Package: planet
Title: Placental DNA methylation analysis tools
Version: 1.20.0
Authors@R: 
    c(person("Victor", "Yuan", email = "victor.2wy@gmail.com",
            role = c("aut", "cre")),
      person(c("Wendy", "P."), "Robinson",
            role = c("aut", "ctb")),
      person("Icíar", "Fernández-Boyano", email = "iciarfernandez@outlook.com",
            role = c("aut", "ctb")))
URL: http://github.com/wvictor14/planet, http://victoryuan.com/planet/
BugReports: http://github.com/wvictor14/planet/issues
Description: This package contains R functions to predict biological variables
    to from placnetal DNA methylation data generated from infinium arrays. This 
    includes inferring ethnicity/ancestry, gestational age, and cell composition
    from placental DNA methylation array (450k/850k) data.
Depends: R (>= 4.3)
Imports: methods, tibble, magrittr, dplyr
Suggests: ExperimentHub, mixOmics, ggplot2, testthat, tidyr, scales,
        minfi, EpiDISH, knitr, rmarkdown
License: GPL-2
Encoding: UTF-8
LazyData: false
RoxygenNote: 7.3.2
VignetteBuilder: knitr
biocViews: Software, DifferentialMethylation, Epigenetics, Microarray,
        MethylationArray, DNAMethylation, CpGIsland
Roxygen: list(markdown = TRUE)
git_url: https://git.bioconductor.org/packages/planet
git_branch: RELEASE_3_23
git_last_commit: 2e51242
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:53:34 UTC; biocbuild
Author: Victor Yuan [aut, cre],
  Wendy P. Robinson [aut, ctb],
  Icíar Fernández-Boyano [aut, ctb]
Maintainer: Victor Yuan <victor.2wy@gmail.com>

# Planet SDK for Python

[![Build Status](https://github.com/planetlabs/planet-client-python/actions/workflows/test.yml/badge.svg?branch=main)](https://github.com/planetlabs/planet-client-python/actions/workflows/test.yml)
[![PyPI Downloads](https://static.pepy.tech/badge/planet)](https://pepy.tech/projects/planet)

The [Planet](https://planet.com) Software Development Kit (SDK) for Python
provides both a Python API and a command-line interface (CLI)
to make use of [the Planet APIs](https://docs.planet.com/develop/apis/).
Everything you need to get started is found in our
[online documentation](https://planet-sdk-for-python-v2.readthedocs.io/en/latest/).

Version 2.0 includes support for the core workflows of the following APIs:

* [Data](https://docs.planet.com/develop/apis/data/) - Search for imagery from Planet's data catalog.
* [Orders](https://docs.planet.com/develop/apis/orders/) - Process and download or deliver imagery.
* [Subscriptions](https://docs.planet.com/develop/apis/subscriptions/) - Set up a search to auto-process and deliver imagery.
* [Features](https://docs.planet.com/develop/apis/features/) - Upload areas of interest to the Planet platform.

After the initial 2.0 release there will be additional work to support the
remaining Planet APIs: [basemaps](https://docs.planet.com/develop/apis/basemaps/),
[tasking](https://docs.planet.com/develop/apis/tasking/) and
[analytics](https://docs.planet.com/develop/apis/analytics/).

## Versions and Stability

The SDK follows [Semantic Versioning](https://semver.org/spec/v2.0.0.html) and therefore only major releases
should break compatibility. Minor versions may include new functionality and
patch versions address bugs or trivial changes (like documentation).

Packages will be released to [PyPi / Planet](https://pypi.org/project/planet/)
with semantic version identifiers that comply with [PEP 440](https://peps.python.org/pep-0440/).

The Semantic Versioning stability scheme only applies to APIs that
are considered part of the public API.  This includes library APIs exported
from the `planet` package and documented in our
[SDK developer documentation](https://planet-sdk-for-python-v2.readthedocs.io/en/latest/),
and the `planet` CLI interface used for scripts.  It does not include
library interfaces below the top level `planet` Python package which are
considered internal and subject to change without notice.

SDK semantic versioning does not apply to the underlying
[Planet APIs](https://docs.planet.com/develop/apis/),
which follow their own independent version and release lifecycles.

If depending upon official packages from PyPI, a developer should feel
comfortable specifying `planet == 2.*` unless depending on a specific feature
introduced at a minor version, in which case `planet == 2.x.*` (where x is the
minor version of the new feature) should suffice.

## Versions and Support Status

Major versions are supported according to their designated support status,
as defined below.  Planet Labs PBC makes no formal commitment
to a specific schedule, but will make every effort to provide reasonable
notice of upcoming changes to the support status of major versions.

* **`development`** - Unstable. Under active development.  Not recommended
  for production use.  API stability not guaranteed.  New features from active
  versions will be ported forward to the extent allowed by the scope of the
  new major version under development.
* **`active`** - Actively maintained and supported. New features and bug fixes.
  Suitable for production use.  API stability guaranteed according to semantic
  versioning, but subject to changes in the underlying Planet APIs.
* **`maintenance`** - Critical bug fixes only.
* **`end-of-life`** - No longer supported.  Software packages will remain available.
* **`removed`** - No longer available.  Removed from distribution channels.

### Python Version Support
`Active` minor versions will support Python versions that have not reached
end-of-life at the time of release.

See https://devguide.python.org/versions/ for current Python versions.

## Branches

The default branch is always `main`, and will correspond to the current stable
major release version. This branch should be considered in-development but
with tests and other build steps kept in a passing state.

See [CONTRIBUTING.md](CONTRIBUTING.md#branches) for more information on branches.

##### Current Mainline Versions and Branches

| Version | Status        | Branch                                                                                 | Documentation                                                                                                | Initial Release | End of Active Development | End of Maintenance | Notes                                                                                           |
|---------|---------------|----------------------------------------------------------------------------------------|--------------------------------------------------------------------------------------------------------------|-----------------|---------------------------|--------------------|-------------------------------------------------------------------------------------------------|
| 3.x     | `development` | [`main-3.0-dev`](https://github.com/planetlabs/planet-client-python/tree/main-3.0-dev) | [Planet Labs Python Client on ReadTheDocs.io](https://planet-sdk-for-python.readthedocs.io/en/latest/)       | TBD             | TBD                       | TBD                | See [3.0.0 Release Milestone](https://github.com/planetlabs/planet-client-python/milestone/31). |
| 2.x     | `active`      | [`main`](https://github.com/planetlabs/planet-client-python/tree/main)                 | [Planet Labs Python Client v2 on ReadTheDocs.io](https://planet-sdk-for-python-v2.readthedocs.io/en/latest/) | April 2023      | TBD                       | TBD                |                                                                                                 |
| 1.x     | `end-of-life` | [`v1`](https://github.com/planetlabs/planet-client-python/tree/v1)                     | [Planet Labs Python Client v1 on Github.io](https://planetlabs.github.io/planet-client-python/)              | April 2017      | April 2023                | TBD                |                                                                                                 |

## Installation and Quick Start

The Planet SDK for Python is [hosted on PyPI](https://pypi.org/project/planet/) and can simply be installed via:

```console
pip install planet
```

To install from source, first clone this repository, then navigate to the root directory (where `setup.py` lives) and run:

```console
pip install .
```

Note that the above commands will install the Planet SDK into the global system Python unless a virtual environment is enabled.  For more information on configuring a virtual environment from system Python, see the official Python [venv](https://docs.python.org/3/library/venv.html) documentation.  For users who are running multiple versions of Python via [pyenv](https://github.com/pyenv/pyenv), see the [pyenv-virtualenv](https://github.com/pyenv/pyenv-virtualenv) extension documentation.

Detailed installation instructions for the Planet SDK can be found in the [Quick Start Guide](https://planet-sdk-for-python-v2.readthedocs.io/en/latest/get-started/quick-start-guide/) of the documentation.

## Contributing and Development

To contribute or develop with this library, see [CONTRIBUTING.md](CONTRIBUTING.md).

## Documentation

Documentation is currently [hosted online](https://planet-sdk-for-python-v2.readthedocs.io/en/latest/)
It should be considered 'in progress', with many updates to come. It can also
be built and hosted locally (see [CONTRIBUTING.md](CONTRIBUTING.md)) or can be
read from source in the [docs](/docs) directory.

## Authentication

Planet's APIs require an account for use. To get started you need to
[Get a Planet Account](https://planet-sdk-for-python-v2.readthedocs.io/en/latest/get-started/get-your-planet-account/).

# data
This directory contains static external resources used by the codebase.

## GeoJSON Schemas

### Files

* `Feature.json`

### Description

These files were generated by cloning and building
[geojson/schema](https://github.com/geojson/schema)
([commit](https://github.com/geojson/schema/commit/ed4bc7b05e6d6751be12b867ca89a30d6aba7650)). These can also be accessed from [geojson.org](https://geojson.org/).

# Examples

This directory contains examples for how to use the Planet SDK for Python.

# Navigation
Each example script is named according to the convention
`<Planet API>_<use_case>.py`.

## Usage

To use these examples, just run the scripts with `python <script_name>`. These
examples hit the Planet services, so be aware that usage and fees may apply.

## Contributing

New examples are great! They just need to meet two requirements.

First off, the name of the new example needs to follow the examples naming
convention.

Second, the new example needs to be tested. All examples in this directory are
tested as a part of an automated test suite. The testing is conducted by
`test_examples.py`.
All scripts should default to downloading into the directory pointed to by the
`TEST_DOWNLOAD_DIR` environment variable, with logic for when that variable
is missing. For example, `DOWNLOAD_DIR = os.getenv('TEST_DOWNLOAD_DIR', '.')`.

Running all example script tests is a long process and also, since each script
communicates with the Planet servers, could affect your usage and incur fees.
To minimize the pain, filter the scripts tested to e.g. the script under
development with:

```console
> nox -s examples -- <script_name>.py
````

For a new script named 
`new_script.py`, this would be `nox -s examples -- new_script.py`

#' @title predictPreeclampsia
#'
#' @description Uses 45 CpGs to predict early preeclampsia (PE delivered before or at 34 weeks of gestation)
#' on placental DNA methylation microarray data.
#'
#' @details Assigns the class labels "early-PE" or "normotensive" to each sample
#' and returns a class probability.
#'
#' It is recommended that users apply beta-mixture quantile normalization (BMIQ) to their data
#' prior to prediction. This was the normalization method used on the training data.
#' 
#' Fernández-Boyano, A.M. Inkster, V. Yuan, W.P. Robinson medRxiv 
#' 2023.05.17.23290125; doi: https://doi.org/10.1101/2023.05.17.23290125 
#'
#' @param betas matrix or array of methylation values on the beta scale (0, 1),
#' where the variables are arranged in rows, and samples in columns.
#' 
#' @param ... feeds into outersect function
#'
#' @return produces a list with components detailed in the `mixOmics::predict` R documentation
#'
#' @examples
#'
#' # To predict early preeclampsia on 450k/850k samples
#'
#' # Load data
#' library(ExperimentHub)
#' eh <- ExperimentHub()
#' query(eh, "eoPredData")
#' 
#' # test object
#' x_test <- eh[['EH8403']]
#' x_test %>% predictPreeclampsia()
#' 
#' @export predictPreeclampsia
#'
predictPreeclampsia <- function(betas, ...){
  
  # read in data to generate model
  eh <- ExperimentHub::ExperimentHub()
  mod <- eh[['EH8090']]
  trainCpGs <- colnames(mod$X)
  
  # check that there are no NAs in the predictors (or if there are, how many)
  peCpGs <- mixOmics::selectVar(mod)$name
  pp <- intersect(rownames(betas), peCpGs)
  
  if(length(pp) < length(peCpGs)){
    stop(paste(
      "Only", length(pp), "out of 45 predictive CpGs present. All 45 predictive CpGs are needed to run the function."
    ))
  } else {
    message(paste(length(pp), "of 45 predictive CpGs present."))
    message("BMIQ normalization is recommended for best results. If choosing other method, it is recommended to compare results to predictions on BMIQ normalized data.")
  }
  
  # set up data for prediction
  
  # if input data is missing any of the cpgs present in the training data, this function
  # adds the ones that are missing as NAs
  # necessary for `mixOmics::predict` to work
  
  outersect <- function(x, y) {
    sort(c(x[!x%in%y],
           y[!y%in%x]))
  }
  
  if(inherits(betas, 'matrix')){
    
  } else if (inherits(betas, 'array')) {
    
  } else {
    # throw an error
    print(paste0("Input data must be a matrix or an array"))
  }
  
  betasSubset <- betas[rownames(betas) %in% trainCpGs,]
  
  # order
  betasSubset <- betasSubset[drop=FALSE,trainCpGs, ]
  
  stopifnot(all(rownames(betasSubset) == trainCpGs))
  
  # predict
  out <- predict.mixo_spls(mod, t(betasSubset))
  
  # get class probabilities
  CP <- out$predict[,,1]
  CP <- t(apply(as.matrix(CP), 1, function(data) exp(data)/sum(exp(data))))
  CP <- as.data.frame(CP) %>% tibble::rownames_to_column("Sample_ID")
  CP$PE_Status <- CP$comp1
  CP <- CP %>%
    dplyr::mutate(PE_Status = dplyr::case_when(EOPE > 0.55 ~ "EOPE",
                                               EOPE < 0.55 ~ "Normotensive"))
  return(tibble::as_tibble(CP))
}

#' @title Predicts ethnicity using placental DNA methylation microarray data
#' 
#' @description Uses 1860 CpGs to predict self-reported ethnicity on placental
#' microarray data.
#'
#' @details Predicts self-reported ethnicity from 3 classes: Africans, Asians,
#' and Caucasians, using placental DNA methylation data measured on the Infinium
#' 450k/EPIC methylation array. Will return membership probabilities that often
#' reflect genetic ancestry composition.
#'
#' The input data should contain all 1860 predictors (cpgs) of the final GLMNET
#' model.
#'
#' It's recommended to use the same normalization methods used on the training
#' data: NOOB and BMIQ.
#'
#' @param betas n x m dataframe of methylation values on the beta scale (0, 1),
#' where the variables are arranged in rows, and samples in columns. Should
#' contain all 1860 predictors and be normalized with NOOB and BMIQ.
#' @param threshold A probability threshold ranging from (0, 1) to call samples
#' 'ambiguous'. Defaults to 0.75.
#' @param force run even if missing predictors. Default is `FALSE`.
#'
#' @return a [tibble][tibble::tibble-package]
#' @examples
#' ## To predict ethnicity on 450k/850k samples
#'
#' # Load placenta DNAm data
#' data(plBetas)
#' predictEthnicity(plBetas)
#' 
#' @export predictEthnicity 
predictEthnicity <- function(betas, threshold = 0.75, force = FALSE) {
  data(ethnicityCpGs, envir=environment())
  pf <- intersect(ethnicityCpGs, rownames(betas)) 
  
  if (!force) {
    
    if (any(is.na(betas[pf,]))) {
      stop(
        paste(
          "NAs present in predictor data."
        )
      )
    } 
    
    if (!all(ethnicityCpGs %in% rownames(betas))) {
      stop(paste(
        "Missing", length(setdiff(ethnicityCpGs, rownames(betas))), 
        "out of", length(ethnicityCpGs), "predictors."
      ))
    }
  }
  message(paste(length(pf), "of 1860 predictors present."))
  
  # subset down to 1860 final features
  betas <- t(betas[pf, ])
  
  # This code is modified from glmnet v3.0.2, GPL-2 license
  # modifications include reducing the number of features from the original 
  # training set, to only where coefficients != 0 (1860 features)
  # These modifications were made to significantly reduce memory size of the
  # internal object `nbeta` 
  # see https://glmnet.stanford.edu/ for original glmnet package
  
  npred <- nrow(betas) # number of samples
  dn <- list(names(nbeta), "1", dimnames(betas)[[1]])
  dp <- array(0, c(nclass, nlambda, npred), dimnames = dn) # set up results
  
  # cross product with coeeficients
  for (i in seq(nclass)) {
    fitk <- methods::cbind2(1, betas) %*%
      matrix(nbeta[[i]][c("(Intercept)", colnames(betas)), ])
    dp[i, , ] <- dp[i, , ] + t(as.matrix(fitk))
  }
  
  # probabilities
  pp <- exp(dp)
  psum <- apply(pp, c(2, 3), sum)
  probs <- data.frame(aperm(
    pp / rep(psum, rep(nclass, nlambda * npred)),
    c(3, 1, 2)
  ))
  colnames(probs) <- paste0("Prob_", dn[[1]])
  
  # classification
  link <- aperm(dp, c(3, 1, 2))
  dpp <- aperm(dp, c(3, 1, 2))
  preds <- data.frame(apply(dpp, 3, glmnet_softmax))
  colnames(preds) <- "Predicted_ethnicity_nothresh"
  
  # combine and apply thresholding
  p <- cbind(preds, probs)
  p$Highest_Prob <- apply(p[, 2:4], 1, max)
  p$Predicted_ethnicity <- ifelse(
    p$Highest_Prob < threshold, "Ambiguous",
    as.character(p$Predicted_ethnicity_nothresh)
  )
  p$Sample_ID <- rownames(p)
  p <- p[, c(7, 1, 6, 2:5)]
  
  return(tibble::as_tibble(p))
}

# This code is copied directly from glmnet v3.0.2, GPL-2 license
# see https://glmnet.stanford.edu/ for original glmnet package
# The authors and copy right holders include:
# Jerome Friedman [aut], Trevor Hastie [aut, cre], Rob Tibshirani [aut], 
# Balasubramanian Narasimhan [aut], Kenneth Tay [aut], Noah Simon [aut], 
# Junyang Qian [ctb]
glmnet_softmax <- function(x, ignore_labels = FALSE) {
  d <- dim(x)
  dd <- dimnames(x)[[2]]
  if (is.null(dd) || !length(dd)) {
    ignore_labels <- TRUE
  }
  
  nas <- apply(is.na(x), 1, any)
  if (any(nas)) {
    pclass <- rep(NA, d[1])
    if (sum(nas) < d[1]) {
      pclass2 <- glmnet_softmax(x[!nas, ], ignore_labels)
      pclass[!nas] <- pclass2
      if (is.factor(pclass2)) {
        pclass <- factor(
          pclass,
          levels = seq(d[2]),
          labels = levels(pclass2)
        )
      }
    }
  } else {
    maxdist <- x[, 1]
    pclass <- rep(1, d[1])
    for (i in seq(2, d[2])) {
      l <- x[, i] > maxdist
      pclass[l] <- i
      maxdist[l] <- x[l, i]
    }
    dd <- dimnames(x)[[2]]
    if (!ignore_labels) {
      pclass <- factor(pclass, levels = seq(d[2]), labels = dd)
    }
  }
  pclass
}

#' predict mixxo from
#' 
#' copied from mixOmicsTeam/mixOmics/refs/heads/master/R/predict.R
#' on 2025 Jan 30. Some components omitted that are not used in planet. 
#' 
#' @param object object of class inheriting from
#' \code{"(mint).(block).(s)pls(da)"}.
#' @param newdata data matrix in which to look for for explanatory variables to
#' be used for prediction. Please note that this method does not perform
#' multilevel decomposition or log ratio transformations, which need to be
#' processed beforehand.
#' @param study.test For MINT objects, grouping factor indicating which samples
#' of \code{newdata} are from the same study. Overlap with \code{object$study}
#' are allowed.
#' @param dist distance to be applied for discriminant methods to predict the
#' class of new data, should be a subset of \code{"centroids.dist"},
#' \code{"mahalanobis.dist"} or \code{"max.dist"} (see Details). Defaults to
#' \code{"all"}.
#' @param multilevel Design matrix for multilevel analysis (for repeated
#' measurements). A numeric matrix or data frame. For a one level factor
#' decomposition, the input is a vector indicating the repeated measures on
#' each individual, i.e. the individuals ID. For a two level decomposition with
#' splsda models, the two factors are included in Y. Finally for a two level
#' decomposition with spls models, 2nd AND 3rd columns in design indicate those
#' factors (see example in \code{?splsda} and \code{?spls}).
#' @param ... not used currently.
#' @return \code{predict} produces a list with the following components:
#' \item{predict}{predicted response values. The dimensions correspond to the
#' observations, the response variables and the model dimension, respectively.
#' For a supervised model, it corresponds to the predicted dummy variables.}
#' \item{variates}{matrix of predicted variates.} \item{B.hat}{matrix of
#' regression coefficients (without the intercept).}
#' 
#' \item{AveragedPredict}{if more than one block, returns the average predicted
#' values over the blocks (using the \code{predict} output)}
#' \item{WeightedPredict}{if more than one block, returns the weighted average
#' of the predicted values over the blocks (using the \code{predict} and
#' \code{weights} outputs)}
#' 
#' \item{class}{predicted class of \code{newdata} for each
#' \eqn{1,...,}\code{ncomp} components.}
#' 
#' \item{MajorityVote}{if more than one block, returns the majority class over
#' the blocks. NA for a sample means that there is no consensus on the
#' predicted class for this particular sample over the blocks.}
#' \item{WeightedVote}{if more than one block, returns the weighted majority
#' class over the blocks. NA for a sample means that there is no consensus on
#' the predicted class for this particular sample over the blocks.}
#' \item{weights}{Returns the weights of each block used for the weighted
#' predictions, for each nrepeat and each fold}
#' 
#' \item{centroids}{matrix of coordinates for centroids.} \item{dist}{type of
#' distance requested.} \item{vote}{majority vote result for multi block
#' analysis (see details above).}
#' @author Florian Rohart, Sébastien Déjean, Ignacio González, Kim-Anh Lê Cao,
#' Al J Abadi
#' @seealso http://www.mixOmics.org for more details.
#' @references
#' 
#' Rohart F, Gautier B, Singh A, Lê Cao K-A. mixOmics: an R package for 'omics
#' feature selection and multiple data integration. PLoS Comput Biol 13(11):
#' e1005752
#' 
#' Tenenhaus, M. (1998). \emph{La regression PLS: theorie et pratique}. Paris:
#' Editions Technic.
#' @keywords regression multivariate
#' @name predict
#' @rdname predict
#' @method predict mixo_pls
#' @importFrom methods hasArg is
#' @importFrom stats setNames
#' @examples
#' # example code
#' 
predict.mixo_pls <-
  function(object,
           newdata,
           study.test,
           dist = c("all", "max.dist", "centroids.dist", "mahalanobis.dist"),
           multilevel = NULL,
           ...
  )
  {
    
    time=FALSE
    
    # pass R check
    newdata.scale = misdata.all = is.na.X = is.na.newdata = noAveragePredict = NULL
    
    # input parameter: noAveragePredict=> no averagePredict calculation, used in tune.block.splsda
    
    if(inherits(object, c("rgcca","sparse.rgcca")))
      stop("no prediction for RGCCA methods")
    
    #check on dist
    if (!any(dist %in% c("all", "max.dist", "centroids.dist", "mahalanobis.dist")) & is(object, "DA"))
      stop("ERROR : choose one of the four following modes: 'all', 'max.dist', 'centroids.dist' or 'mahalanobis.dist'")
    #end general checks
    
    ncomp = object$ncomp
    
    if(is(object, "DA")) # a DA analysis (mint).(block).(s)plsda
    {
      #if DA analysis, the unmap Y is in ind.mat
      Y.factor=object$Y
      Y=object$ind.mat
    }else{
      #if not DA, Y is in object$Y
      Y=object$Y
      if(is.null(Y)) # block analysis
      {
        Y=object$X[[object$indY]]
      }
    }
    q=ncol(Y)
    
    if(time) time1 = proc.time()
    #print(names(list(...)))
    
    if(hasArg(newdata.scale)) # if an input `newdata.scale' is given, we use that one and we don't scale the data and don't do the logratio or multilevel
    {
      newdata = list(...)$newdata.scale
      object$logratio = NULL
      multilevel = NULL
    }
    
    mint.object = c("mint.pls", "mint.spls", "mint.plsda", "mint.splsda")
    block.object = c("block.pls", "block.spls", "block.plsda", "block.splsda")
    ### if the object is a block, the input newdata is different, we check newdata, make sure it's a list and check newdata/X
    if(!inherits(object, block.object)) # not a block (pls/spls/plsda/splsda/mint...)
    {
      p=ncol(object$X)
      if(is.list(object$X))
        stop("Something is wrong, object$X should be a matrix and it appears to be a list") #this should never happen/intern check
      
      if(is.list(newdata) & !is.data.frame(newdata))
        stop("'newdata' must be a numeric matrix")
      
      # deal with near.zero.var in object, to remove the same variable in newdata as in object$X (already removed in object$X)
      if(length(object$nzv$Position) > 0)
        newdata = newdata[, -object$nzv$Position,drop=FALSE]
      
      if(all.equal(colnames(newdata),colnames(object$X))!=TRUE)
        stop("'newdata' must include all the variables of 'object$X'")
      
      #not a block, the input newdata should be a matrix
      if (length(dim(newdata)) == 2) {
        if (ncol(newdata) != p)
          stop("'newdata' must be a numeric matrix with ncol = ", p,
               " or a vector of length = ", p, ".")
      }
      
      if (length(dim(newdata)) == 0) {
        if (length(newdata) != p)
          stop("'newdata' must be a numeric matrix with ncol = ", p,
               " or a vector of length = ", p, ".")
        dim(newdata) = c(1, p)
      }
      
      #check col/rownames of newdata
      check=Check.entry.single(newdata, ncomp,q=1)
      newdata=check$X
      
      if(length(rownames(newdata))==0) rownames(newdata)=1:nrow(newdata)
      if(max(table(rownames(newdata)))>1) stop('samples should have a unique identifier/rowname')
      
      # we transform everything in lists
      X=list(X=object$X)
      object$X=X
      newdata=list(newdata=newdata)
      
      object$indY=2
      ind.match = 1
      
    }else{
      
      # a block, newdata should be a list, each blocks should have the same number of samples
      if(!is.list(newdata))
        stop("'newdata' should be a list")
      
      if(!is.null(object$indY) && !is(object, "DA")) #if DA, object$X is already without Y
      {
        X = object$X[-object$indY]
      }else{
        X=object$X
      }
      object$X=X
      
      p = lapply(X, ncol)
      
      #matching newdata and X
      
      # error if no names on keepX or not matching the names in X
      if(length(unique(names(newdata)))!=length(newdata) | sum(is.na(match(names(newdata),names(X)))) > 0)
        stop("Each entry of 'newdata' must have a unique name corresponding to a block of 'X'")
      
      # error if not same number of samples in each block of newdata
      if (length(unique(sapply(newdata,nrow))) != 1)
        stop("All entries of 'newdata' must have the same number of rows")
      
      # I want to match keepX to X by names
      ind.match = match(names(X), names(newdata))
      if(any(is.na(ind.match)))
        warning("Some blocks are missing in 'newdata'; the prediction is based on the following blocks only: ", paste(names(X)[!is.na(ind.match)],collapse=", "))
      
      #replace missing blocks by 0
      newdataA = list()
      for (q in 1:length(X))
      {
        
        if (!is.na(ind.match[q])) # means there is a newdata with the same name as X[q] #(q <= length(newdata))
        {
          newdataA[[q]] = newdata[[ind.match[q]]]
        }else{
          newdataA[[q]] = matrix(0,nrow = unique(sapply(newdata,nrow)), ncol = ncol(X[[q]]), dimnames = list(rownames(newdata[[1]]), colnames(X[[q]]))) # if missing, replaced by a 0 matrix of correct size
        }
      }
      names(newdataA) = names(X)
      newdata = newdataA
      
      # deal with near.zero.var in object, to remove the same variable in newdata as in object$X (already removed in object$X)
      if(!is.null(object$nzv))
      {
        # for each of the input blocks, checks to see if the nzv features have already been removed
        # if not, then these features are removed here
        for (x in 1:length(newdata)) {
          if (nrow(object$nzv[[x]]$Metrics) == 0) { next }
          if (all(!(rownames(object$nzv[[x]]$Metrics) %in% colnames(newdata[[x]])))) { next }
          
          newdata[[x]] <- newdata[[x]][, -object$nzv[[x]]$Position,drop=FALSE]
        }
      }
      if(length(newdata)!=length(object$X)) stop("'newdata' must have as many blocks as 'object$X'")
      
      names(newdata)=names(X)
      
      if (any(lapply(newdata, function(x){length(dim(x))}) != 2)) {
        if (any(unlist(lapply(newdata, ncol)) != unlist(p)))
          stop("'newdata' must be a list with ", length(p), " numeric matrix and ncol respectively equal to ", paste(p, collapse = ", "), ".")
      }
      
      if (any(lapply(newdata, function(x){length(dim(x))}) == 0)) {
        if (any(unlist(lapply(newdata, ncol)) != unlist(p)))
          stop("'newdata' must be a list with ", length(p), " numeric matrix and ncol respectively equal to ", paste(p, collapse = ", "), ".")
        dim(newdata) = c(1, p) #don't understand that, Benoit?
      }
      
      #check dimnames and ncomp per block of A
      for(q in 1:length(newdata))
      {
        check=Check.entry.single(newdata[[q]], ncomp[q],q=q)
        newdata[[q]]=check$X
      }
      names(newdata)=names(X)
      
      #check that newdata and X have the same variables and that they are in the same order
      for (i in 1:length(newdata)) {
        X.names <- colnames(X[[i]])
        newdata.names <- colnames(newdata[[i]])
        
        if (any(X.names != newdata.names)) { # if there is any difference between colnames
          if (length(setdiff(X.names, newdata.names)) > 0) { # if there is presence of novel feature/absence of existing feature
            stop(paste("The set of features in 'object$X$", 
                       names(X)[i], "' is different to 'newdata$", 
                       names(newdata)[i], "'. Please ensure they have the same features.", sep = ""))
          }
          else if (all(sort(X.names) == sort(newdata.names))) { # if it is only a difference in order
            stop(paste("The order of features in 'object$X$", 
                       names(X)[i], "' is different to 'newdata$", 
                       names(newdata)[i], "'. Please ensure that you adjust these to the same order", sep = ""))
          }
        }
      }
      
      #reorder variables in the newdata as in X if needed
      if (all.equal(lapply(newdata, colnames), lapply(X, colnames)) != TRUE) {
        newdata <- setNames(lapply(seq_along(X), function(i) {newdata[[i]][, colnames(X[[i]])]}), nm = names(X))
      }
      #need to reorder variates and loadings to put 'Y' in last
      if(!is.null(object$indY))
      {
        indY=object$indY
        object$variates=c(object$variates[-indY],object$variates[indY])
        object$loadings=c(object$loadings[-indY],object$loadings[indY])
      }
      
      
    }
    
    # logratio and multilevel transform if necessary
    if (!is.null(object$logratio))
      newdata = lapply(newdata, logratio.transfo, logratio = object$logratio)
    
    if(!is.null(multilevel))
      newdata = lapply(newdata, withinVariation, design = data.frame(multilevel))
    
    p = lapply(X, ncol)
    q = ncol(Y)
    J = length(X) #at this stage we have a list of blocks
    variatesX = object$variates[-(J + 1)];
    loadingsX = object$loadings[-(J + 1)]
    
    scale = object$scale # X and Y are both mean centered by groups and if scale=TRUE they are scaled by groups
    
    
    ### if the object is not a mint analysis, the input study.test is missing and we can go faster to scale the data
    
    # we only scale the data if the input `newdata.scale' is missing. Only use in tune functions where we do not need to scale for every prediction as we predict on the same newdata for a grid of keepX
    if(!hasArg(newdata.scale))
    {
      if(!inherits(object, mint.object))#| nlevels(factor(object$study))<=1) #not a mint object or just one level in the study
      {   # not a mint (pls/spls/plsda/splsda/block...)
        
        # scale newdata if just one study
        if (!is.null(attr(X[[1]], "scaled:center")))
          newdata[which(!is.na(ind.match))] = lapply(which(!is.na(ind.match)), function(x){sweep(newdata[[x]], 2, STATS = attr(X[[x]], "scaled:center"))})
        if (scale)
          newdata[which(!is.na(ind.match))] = lapply(which(!is.na(ind.match)), function(x){sweep(newdata[[x]], 2, FUN = "/", STATS = attr(X[[x]], "scaled:scale"))})
        if (any(unlist(lapply(newdata[which(!is.na(ind.match))], function(x){any(is.infinite(x))})))) {
          newdata[which(!is.na(ind.match))] <- lapply(which(!is.na(ind.match)), function(x){df <- newdata[[x]]; df[which(is.infinite(df))] <- NaN; return(df)})
        }
        
        means.Y = matrix(attr(Y, "scaled:center"),nrow=nrow(newdata[[1]]),ncol=q,byrow=TRUE);
        if (scale)
        {sigma.Y = matrix(attr(Y, "scaled:scale"),nrow=nrow(newdata[[1]]),ncol=q,byrow=TRUE)}else{sigma.Y=matrix(1,nrow=nrow(newdata[[1]]),ncol=q)}
        concat.newdata=newdata
        names(concat.newdata)=names(X)
        
      }else{
        # a mint analysis
        
        #check study.test
        if(missing(study.test))
        {
          if(nlevels(object$study)==1)
          {study.test=factor(rep(1,nrow(newdata[[1]])))}else{
            stop("'study.test' is missing")}
        }else{
          study.test=as.factor(study.test)
        }
        if (any(unlist(lapply(newdata, nrow)) != length(study.test)))
          stop(paste0("'study' must be a factor of length ",nrow(newdata[[1]]),"."))
        
        #scale newdata if more than one study. If some levels of study.test are included in study.learn, the means/sigmas of study.learn are used to scale
        M=nlevels(study.test)
        study.learn=factor(object$study)
        names.study.learn=levels(study.learn);names.study.test=levels(study.test)
        match.study=match(names.study.test,names.study.learn)
        match.study.indice=which(!is.na(match.study))
        
        newdata.list.study = lapply(newdata,study_split,study.test) #a list of lists. [[j]][[m]]: j is for the blocks, m is for the levels(study)
        
        # each study is normalized, depending on how the normalization was performed on the learning set (center/scale)
        newdata.list.study.scale.temp =NULL#vector("list",length=J) #list(list())
        concat.newdata  = vector("list",length=J)
        for(j in 1:J) # loop on the blocks
        {
          for (m in 1:M) #loop on the groups of study.test
          {
            # case 1: sample test is part of the learning data set
            if(m%in%match.study.indice) #if some study of study.test were already in the learning set
            {
              
              if(scale==TRUE)
              {
                if(nlevels(object$study)>1)
                {
                  newdata.list.study.scale.temp=scale(newdata.list.study[[j]][[m]], center = attr(X[[j]],paste0("means:", levels(study.test)[m])), scale = attr(X[[j]],paste0("sigma:", levels(study.test)[m])))
                }else{#if just one level in object$study, the normalisation attributes are not named the same
                  newdata.list.study.scale.temp=scale(newdata.list.study[[j]][[m]], center = attr(X[[j]],"scaled:center"), scale = attr(X[[j]],"scaled:scale"))
                }
              }
              
              if(scale==FALSE)
              {
                if(nlevels(object$study)>1)
                {
                  newdata.list.study.scale.temp=scale(newdata.list.study[[j]][[m]], center = attr(X[[j]],paste0("means:", levels(study.test)[m])),scale=FALSE)
                }else{#if just one level in object$study, the normalisation attributes are not named the same
                  newdata.list.study.scale.temp=scale(newdata.list.study[[j]][[m]], center = attr(X[[j]],"scaled:center"),scale=FALSE)
                }
                
                
              }
              
            }else{
              # case 2: sample test is a new study # a new study which was not in the learning set
              
              ## if there is one sample from a new study to be scaled throw a condition and do not scale
              if (scale == TRUE & dim(newdata.list.study[[j]][[m]])[1] == 1 ) {
                warning("Train data are scaled but the test data include a single sample from a new study (which cannot be scaled). Mkaing prediction without scaling this test sample and thus prediction for this sample should be given with care. Consider scale=FALSE for model, or using more samples for prediction, or using a sample from model studies.\n")
                newdata.list.study.scale.temp = newdata.list.study[[j]][[m]]
              } else {
                newdata.list.study.scale.temp=scale(newdata.list.study[[j]][[m]],center=TRUE,scale=scale)
              }
            }
            #concatenation of the scaled data
            concat.newdata[[j]] = rbind(concat.newdata[[j]], unlist(newdata.list.study.scale.temp))#[[j]][[m]]))
          }
        }
        
        # we now need to reorganise concat.newdata as newdata. Indeed, the concatenation was done without taking care of the order of the samples in newdata
        for(j in 1:J) # loop on the blocks
        {
          indice.match=match(rownames(newdata[[j]]),rownames(concat.newdata[[j]]))
          #match indice
          concat.newdata[[j]]=concat.newdata[[j]][indice.match,, drop=FALSE]
          concat.newdata[[j]][which(is.na(concat.newdata[[j]]))]=0 # taking care of the NA due to normalisation: put to 0 so they don't influence the product below (in Y.hat), reviens au meme que de supprimer les colonnes sans variances au depart.
          
        }
        
        names(concat.newdata)=names(X)
        
        means.Y=matrix(0,nrow=nrow(concat.newdata[[1]]),ncol=q)
        sigma.Y=matrix(1,nrow=nrow(concat.newdata[[1]]),ncol=q)
        
        #loop on the blocks to define means.Y and sigma.Y for mint analysis
        for(m in 1:M)
        {
          if(m%in%match.study.indice) #if some study of study.test were already in the learning set
          {
            if(nlevels(object$study)>1)
            {
              means.Y[which(study.test%in%levels(study.learn)[match.study[m]]),]=matrix(attr(Y,paste0("means:", levels(study.test)[m])),nrow=length(which(study.test%in%levels(study.learn)[match.study[m]])),ncol=q,byrow=TRUE)
            }else{#if just one level in object$study, the normalisation attributes are not named the same
              means.Y[which(study.test%in%levels(study.learn)[match.study[m]]),]=matrix(attr(Y,"scaled:center"),nrow=length(which(study.test%in%levels(study.learn)[match.study[m]])),ncol=q,byrow=TRUE)
            }
            
            
            if(scale==TRUE)
            {
              # I want to build a vector with sigma.Y for each group
              if(nlevels(object$study)>1)
              {
                sigma.Y[which(study.test%in%levels(study.learn)[match.study[m]]),]=matrix(attr(Y,paste0("sigma:", levels(study.test)[m])),nrow=length(which(study.test%in%levels(study.learn)[match.study[m]])),ncol=q,byrow=TRUE)
              }else{#if just one level in object$study, the normalisation attributes are not named the same
                sigma.Y[which(study.test%in%levels(study.learn)[match.study[m]]),]=matrix(attr(Y,"scaled:scale"),nrow=length(which(study.test%in%levels(study.learn)[match.study[m]])),ncol=q,byrow=TRUE)
              }
              
              
            }
          }
        }
        
      }
      ### end if object is a mint analysis
    } else {
      means.Y = matrix(attr(Y, "scaled:center"),nrow=nrow(newdata[[1]]),ncol=q,byrow=TRUE);
      if (scale)
      {sigma.Y = matrix(attr(Y, "scaled:scale"),nrow=nrow(newdata[[1]]),ncol=q,byrow=TRUE)}else{sigma.Y=matrix(1,nrow=nrow(newdata[[1]]),ncol=q)}
      concat.newdata=newdata
      names(concat.newdata)=names(X)
    }
    if(time) time2 = proc.time()
    if(time) print("scaling")
    if(time) print(time2-time1)
    
    
    ### at this stage we have
    # X         # list of blocks
    # Y         # observation
    # newdata   #list of blocks for the prediction, same length as A, scaled
    
    ###  replace NA by 0 in the training data
    if( (hasArg(misdata.all) & hasArg(is.na.X)) && any(list(...)$misdata.all)) # ind.na.X: all blocks except Y
    {    # if misdata.all and ind.na.X are provided, we don't calculate the is.na(X) as it takes time. Used in tune functions.
      for(j in c(1:J)[list(...)$misdata.all])
        X[[j]][list(...)$is.na.X[[j]]]=0 # faster than using replace
    } else {
      # replace NA by 0
      X = lapply(X,function(x)
      {
        if (anyNA(x)){
          ind = is.na(x)
          x[ind] = 0
        }
        x
      })
    }
    
    ###  replace NA by 0 in the test data
    
    if( (hasArg(misdata.all) & hasArg(is.na.newdata)) && any(list(...)$misdata.all)) # ind.na.newdata: all blocks of newdata
    {
      # if misdata.all and ind.na.X are provided, we don't calculate the is.na(X) as it takes time. Used in tune functions.
      concat.newdata = lapply(1:J, function(q){replace(concat.newdata[[q]], list(...)$is.na.newdata[[q]], 0)})
      
    }
    
    if (any(sapply(concat.newdata, anyNA)))
    {
      concat.newdata = lapply(concat.newdata,function(x)
      {
        if (anyNA(x)){
          ind = is.na(x)
          x[ind] = 0
        }
        x
      })
    }
    
    
    # replace NA by 0 in Y
    Y[is.na(Y)] = 0
    
    if(time) time3 = proc.time()
    if(time) print("NA")
    if(time) print(time3-time2)
    
    # -----------------------
    #       prediction
    # -----------------------
    
    B.hat = t.pred = Y.hat = list() #= betay
    for (i in 1 : J)
    {
      Pmat = Cmat = Wmat = NULL
      
      ### Start estimation using formula Y = XW(P'W)C (+ Yr, residuals on Y) See page 136 La regression PLS Theorie et pratique Tenenhaus
      # Estimation matrix W, P and C
      Pmat = crossprod(X[[i]], variatesX[[i]])
      Cmat = crossprod(Y, variatesX[[i]])
      Wmat = loadingsX[[i]]
      
      # Prediction Y.hat, B.hat and t.pred
      Ypred = lapply(1 : ncomp[i], function(x){concat.newdata[[i]] %*% Wmat[, 1:x] %*% solve(t(Pmat[, 1:x]) %*% Wmat[, 1:x]) %*% t(Cmat)[1:x, ]})
      Ypred = sapply(Ypred, function(x){x*sigma.Y + means.Y}, simplify = "array")
      
      Y.hat[[i]] = array(Ypred, c(nrow(newdata[[i]]), ncol(Y), ncomp[i])) # in case one observation and only one Y, we need array() to keep it an array with a third dimension being ncomp
      
      t.pred[[i]] = concat.newdata[[i]] %*% Wmat %*% solve(t(Pmat) %*% Wmat)
      t.pred[[i]] = matrix(data = sapply(1:ncol(t.pred[[i]]),
                                         function(x) {t.pred[[i]][, x] * apply(variatesX[[i]], 2,
                                                                               function(y){(norm(y, type = "2"))^2})[x]}), nrow = nrow(concat.newdata[[i]]), ncol = ncol(t.pred[[i]]))
      
      B.hat[[i]] = sapply(1 : ncomp[i], function(x){Wmat[, 1:x] %*% solve(t(Pmat[, 1:x]) %*% Wmat[, 1:x]) %*% t(Cmat)[1:x, ]}, simplify = "array")
      ### End estimation using formula Y = XW(P'W)C (+ Yr, residuals on Y) See page 136 La regression PLS Theorie et pratique Tenenhaus
      
      rownames(t.pred[[i]]) = rownames(newdata[[i]])
      colnames(t.pred[[i]]) = paste0("dim", c(1:ncomp[i]))
      rownames(Y.hat[[i]]) = rownames(newdata[[i]])
      colnames(Y.hat[[i]]) = colnames(Y)
      dimnames(Y.hat[[i]])[[3]]=paste0("dim", c(1:ncomp[i]))
      rownames(B.hat[[i]]) = colnames(newdata[[i]])
      colnames(B.hat[[i]]) = colnames(Y)
      dimnames(B.hat[[i]])[[3]]=paste0("dim", c(1:ncomp[i]))
      
    }
    
    if(time) time4 = proc.time()
    if(time) print("Prediction")
    if(time) print(time4-time3)
    
    #-- valeurs sortantes --#
    names(Y.hat)=names(t.pred)=names(B.hat)=names(object$X)
    
    if(time) time4 = proc.time()
    
    # basic prediction results
    if(inherits(object, block.object) & length(object$X)>1 )
    {
      out=list(predict=Y.hat[which(!is.na(ind.match))],variates=t.pred[which(!is.na(ind.match))],B.hat=B.hat[which(!is.na(ind.match))])
      
      # average prediction over the blocks
      temp.all =list()
      for(comp in 1:min(ncomp[-object$indY])) #note: all ncomp are the same in v6 as the input parameter is a single value
      {
        temp = array(0, c(nrow(Y.hat[[1]]), ncol(Y.hat[[1]]), J), dimnames = list(rownames(newdata[[1]]), colnames(Y),names(object$X)))
        for(i in 1 : J)
          temp[, , i] = Y.hat[[i]][, , comp]
        
        temp.all[[comp]] = temp
      }
      names(temp.all) = paste0("dim", c(1:min(ncomp[-object$indY])))
      
      if(!hasArg(noAveragePredict))
      {
        out$AveragedPredict = array(unlist(lapply(temp.all, function(x){
          apply(x, c(1,2), mean)
          
        })), dim(Y.hat[[1]]), dimnames = list(rownames(newdata[[1]]), colnames(Y), paste0("dim", c(1:min(ncomp[-object$indY])))))
        
        out$WeightedPredict = array(unlist(lapply(temp.all, function(x){
          apply(x, c(1,2), function(z){
            temp = aggregate(rowMeans(object$weights),list(z),sum)
            ind = which(temp[,2]== max (temp[,2]))# if two max, then NA
            if(length(ind) == 1)
            {
              res = temp[ind, 1]
            } else {
              res = NA
            }
            res
          })})), dim(Y.hat[[1]]), dimnames = list(rownames(newdata[[1]]), colnames(Y), paste0("dim", c(1:min(ncomp[-object$indY])))))
      }
      
      
      #out$newdata=concat.newdata
    }else if(inherits(object, block.object)){ # a block but can have only one block (so e.g. a pls done with a block.pls)
      out=list(predict=Y.hat,variates=t.pred,B.hat=B.hat)
      
    } else {# not a block (pls/spls/plsda/splsda/mint...)
      out=list(predict=Y.hat[[1]],variates=t.pred[[1]],B.hat=B.hat[[1]])
    }
    
    if(time) time5 = proc.time()
    if(time) print("Y.hat")
    if(time) print(time5-time4)
    
    
    # get the classification for each new sample if the object is a DA
    if(is(object, "DA")) # a DA analysis (mint).(block).(s)plsda
    {
      
      if(inherits(object, block.object) & length(object$X)>1 )
      {
        if(!hasArg(noAveragePredict))
        {
          # predict class of AveragePredict, only with max.dist
          out$AveragedPredict.class$max.dist = matrix(sapply(1:ncomp[1], ### List level
                                                             function(y){apply(out$AveragedPredict[, , y, drop = FALSE], 1,  ### component level
                                                                               function(z){
                                                                                 paste(levels(Y.factor)[which(z == max(z))], collapse = "/")
                                                                               }) ### matrix level
                                                             }), nrow = nrow(newdata[[1]]), ncol = ncomp[1])
          
          
          # predict class of WeightedPredict, only with max.dist
          out$WeightedPredict.class$max.dist = matrix(sapply(1:ncomp[1], ### List level
                                                             function(y){apply(out$WeightedPredict[, , y, drop = FALSE], 1,  ### component level
                                                                               function(z){
                                                                                 paste(levels(Y.factor)[which(z == max(z))], collapse = "/")
                                                                               }) ### matrix level
                                                             }), nrow = nrow(newdata[[1]]), ncol = ncomp[1])
          
          rownames(out$AveragedPredict.class$max.dist) = rownames(out$WeightedPredict.class$max.dist) = rownames(newdata[[1]])
          colnames(out$AveragedPredict.class$max.dist) = colnames(out$WeightedPredict.class$max.dist) = paste0("dim", c(1:min(ncomp[-object$indY])))
        }
      }
      
      
      # creating temporary 'blocks' outputs to pass into the internal_predict.DA function
      out.temp=list(predict=Y.hat[which(!is.na(ind.match))],variates=t.pred[which(!is.na(ind.match))],B.hat=B.hat[which(!is.na(ind.match))])
      out.temp$newdata=concat.newdata[which(!is.na(ind.match))]
      
      # getting classification for each new sample
      object.temp = object
      object.temp$X = object.temp$X[which(!is.na(ind.match))]
      object.temp$variates = object.temp$variates[c(which(!is.na(ind.match)),J+1)] #J+1 is Y
      if (!is.null(object$weights))
        weights <- rowMeans(object$weights)[which(!is.na(ind.match))]
      else
        weights <- NULL
      
      classif.DA=internal_predict.DA(object=object.temp, q=q, out=out.temp, dist=dist, weights = weights)
      out=c(out,classif.DA)
      
    }
    
    if(time) time6 = proc.time()
    if(time) print("DA")
    if(time) print(time6-time5)
    
    out$call = match.call()
    class(out) = paste("predict")
    
    out
    
  }

#' @rdname predict
#' @method predict mixo_spls
predict.mixo_spls <- predict.mixo_pls


# from https://github.com/mixOmicsTeam/mixOmics/blob/master/R/check_entry.R#L111
################################################################################
# --------------------------------------
# Check.entry.single: check input parameter for a single matrix that comes
#   from a list of matrix
# --------------------------------------
# X: a single numeric matrix
# ncomp: the number of components to include in the model
# q: position of X in a list of matrix, as used in horizontal analysis
#   (e.g. block.pls)
Check.entry.single = function(X,  ncomp, q)
{
  
  #-- validation des arguments --#
  if (length(dim(X)) != 2)
    stop(paste0("'X[[", q, "]]' must be a numeric matrix."))
  
  if(! any(class(X) %in% "matrix"))
    X = as.matrix(X)
  
  if (!is.numeric(X))
    stop(paste0("'X[[", q, "]]'  must be a numeric matrix."))
  
  N = nrow(X)
  P = ncol(X)
  
  if (is.null(ncomp) || !is.numeric(ncomp) || ncomp <= 0)
    stop(paste0(
      "invalid number of variates 'ncomp' for matrix 'X[[", q, "]]'."))
  
  ncomp = round(ncomp)
  
  # add colnames and rownames if missing
  X.names = dimnames(X)[[2]]
  if (is.null(X.names))
  {
    X.names = paste("X", 1:P, sep = "")
    dimnames(X)[[2]] = X.names
  }
  
  ind.names = dimnames(X)[[1]]
  if (is.null(ind.names))
  {
    ind.names = 1:N
    rownames(X)  = ind.names
  }
  
  if (length(unique(rownames(X))) != nrow(X))
    stop("samples should have a unique identifier/rowname")
  if (length(unique(X.names)) != P)
    stop("Unique indentifier is needed for the columns of X")
  
  return(list(X=X, ncomp=ncomp, X.names=X.names, ind.names=ind.names))
}

logratio.transfo <- function(X,
                             logratio = c('none','CLR','ILR'),
                             offset = 0)
{
  X <- as.matrix(X)
  if (!is.numeric(X))
    stop("X must be a numeric matrix", call. = FALSE)
  
  logratio <- match.arg(logratio)
  if (logratio == 'ILR')
  {
    if (!is(X, 'ilr'))
    {   # data are ilr transformed, then the data lose 1 variable, but we'll use V to reconstruct the matrix
      X = ilr.transfo(X, offset = offset)
    }
  } else if (logratio == 'CLR') {
    X = clr.transfo(X, offset = offset)
  }
  return(X)
}


#' @importFrom dplyr group_by row_number filter n
internal_predict.DA <- 
  function(object, out, q, dist, weights)
  {
    # a DA analysis (mint).(block).(s)plsda
    if (!is(object, "DA"))
      stop("'Object' is not from a Discriminant Analysis", call.=FALSE)
    
    out.DA = list()
    J = length(object$X) #at this stage we have a list of blocks
    p = lapply(object$X, ncol)
    t.pred = out$variates
    Y.hat = out$predict
    newdata = out$newdata #actually concat.newdata
    variatesX = object$variates[-(J + 1)];
    ncomp = object$ncomp
    
    Y = object$Y
    Y.prim = unmap(object$Y)
    G = cls = list()
    for (i in 1 : J)
    {
      G[[i]] = sapply(1:q, function(x)
      {apply(as.matrix(variatesX[[i]][Y.prim[, x] == 1,
                                      ,drop=FALSE]), 2, mean)})
      if (ncomp[i] == 1)
        G[[i]] = t(t(G[[i]]))
      else
        G[[i]] = t(G[[i]])
      colnames(G[[i]]) = paste0("dim", c(1:ncomp[i]))
      rownames(G[[i]]) = colnames(object$ind.mat)
      
    }
    names(G)=names(object$X)
    
    ### Start: Maximum distance
    if (any(dist == "all") || any(dist == "max.dist"))
    {
      cls$max.dist = lapply(1:J, function(x){matrix(sapply(1:ncomp[x],
                                                           ### List level
                                                           function(y){apply(Y.hat[[x]][, , y, drop = FALSE], 1,
                                                                             ### component level
                                                                             function(z){
                                                                               paste(levels(Y)[which(z == max(z))], collapse = "/")
                                                                             }) ### matrix level
                                                           }), nrow = nrow(newdata[[x]]), ncol = ncomp[x])
      })
      cls$max.dist = lapply(1:J, function(x){colnames(cls$max.dist[[x]]) =
        paste0(rep("comp", ncomp[x]), 1 : ncomp[[x]]);
      rownames(cls$max.dist[[x]]) = rownames(newdata[[x]]);
      return(cls$max.dist[[x]])})
      names(cls$max.dist)=names(object$X)
    }
    
    
    ### Start: Centroids distance
    if (any(dist == "all") || any(dist == "centroids.dist"))
    {
      cl = list()
      centroids.fun = function(x, G, h, i) {
        q = nrow(G[[i]])
        x = matrix(x, nrow = q, ncol = h, byrow = TRUE)
        
        if (h > 1) {
          d = apply((x - G[[i]][, 1:h])^2, 1, sum)
        }
        else {
          d = (x - G[[i]][, 1])^2
        }
        cl.id = paste(levels(Y)[which(d == min(d))], collapse = "/")
      }
      
      for (i in 1 : J)
      {
        cl[[i]] = matrix(nrow = nrow(newdata[[1]]), ncol = ncomp[i])
        
        for (h in 1 : ncomp[[i]])
        {
          cl.id = apply(matrix(t.pred[[i]][, 1:h], ncol = h), 1,
                        function(x) {centroids.fun(x = x, G = G, h = h, i = i)})
          cl[[i]][, h] = cl.id
        }
      }
      
      cls$centroids.dist = lapply(1:J, function(x){colnames(cl[[x]]) =
        paste0(rep("comp", ncomp[x]), 1 : ncomp[[x]]);
      rownames(cl[[x]]) = rownames(newdata[[x]]); return(cl[[x]])})
      names(cls$centroids.dist)=names(object$X)
    }### End: Centroids distance
    
    
    ### Start: Mahalanobis distance
    if (any(dist == "all") || any(dist == "mahalanobis.dist"))
    {
      cl = list()
      Sr.fun = function(x, G, Yprim, h, i) {
        q = nrow(G[[i]])
        Xe = Yprim %*% G[[i]][, 1:h]
        #Xr = object$variates$X[, 1:h] - Xe
        Xr = variatesX[[i]][, 1:h] - Xe
        Sr = t(Xr) %*% Xr/nrow(Yprim)
        Sr.inv = solve(Sr)
        x = matrix(x, nrow = q, ncol = h, byrow = TRUE)
        if (h > 1) {
          mat = (x - G[[i]][, 1:h]) %*% Sr.inv %*% t(x - G[[i]][, 1:h])
          d = apply(mat^2, 1, sum)
        } else {
          d = drop(Sr.inv) * (x - G[[i]][, 1])^2
        }
        cl.id = paste(levels(Y)[which(d == min(d))], collapse = "/")
      }
      
      for (i in 1 : J){
        cl[[i]] = matrix(nrow = nrow(newdata[[1]]), ncol = ncomp[i])
        
        for (h in 1:ncomp[[i]]) {
          cl.id = apply(matrix(t.pred[[i]][, 1:h], ncol = h), 1, Sr.fun,
                        G = G, Yprim = Y.prim, h = h, i = i)
          cl[[i]][, h] = cl.id
        }
      }
      
      cls$mahalanobis.dist = lapply(1:J, function(x){colnames(cl[[x]]) =
        paste0(rep("comp", ncomp[x]), 1 : ncomp[[x]]);
      rownames(cl[[x]]) = rownames(newdata[[x]]);return(cl[[x]])})
      names(cls$mahalanobis.dist)=names(object$X)
    } ### End: Mahalanobis distance
    
    out.DA$class = cls
    
    ### End if discriminant analysis is performed
    
    # at this stage, we have the classification of each sample for each dataset
    #   of object$X
    # now we need to combine the classification by vote (majority wins),
    #  only when more than one block, otherwise 'vote' is classic classification
    if (length(object$X)>1)
    {
      for (ijk in 1:length(out.DA$class))# loop on the dist
      {
        # create a temporary array to make computation on the lists easier
        temp=array(, c(nrow(newdata[[1]]), min(ncomp), J))
        for(i in 1:J)
        {
          temp[, , i] = out.DA$class[[ijk]][[i]][, 1:min(ncomp)]
          
        }
        # look at the majority vote for all dataset of object$X (with table)
        #   if more than a unique max, we put NA
        table.temp = apply(temp,c(1,2), function(x)
        {a=table(x); if (length(which(a==max(a)))==1)
        {b=names(which.max(a))}else{b=NA}; b})
        colnames(table.temp) =
          colnames(out.DA$class[[ijk]][[i]])[1:min(ncomp)]
        rownames(table.temp) = rownames(out.DA$class[[ijk]][[i]])
        out.DA$MajorityVote[[ijk]] = table.temp
      }
      names(out.DA$MajorityVote) = names(out.DA$class)
      
      #save(list=ls(),file="temp.Rdata")
      #stop("")
      # weighted vote for each distance, each comp
      if(!is.null(weights))
      {
        out.WeightedVote = vector("list",length=length(out.DA$class))
        Group.2 = n = x =NULL #CRAN check
        for(i in 1:length(out.DA$class)){ #i distance
          out = matrix(NA_real_,nrow=nrow(newdata[[1]]), ncol=min(ncomp))
          rownames(out) = rownames(newdata[[1]])
          colnames(out) = paste0("comp",1:min(ncomp))
          
          for(comp in 1:min(ncomp)){ #comp
            data.temp=NULL
            for(j in 1:J){ #block
              data.temp = rbind(data.temp,
                                out.DA$class[[i]][[j]][,comp,drop=FALSE])
            }
            colnames(data.temp)="pred"
            temp=data.frame(data.temp,indiv=rownames(data.temp),
                            weights=rep(weights,each=nrow(out.DA$class[[1]][[1]])))
            ag = aggregate(temp$weights,
                           by=list(temp$pred, temp$indiv), FUN=sum)
            data_max <- group_by(.data = ag, Group.2)
            data_max <- filter(.data = data_max, row_number(x)==n())
            out.comp = as.matrix(data_max[,1])
            rownames(out.comp) = as.matrix(data_max[,2])
            colnames(out.comp) = paste0("comp",comp)
            
            out[,comp] = out.comp[match(rownames(out),
                                        rownames(out.comp)),]
          }
          
          out.WeightedVote[[i]] = out
        }
        names(out.WeightedVote) = names(out.DA$class)
        out.DA$WeightedVote = out.WeightedVote
        
        
        
        if(FALSE){
          out.DA$WeightedVote = lapply(out.DA$class, function(x){
            # x is a distance
            class.per.comp = lapply(1:min(ncomp), function(y) {
              matrix(sapply(x, function(z)
                z[,y, drop = FALSE]),ncol=J)})
            # combine the results per component
            names(class.per.comp) = paste0("comp",1:min(ncomp))
            class.weighted.per.comp = sapply(class.per.comp, function(y){
              # for each component
              apply(y,1,function(z){
                # we aggregate the results of each individuals using the 'weights'
                temp = aggregate(weights,list(as.character(z)),sum)
                ind = which(temp[,2]== max (temp[,2]))
                # if two max, then NA
                if(length(ind) == 1)
                {
                  res = as.character(temp[ind, 1])
                } else {
                  res = NA
                }
                res
                
              })
              
            })
            class.weighted.per.comp = matrix(class.weighted.per.comp,
                                             nrow = nrow(class.per.comp[[1]]))
            colnames(class.weighted.per.comp) = names(class.per.comp)
            rownames(class.weighted.per.comp) =
              rownames(out.DA$MajorityVote[[1]])
            class.weighted.per.comp
            
          })
        }
        out.DA$weights = weights
        
      }
    }else{
      out.DA$MajorityVote = lapply(out.DA$class,function(x){x[[1]]})
    }
    
    block.object = c("block.pls", "block.spls", "block.plsda", "block.spsda")
    if (inherits(object, block.object) & J>1) # a block
    {
      out.DA$centroids = G
    }else{ #not a block
      out.DA$centroids = G[[1]]
      out.DA$class = out.DA$MajorityVote
    }
    if (any(dist == "all"))
      dist = "all"
    
    out.DA$dist = dist
    
    out.DA
    
  }

unmap <-
  function (classification, groups = NULL, noise = NULL)
  {
    n = length(classification)
    u = sort(unique(classification))
    levels =  levels(classification)### Add levels
    
    if (is.null(groups))
    {
      groups = u
    } else {
      if (any(match(u, groups, nomatch = 0) == 0))
        stop("groups incompatible with classification")
      miss = match(groups, u, nomatch = 0) == 0
    }
    
    cgroups = as.character(groups)
    if (!is.null(noise))
    {
      noiz = match(noise, groups, nomatch = 0)
      if (any(noiz == 0))
        stop("noise incompatible with classification")
      
      groups = c(groups[groups != noise], groups[groups == noise])
      noise = as.numeric(factor(as.character(noise), levels = unique(groups)))
    }
    
    groups = as.numeric(factor(cgroups, levels = unique(cgroups)))
    classification = as.numeric(factor(as.character(classification), levels = unique(cgroups)))
    k = length(groups) - length(noise)
    nam = levels(groups)
    
    if (!is.null(noise))
    {
      k = k + 1
      nam = nam[1:k]
      nam[k] = "noise"
    }
    
    z = matrix(0, n, k, dimnames = c(names(classification), nam))
    for (j in 1:k) z[classification == groups[j], j] = 1
    attr(z, "levels") = levels
    z
  }

#' @title Predicts gestational age using placental DNA methylation microarray 
#' data
#'
#' @description \code{predictAge} Multiplies the coefficients from one of three 
#' epigenetic gestational age clocks, by the corresponding CpGs in a supplied 
#' betas `data.frame`.
#' 
#' @details Predicts gestational age using one of 3 placental gestational age
#' clocks: RPC, CPC, or refined RPC. Requires placental DNA methylation measured
#' on the Infinium 27K/450k/EPIC methylation array. Ensure as many predictive
#' CpGs are present in your data, otherwise accuracy may be impacted.
#'
#' It's recommended that you have all predictive CpGs, otherwise accuracy may
#' vary.
#' 
#' @param betas An n by m dataframe of methylation values on the beta scale (0,
#' 1), where the CpGs are arranged in rows, and samples in columns. Should
#' contain all CpGs used in each clock
#' @param type One of the following: "RPC" (Robust), "CPC", (Control) or "RRPC"
#' (Refined Robust).
#' @return A vector of length `m`, containing inferred gestational age.
#'
#' @examples
#'
#' # Load placenta DNAm data
#' library(dplyr)
#' data(plBetas)
#' data(plPhenoData)
#'
#' plPhenoData %>%
#'     mutate(inferred_ga = predictAge(plBetas, type = "RPC"))
#'     
#' @export predictAge
#' 
predictAge <- function(betas, type = "RPC") {
    data(ageCpGs, envir = environment())
    RPC <- CPC <- RRPC <- CpGs <- NULL
    # Filter to coefficients
    if (type == "RPC") {
        coef <- ageCpGs %>%
            dplyr::filter(RPC != 0)
    } else if (type == "CPC") {
        coef <- ageCpGs %>%
            dplyr::filter(CPC != 0)
    } else if (type == "RRPC") {
        coef <- ageCpGs %>%
            dplyr::filter(RRPC != 0)
    } else {
        stop('Type must be one of "CPC", "RPC", or "RRPC"')
    }

    # intersection of cpgs
    cpgs <- intersect(
        coef %>%
            dplyr::filter(CpGs != "(Intercept)") %>%
            dplyr::pull(CpGs),
        rownames(betas)
    )

    # Check if CpGs missing
    if (length(cpgs) / (nrow(coef) - 1) < 0.5) {
        stop("Less than 50% of predictors were found.")
    }


    if (length(cpgs) < (nrow(coef) - 1)) {
        warning(paste(
            "Only", length(cpgs), "out of", (nrow(coef) - 1),
            "predictors present."
        ))
    } else {
        message(paste(
            length(cpgs), "of",
            (nrow(coef) - 1), "predictors present."
        ))
    }

    # filter coefficients and beta
    coef_filtered <- coef %>%
        dplyr::filter(CpGs %in% c("(Intercept)", cpgs)) %>%
        dplyr::pull(!!type)

    betas_filtered <- cbind(1, t(betas[cpgs, ]))

    # calculate
    age <- betas_filtered %*% coef_filtered %>%
        as.vector()

    return(age)
}

test_that("predictAge() complains when no CpGs found", {
  data(plBetas)
  data(ageCpGs)
  expect_error(predictAge(data.frame(1:3, 4:6)))
  expect_error(predictAge(plBetas[1:500,], type = 'RPC'))
  
  # 2:700 = 344/558
  expect_warning(predictAge(plBetas[ageCpGs$CpGs[2:700],], 
                              type = 'RPC'))
  # 2:700 = 337/546
  expect_warning(predictAge(plBetas[ageCpGs$CpGs[2:700],], 
                              type = 'CPC'))
  # 2:700 = 243/395
  expect_warning(predictAge(plBetas[ageCpGs$CpGs[2:700],], 
                              type = 'RRPC'))
})

test_that("predictAge() returns correct number of samples", {
  data(plBetas)
  expect_equal(length(predictAge(plBetas)), ncol(plBetas))
})

test_that("predictAge() returns numeric vector", {
  data(plBetas)
  expect_true(is.vector(predictAge(plBetas)))
  expect_true(is.numeric(predictAge(plBetas)))
})

test_that("predictAge() returns sensible gestational ages", {
  data(plBetas)
  expect_true(all(predictAge(plBetas) < 50))
  expect_true(all(predictAge(plBetas) > 0))
})

#' @title CpGs to predict ethnicity
#'
#' @description 1860 CpGs used to predict ethnicity. 
#' 
#' See [Yuan et al. 2019](https://pubmed.ncbi.nlm.nih.gov/31399127/) for 
#' details.
#'
#' @format A character vector of length 1860
#' @source \url{https://pubmed.ncbi.nlm.nih.gov/31399127/}
#' @usage data(ethnicityCpGs)
"ethnicityCpGs"

#' @title Example placental DNA methylation data
#'
#' @description 6 DNA methylation profiles from preeclampsia and healthy 
#' control placentas. This data was downloaded from:
#' 
#' - [GSE75196](https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE75196)
#' 
#' "Genome wide DNA methylation profiling of normal and 
#' preeclampsia placental samples. Illumina Infinium HumanMethylation450 
#' BeadChip (450K array) was used to obtain DNA methylation profiles in 
#' placental samples. Samples included 16 samples from healthy uncomplicated
#'  pregnancies and 8 samples from pregnancies affected by preeclampsia." - 
#'  from [Yeung et al.](https://pubmed.ncbi.nlm.nih.gov/26968548/)
#'
#' The DNA methylation data for 24 placental samples were downloaded from
#' [GSE75196](https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE75196).
#' After normalizing using `minfi::preprocessNoob` and `wateRmelon::BMIQ`, 
#' the data were filtered to 6/24 samples and 10,000 random CpGs + those CpGs 
#' used in the gestational age clock and ethnicity classifier.
#'
#' Reference: Yeung KR, Chiu CL, Pidsley R, Makris A et al. DNA methylation
#' profiles in preeclampsia and healthy control placentas. Am J Physiol Heart
#' Circ Physiol 2016 May 15;310(10):H1295-303.
#' [PMID:26968548](https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE75196)
#'
#' @format A matrix
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE75196}
#' @usage data(plBetas)
"plBetas"

#' @title Sample information accompanying `pl_betas`
#' 
#' @description Sex, disease, and gestational age information associated with
#' `pl_betas`.
#'
#' Downloaded from the GEO accession:
#'  
#' - [GSE75196](https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE75196)
#' 
#' Reference: Yeung KR, Chiu CL, Pidsley R, Makris A et al. DNA methylation
#' profiles in preeclampsia and healthy control placentas. Am J Physiol Heart
#' Circ Physiol 2016 May 15;310(10):H1295-303.
#' [PMID: 26968548](https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE75196)
#' 
#' @format A [tibble][tibble::tibble-package]
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE75196}
#' @usage data(plPhenoData)
"plPhenoData"

#' @title Placental gestational age CpGs 
#' 
#' @description Coefficients from the three placental gestational age clocks 
#' from [Lee Y et al. 2019](https://pubmed.ncbi.nlm.nih.gov/31235674/).
#'
#' Reference: Lee Y, Choufani S, Weksberg R, et al. Placental epigenetic 
#' clocks: estimating gestational age using placental DNA methylation levels. 
#' Aging (Albany NY). 2019;11(12):4238–4253. doi:10.18632/aging.102049. PMID:
#' 31235674
#'
#' @format A [tibble][tibble::tibble-package] with coefficients for the RPC,
#' CPC, and refined RPC.
#' @usage data(ageCpGs)
"ageCpGs"

#' @title First trimester placental cell type coefficients
#' @description First trimester coefficients for placental cellular
#' deconvolution from [Yuan V et al. 2020]().
#'
#' Reference: to be edited
#' PMID: to be edited
#'
#' @format A [matrix] with coefficients for Trophoblasts, Stromal,
#' Endothelial, Hofbauer cells, nRBCs, and Syncytiotrophoblasts.
#' @usage data(plCellCpGsFirst)
"plCellCpGsFirst"

#' @title Third trimester placental cell type coefficients
#' @description Third trimester coefficients for placental cellular
#' deconvolution from [Yuan V et al. 2020]().
#'
#' Reference: to be edited
#' PMID: to be edited
#'
#' @format A [matrix] with coefficients for Trophoblasts, Stromal,
#' Endothelial, Hofbauer cells, nRBCs, and Syncytiotrophoblasts.
#' @usage data(plCellCpGsThird)
"plCellCpGsThird"

#' @title A color palette for placental cell types
#' @description A nice color palette for placental cell types. 
#' 
#' Used in [Yuan V et al. 2020]().
#' 
#' Contains colors for:
#'
#' - Syncytiotrophoblast
#' - Trophoblast
#' - Stromal
#' - Hofbauer
#' - Endothelial
#' - nRBCs
#' @usage data(plColors)
"plColors"

---
title: Python SDK User Guide
---

This guide is for Planet SDK for Python users who want to use Python code to search, order, customize, and deliver Planet imagery and data. If you’re new to Python, you may want to choose the no-code option of using the [command-line interface (CLI)](../../cli/cli-guide). But if you’ve successfully followed the instructions to [get started](../../get-started/quick-start-guide) and you’re ready to try your hand at Python coding, this guide should be all you need to use this SDK to get Planet data.

!!!note
    Looking for the asyncio-based SDK? See the [Planet Async SDK guide](./async-sdk-guide.md).

## Usage

### Install the Planet Python SDK

Use a package manager (such as `pip`) to install the Planet Python SDK:

```sh
pip install planet
```

### The Planet client

The `Planet` class is the main entry point for the Planet SDK. It provides access to the various APIs available on the Planet platform.

```python
from planet import Planet
pl = Planet()  # automatically detects PL_API_KEY
```

The Planet client has members `data`, `orders`, and `subscriptions`, which allow you to interact with the Data API, Orders API, and Subscriptions API.


### Authentication

Use the `PL_API_KEY` environment variable to authenticate with the Planet API.

```bash
export PL_API_KEY=your_api_key
```

These examples will assume you are using the `PL_API_KEY` environment variable. If you are, you can skip to the next section.

#### Authenticate using the Session class

Alternately, you can also authenticate using the `Session` class:

```python
from planet import Auth, Session, Auth
from planet.auth import APIKeyAuth

pl = Planet(session=Session(auth=APIKeyAuth(key='your_api_key')))
```

### Search

To search for items in the Planet catalog, use the `data.search()` method on the `Planet` client. The return value is an iterator that yields search
results:

```python
from planet import Planet

pl = Planet()
for item in pl.data.search(['PSScene'], limit=5):
    print(item)
```

#### Geometry

Use the `geometry` parameter to filter search results by geometry:

```python
geom = {
  "coordinates": [
    [
      [
        -125.41267816101056,
        46.38901501783491
      ],
      [
        -125.41267816101056,
        41.101114161051015
      ],
      [
        -115.51426167332103,
        41.101114161051015
      ],
      [
        -115.51426167332103,
        46.38901501783491
      ],
      [
        -125.41267816101056,
        46.38901501783491
      ]
    ]
  ],
  "type": "Polygon"
}
for item in pl.data.search(['PSScene'], geometry=geom, limit=5):
    print(item)
```

#### Filters

The Data API allows a wide range of search parameters. Whether using the `.search()` method, or
creating or updating a saved search, or requesting stats, a data search filter
can be provided to the API as a JSON blob. This JSON blob can be built up manually or by using the
`data_filter` module.

An example of creating the request JSON with `data_filter`:

```python
from datetime import datetime
from planet import data_filter

def main():
    pl = Planet()

    sfilter = data_filter.and_filter([
        data_filter.permission_filter(),
        data_filter.date_range_filter('acquired', gt=datetime(2022, 6, 1, 1))
    ])

    for item in pl.data.search(['PSScene'], filter=sfilter, limit=10):
        print(item["id"])
```

This returns scenes acquired after the provided date that you have permission to download using
your plan.

If you prefer to build the JSON blob manually, the above filter would look like this:

```python
sfilter = {
    'type': 'AndFilter',
    'config': [
        {'type': 'PermissionFilter', 'config': ['assets:download']},
        {
            'type': 'DateRangeFilter',
            'field_name': 'acquired',
            'config': {'gt': '2022-06-01T01:00:00Z'}
        }
    ]
}
```

This means that if you already have Data API filters saved as a query, you can copy them directly into the SDK.

#### Downloading a single asset

Downloading a single asset with the Data API is a multi-step process involving: activating the asset,
waiting for the asset to be active, downloading the asset, and, optionally,
validating the downloaded file.

With wait and download, it is often desired to track progress as these
processes can take a long time. Therefore, in this example, we use a simple
print command to report wait status. `download_asset` has reporting built in.

!!!note
    For bulk orders, we recommend creating an order or subscription.

```python
def download_and_validate():
    pl = Planet()

    # get asset description
    item_type_id = 'PSScene'
    item_id = '20221003_002705_38_2461'
    asset_type_id = 'ortho_analytic_4b'
    asset = pl.data.get_asset(item_type_id, item_id, asset_type_id)

    # activate asset
    pl.data.activate_asset(asset)

    # wait for asset to become active
    asset = pl.data.wait_asset(asset, callback=print)

    # download asset
    path = pl.data.download_asset(asset)

    # validate download file
    pl.data.validate_checksum(asset, path)
```

### Placing an Order

Once you have a list of scenes you want to download, you can place an order for assets using the Orders API client. Please review
[Items and Assets](https://developers.planet.com/docs/apis/data/items-assets/) in the Developer Center for a refresher on item types
and asset types.

Use the `order_request` module to build an order request, and then use the `orders.create_order()` method to place the order.

Orders take time to process. You can use the `orders.wait()` method to wait for the order to be ready, and then use the `orders.download_order()` method to download the assets.

Warning: running the following code will result in quota usage based on your plan.

```python
from planet import Planet, order_request

def main():
    pl = Planet()
    image_ids = ["20200925_161029_69_2223"]
    request = order_request.build_request(
        name='test_order',
        products=[
           order_request.product(
               item_ids=image_ids,
               product_bundle='analytic_8b_udm2',
               item_type='PSScene',
               fallback_bundle='analytic_udm2,analytic_3b_udm2')
       ]
    )

    order = pl.orders.create_order(request)

    # wait for the order to be ready
    # note: this may take several minutes.
    pl.orders.wait(order['id'])

    pl.orders.download_order(order['id'], overwrite=True)
```

### Creating a subscription

#### Prerequisites

Subscriptions can be delivered to a destination. The following example uses Amazon S3.
You will need your ACCESS_KEY_ID, SECRET_ACCESS_KEY, bucket and region name.

#### Scene subscription

To subscribe to scenes that match a filter, use the `subscription_request` module to build a request, and
pass it to the `subscriptions.create_subscription()` method of the client.

Warning: the following code will create a subscription, consuming quota based on your plan.

```python
from planet.subscription_request import catalog_source, build_request, amazon_s3

source = catalog_source(
    ["PSScene"],
    ["ortho_analytic_4b"],
    geometry={
        "type": "Polygon",
        "coordinates": [
            [
                [37.791595458984375, 14.84923123791421],
                [37.90214538574219, 14.84923123791421],
                [37.90214538574219, 14.945448293647944],
                [37.791595458984375, 14.945448293647944],
                [37.791595458984375, 14.84923123791421],
            ]
        ],
    },
    start_time=datetime.now(),
    publishing_stages=["standard"],
    time_range_type="acquired",
)

request = build_request("Standard PSScene Ortho Analytic", source=source, delivery={})

# define a delivery method. In this example, we're using AWS S3.
delivery = amazon_s3(ACCESS_KEY_ID, SECRET_ACCESS_KEY, "test", "us-east-1")

# finally, create the subscription
subscription = pl.subscriptions.create_subscription(request)
```

### Features API Collections and Features

The Python SDK now supports [Features API](https://developers.planet.com/docs/apis/features/) Collections and Features (note: in the SDK and API, Features are often referred to as items in a collection).

Collections and Features/items that you create in in the SDK will be visible in Features API and Features Manager.

#### Creating a collection

You can use the Python SDK to create feature collections in the Features API.

```python
new_collection = pl.features.create_collection(title="my collection", description="a new collection")
```

#### Listing collections

```python
collections = pl.features.list_collections()
for collection in collections:
  print(collection)
```

#### Listing features/items in a collection

```python
items = pl.features.list_items(collection_id)
for item in items:
  print(item)

```

#### Using items as geometries for other methods

You can pass collection items/features directly to other SDK methods. Any method that requires a geometry will accept
a Features API Feature.

!!!note
    When passing a Features API Feature to other methods, the [feature ref](https://developers.planet.com/docs/apis/features/feature-references/) will be used. This means any searches or subscriptions you create will be linked to your feature.

```python
# collection_id: the ID of a collection in Features API

items = pl.features.list_items(collection_id)
example_feature = next(items)
results = pl.data.search(["PSScene"], geometry=example_feature)
```

!!!note
    Reserving quota for features is currently not supported in the SDK. However, you may create features within the SDK and then use [Features Manager](https://planet.com/features) to reserve quota.

## API Exceptions

When errors occur, the Planet SDK for Python exception hierarchy is as follows:

* All exceptions inherit from the base exception called `PlanetError`.
* Client-side errors are raised as `ClientError`.
* Server-side errors are raised as specific exceptions based on the http code. These specific exceptions all inherit from `APIError`  and contain the original error message returned by the server.

## How to Get Help

As The Planet SDK (V2) is in active development, features & functionality will continue to be added.

If there's something you're missing or are stuck, the development team would love to hear from you.

  - To report a bug or suggest a feature, [raise an issue on GitHub](https://github.com/planetlabs/planet-client-python/issues/new)
  - To get in touch with the development team, email [developers@planet.com](mailto:developers@planet.com)

---
name: Bug report
about: Create a report to help us improve
title: ''
labels: bug
assignees: ''

---

**Expected behavior**
A clear and concise description of what you expected to happen.

**Actual behavior (describe the problem)**
Why the current behavior is a problem and why the expected behavior is a better solution.

**Related Issues**
Please list the ticket numbers (e.g. #708) for any issues already logged in the system.

**Workaround**
Any ways you have found to work around the problem and accomplish your task.

**Minimum, Complete, Viable Code Sample**
A "Minimal, Complete and Verifiable Example" will make it much easier for maintainers to help you.
See http://matthewrocklin.com/blog/work/2018/02/28/minimal-bug-reports

```python
# Your python code here
```
or
```console
> command-line-call
```

**Environment Information**
* Operation System Information (`python -c "import platform; print(platform.platform())"`)
* Python version (`python -c "import sys; print(sys.version.replace('\n', ' '))"`)
* Planet package version (`planet -v`)

**Installation Method**
* conda, pip wheel, from source, etc...

**Related Issue(s):**

Closes #


**Proposed Changes:**

For inclusion in changelog (if applicable):

1.

Not intended for changelog:

1. 

**Diff of User Interface**

Old behavior:

New behavior:




**PR Checklist:**

- [] This PR is as small and focused as possible
- [] If this PR includes proposed changes for inclusion in the changelog, the title of this PR summarizes those changes and is ready for inclusion in the Changelog.
- [] I have updated docstrings for function changes and docs in the 'docs' folder for user interface / behavior changes
- [] This PR does not break any examples or I have updated them

**(Optional) @mentions for Notifications:**

---
name: Feature request
about: Suggest an idea for this project
title: ''
labels: proposal
assignees: ''

---

**Is your feature request related to a problem? Please describe.**


**Describe the solution you'd like**


**Describe alternatives you've considered**


**Additional context**

# Application Managed Sessions - OAuth2

If an application cannot or should not use a login session initiated by the
[`planet auth`](../../cli/cli-reference/#auth) CLI command, the application will be
responsible for managing the process on its own, persisting session state as
needed.

Application managed sessions may be used with all authentication protocols.
Application developers may control whether sessions are visible to the CLI.
This is managed with the `save_state_to_storage` parameter on the `planet.Auth`
constructor methods illustrated below.

The process varies depending on the authentication protocol used.
Depending on the use case, applications may need to support multiple authentication
methods, just as the [`planet`](../../cli/cli-reference) CLI command supports interacting with Planet APIs
using either a user or a service user account.

## OAuth2 Session for Users
User session initialization inherently involves using a web browser to
complete user authentication.  This architecture allows for greater security
by keeping the user's password from being directly exposed to the application
code. This also allows for flexibility in user federation and multifactor
authentication procedures without the complexity of these needing to
be exposed to the application developer who is focused on geospatial
operations using the Planet platform, and not the nuances of user
authentication and authorization.

### OAuth2 User Client Registration
Developers of applications must register client applications with Planet, and
will be issued a Client ID as part of that process.  Developers should register
a client for each distinct application so that end-users may discretely manage
applications permitted to access Planet APIs on their behalf.

See [OAuth2 Client Registration](http://docs.planet.com/develop/authentication/#interactive-client-registration)
for more information.

### With a Local Web Browser
In environments where a local browser is available, the Planet SDK library can manage
the process of launching the browser locally, transferring control to the Planet
authorization services for session initialization, and accepting a network
callback from the local browser to regain control once the authorization
process is complete. At a network protocol level, this establishes the user
login session using the OAuth2 authorization code flow.

To use this method using the SDK, the following requirements must be met:

* The application must be able to launch a local web browser.
* The web browser must be able to connect to Planet services.
* The application must be able to listen on a network port that is accessible
  to the browser.

#### Examples - OAuth2 Authorization Code Flow

##### In Memory Session State
When an application cannot safely store user session state, it may operate purely in memory. When this
method is used, the user will be prompted to complete the login process each time the application is run.

```python linenums="1" title="Login as a user using a local browser with in memory only state persistance"
{% include 'auth-session-management/app_managed_auth_state__in_memory__oauth_user_authcode__with_browser.py' %}
```

##### Session State Shared with CLI
Applications may save their session state in a way that is shared with the CLI.  With saved state,
the user will only be prompted to complete the login process once.
```python linenums="1" title="Login as a user using a local browser with sessions persisted on disk and shared with the CLI"
{% include 'auth-session-management/app_managed_auth_state__on_disk_cli_shared__oauth_user_authcode__with_browser.py' %}
```

#####  Session State Saved to Application Storage
Applications may save their session state to application provided storage.  With saved state,
the user should only be prompted to complete the login process once.  Using application provided storage
will result in the session state not being shared with the CLI.

Applications needing to use their own storage will do so by providing
the `Auth` layer in the SDK with a custom implementation of the
[`planet_auth.ObjectStorageProvider`](https://planet-auth.readthedocs.io/en/latest/api-planet-auth/#planet_auth.ObjectStorageProvider)
abstract base class.  See examples below for more details.

```python linenums="1" title="Login as a user using a local browser with sessions persisted to application provided storage"
{% include 'auth-session-management/app_managed_auth_state__app_custom_storage__oauth_user_authcode__with_browser.py' %}
```

### Without a Local Web Browser
In environments where a local web browser is not available, additional steps must
be taken by the application author to initialize the user session.
For example, a remote shell to a cloud environment is not likely
to be able to open a browser on the user's desktop or receive network callbacks
from the user's desktop browser.  In these cases, a browser is
still required.  To complete login in such a case, the SDK will generate a URL and a
verification code that must be presented to the user. The user must visit the
URL out of band to complete the login process while the application polls for
the completion of the login process using the SDK. At a network protocol
level, this establishes the user login session using the OAuth2 device
code flow.

To use this method using the SDK, the following requirements must be met:

* The application must be able to connect to Planet services.
* The application must be able to display instructions to the user, directing
  them to a web location to complete login.

As above, this may be done with state only persisted in memory, with state
shared with the CLI, or with state saved to application provided storage.

#### Examples - OAuth2 Device Code Flow

##### In Memory Session State
```python linenums="1" title="Login as a user using an external browser with in memory only state persistance"
{% include 'auth-session-management/app_managed_auth_state__in_memory__oauth_user_devicecode__external_browser.py' %}
```

##### Session State Shared with CLI
```python linenums="1" title="Login as a user using an external browser with sessions persisted on disk and shared with the CLI"
{% include 'auth-session-management/app_managed_auth_state__on_disk_cli_shared__oauth_user_devicecode__external_browser.py' %}
```

#####  Session State Saved to Application Storage
```python linenums="1" title="Login as a user using an external browser with sessions persisted to application provided storage"
{% include 'auth-session-management/app_managed_auth_state__app_custom_storage__oauth_user_devicecode__external_browser.py' %}
```

## OAuth2 Session for Service Accounts
Service account session initialization is simpler than user session
initialization, and does not require a web browser.

While preserving session state for user sessions was a concern driven
in part by a concern for the user experience of using a web browser for
initialization, for service accounts it remains a concern to avoid
throttling by the authorization service.

If applications are expected to run longer than the life of an access token
(a few hours), then in memory operations are acceptable (for example: a long-running
data processing job).  If application lifespan is short and frequent,
then the application should take steps to persist the session state (for
example: a command line utility run repeatedly from a shell with a short lifespan).

Like the session state itself, service account initialization parameters are
sensitive, and it is the responsibility of the application to store them
securely.

At a network protocol level, OAuth2 service account sessions are implemented
using the OAuth2 authorization code flow.  This carries with it some additional
security concerns, discussed in
[RFC 6819 §4.4.4](https://datatracker.ietf.org/doc/html/rfc6819#section-4.4.4).
Because of these considerations, service accounts should only be used for
workflows that are independent of a controlling user.

As above, this may be done with state only persisted in memory, with state
shared with the CLI, or with state saved to application provided storage.

### OAuth2 M2M Client Registration
Service accounts are managed under the
**OAuth Clients** panel on the [Planet Insights Account](https://insights.planet.com/account/#/) page.

See [Sentinel Hub Authentication](https://docs.sentinel-hub.com/api/latest/api/overview/authentication/) for further information.

### Examples - OAuth2 Client Credentials Flow

#### In Memory Session State
```python linenums="1" title="Access APIs using a service account with in memory only state persistance"
{% include 'auth-session-management/app_managed_auth_state__in_memory__oauth_m2m.py' %}
```

#### Session State Shared with CLI
```python linenums="1" title="Access APIs using a service account with sessions persisted on disk and shared with the CLI"
{% include 'auth-session-management/app_managed_auth_state__on_disk_cli_shared__oauth_m2m.py' %}
```

####  Session State Saved to Application Storage
```python linenums="1" title="Access APIs using a service account with sessions persisted to application provided storage"
{% include 'auth-session-management/app_managed_auth_state__app_custom_storage__oauth_m2m.py' %}
```

----

---
title: No-Code CLI User Guide
---

## About

This is the complete guide to using the command-line interface (CLI) to Planet’s
APIs. It’s divided up into a number of sections, so you can jump right into 
the examples for an API you’re interested in. If you’re new to CLI’s it should
provide all the information you need to work more directly with Planet’s API’s.

## CLI Guide Overview

* **[CLI Introduction](cli-intro.md)** provides an introduction to using a
CLI and highlights some of the key concepts and tools that work with Planet’s CLI.
If you’re already comfortable with CLI tools you can safely skip this section.
* **[CLI for Data API](cli-data.md)** explores the `planet data` commands with 
extensive examples.
* **[CLI for Orders API](cli-orders.md)** dives into the `planet orders` commands
with numerous samples to get you started.
* **[CLI for Subscriptions API](cli-subscriptions.md)** - explains the `planet subscriptions` commands
* **[CLI Tips & Tricks](cli-tips-tricks.md)** highlights a number of interesting 
geospatial CLI command-line tools and shows you how to use them in conjunction
with Planet’s tools.

## Step 1: Install Python 3.9+ and a virtual environment

This is a Python package, so you’ll need to install Python (version 3.9 or greater), and set up and install a virtual environment.

Yes. Even if you’re not writing code—and only using the "no code" CLI part of the Planet SDK for Python—you’re using Python to communicate with the Planet Labs PBC servers. If you need help with Python install and setting up a virtual environment, read [Virtual Environments and the Planet SDK for Python](../get-started/venv-tutorial.md).

## Step 2: Install the Planet SDK for Python

Install the Planet SDK for Python using [pip](https://pip.pypa.io):

```console
$ pip install planet
```

## Step 3: Check the Planet SDK for Python version

```console
$ planet --version
```

You should be on some version 2 of the Planet SDK for Python.

## Step 4: Sign on to your account

Planet SDK for Python, like the Planet APIs, requires an account for use.

### Have your Planet account username and password ready

To confirm your Planet account, or to get one if you don’t already have one, see [Get your Planet Account](../get-started/get-your-planet-account.md).

### Authenticate with the Planet server

Just as you log in when you browse to https://account.planet.com, you’ll want to sign on to your account so you have access to your account and orders.

At a terminal console, type the following Planet command:

```console
$ planet auth init
```

You’ll be prompted for the email and password you use to access [your account](https://account.planet.com). When you type in your password, you won’t see any indication that the characters are being accepted. But when you hit enter, you’ll know that you’ve succeeded because you’ll see on the command line:

```console
Initialized
```

### Get your API key

Now that you’ve logged in, you can easily retrieve your API key that is being used for requests with the following command:

```console
planet auth value
```

Many `planet` calls you make require an API key. This is a very convenient way to quickly grab your API key.

#### Your API Key as an Environment Variable

You can also set the value of your API Key as an environment variable in your terminal at the command line:

```console
export PL_API_KEY=<your api key>
```

And you can see that the value was stored successfully as an environment variable with the following command:

```console
echo $PL_API_KEY
```

!!!note "The API Key environment variable is ignored by the CLI but used by the Python library"
    If you do create a `PL_API_KEY` environment variable, the CLI will be unaffected but the Planet library will use this as the source for authorization instead of the value stored in `planet auth init`.

## Step 5: Search for Planet Imagery

You’ve installed the environment, the SDK, and connected with the Planet server. You’re now ready to get your first bunch of data.

In this step, you search for the most recent PSScene images available to download and filter the list based on those images you actually have permissions to download.

### planet data filter

One of the commands you’ll use most frequently is `planet data filter`. This “convenience method” creates the JSON you need to run other commands. Run it with no arguments to see how it works by default:

```console
planet data filter --permission --std-quality
```

Look at the console output to see some default filters. `PermissionFilter` filters the output to only contain imagery that you have permission to download. You’ll also see `quality_category`, which means the output lists only images in the [`standard quality` category](https://developers.planet.com/docs/data/planetscope/#image-quality-standard-vs-test-imagery). Without these options, an empty filter is generated which would be used to disable filtering and simply return all results.

!!!note "The --help switch is your friend"
    You can do a lot with this `filter` command. We recommend running `planet data filter --help` often to get a reference of how the commands work.

### planet data search

Run the filter command and save it to a file named `filter.json`:

```console
planet data filter --permission --std-quality > filter.json
```

Then use that file with the search command and save the results to another file named `recent-psscene.json`.

```console
planet data search PSScene --filter filter.json > recent-psscene.json
```

Open `recent-psscene.json` to see the 100 most recent PSScene images you have permissions to actually download.

## Next steps

Now that you have the quick setup for the Planet SDK for Python, you have a few options:

* Continue to explore the [No-Code CLI Guide](#cli-guide-overview).
* Start coding with the [Python SDK User Guide](../python/sdk-guide.md).
* Check out some of the [examples in our GitHub repo](https://github.com/planetlabs/planet-client-python/tree/main/examples).

## How to Get Help

As The Planet SDK (V2) is in active development, features & functionality will continue to be added.

If there's something you're missing or are stuck, the development team would love to hear from you.

  - To report a bug or suggest a feature, [raise an issue on GitHub](https://github.com/planetlabs/planet-client-python/issues/new)
  - To get in touch with the development team, email [developers@planet.com](mailto:developers@planet.com)

---
title: Python SDK Quick Start
---

The Planet SDK for Python makes it easy to access Planet’s massive repository of satellite imagery and add Planet
data to your data ops workflow.

**Note:** This is the new, non-asyncio client. If you want to take advantage of asyncio, see the [async client guide](../python/async-sdk-guide.md). For the no-code CLI client, see the [CLI guide](../cli/cli-guide.md).

Your feedback on this version of our client is appreciated. Please raise an issue on [GitHub](https://github.com/planetlabs/planet-client-python/issues) if you encounter any problems.

## Dependencies

This package requires [Python 3.9 or greater](https://python.org/downloads/). A virtual environment is strongly recommended.

You will need your Planet API credentials. You can find your API key in [Planet Explorer](https://planet.com/explorer) under Account Settings.

## Installation

Install from PyPI using pip:

```bash
pip install planet
```

## Usage

### Authentication

Use the `PL_API_KEY` environment variable to authenticate with the Planet API. For other authentication options, see the [SDK guide](../python/sdk-guide.md).

```bash
export PL_API_KEY=your_api_key
```

### The Planet client

The `Planet` class is the main entry point for the Planet SDK. It provides access to the various APIs available on the Planet platform.

```python
from planet import Planet
pl = Planet()  # automatically detects PL_API_KEY
```

The Planet client has members `data`, `orders`, and `subscriptions`, which allow you to interact with the Data API, Orders API, and Subscriptions API. Usage examples for searching, ordering and creating subscriptions can be found in the [SDK guide](../python/sdk-guide.md).

## How to Get Help

As The Planet SDK (V2) is in active development, features & functionality will continue to be added.

If there's something you're missing or are stuck, the development team would love to hear from you.

  - To report a bug or suggest a feature, [raise an issue on GitHub](https://github.com/planetlabs/planet-client-python/issues/new)
  - To get in touch with the development team, email [developers@planet.com](mailto:developers@planet.com)

# Upgrade from Version 2 to Version 3

Version 3 of the Planet SDK for Python is a major update of the SDK offering
new features, not all of which are backwards compatible with version 2.

## Authentication
Version 3 of the SDK removes support for Planet's legacy authentication network
protocols in favor of OAuth2 based mechanisms.  The legacy protocols
were never a [documented Planet API](https://docs.planet.com/develop/apis/), but could
easily be understood by inspection of the SDK code.

Specifically, what is being deprecated in version 3 are the paths where the SDK
handled a username and password to obtain the user's API key for forward
operations.  Users may still operate with an API key by retrieving it from the
Planet user interface under [My Settings](https://www.planet.com/account/#/user-settings)
and providing it to the SDK.  While API keys remain supported for machine-to-machine
API use cases using `api.planet.com` APIs, OAuth2 mechanisms should be preferred
where the use case allows for it.

Users may also continue to initialize SDK and CLI sessions with their username
and password, but rather than being processed by the SDK itself a browser must
be invoked to complete OAuth2 client session initialization.
This new method is intended to offer a number of long-term benefits, including:

* The new method provides the SDK and the CLI with access tokens that may be
  used with both `api.planet.com` and `services.sentinel-hub.com` endpoints.  The method
  used by version 2 of the SDK was specific to `api.planet.com` endpoints, and
  will never be supported by `services.sentinel-hub.com` endpoints.
* The new method extends (currently optional) multifactor authentication (MFA)
  to SDK and CLI client use cases.
* The new method is compatible with other platform enhancements currently under
  development by Planet's software engineering team.

For complete details on the new mechanisms, see the [Client Authentication Guide](../auth/auth-overview.md).

### CLI Usage
The [`planet auth`](../../cli/cli-reference/#auth) command has been substantially
revised to align to the new authentication mechanisms.  For migration from version 2
of the SDK, the following changes are the most important to note:

* The `planet auth init` command has been replaced with [`planet auth login`](../../cli/cli-reference/#login).
  By default, this command will open a browser window to allow the user to log
  in to their Planet account and authorize the SDK or CLI to access their account.
  Other options are available to support a variety of use cases, including a
  `--no-open-browser` option for remote shells.  See `planet auth login --help`
  for complete details.
* The `planet auth value` command has been deprecated.  Depending on whether the SDK
  has been initialized with OAuth2 or API key authentication,
  [`planet auth print-access-token`](../../cli/cli-reference/#print-access-token)
  or [`planet auth print-api-key`](../../cli/cli-reference/#print-api-key) may
  be used.  OAuth2 sessions should be preferred where possible.
* The `planet auth store` command has been deprecated. The various options to the
  `planet auth login` command should provide suitable alternatives for all use cases.
  OAuth2 sessions should be favored for user interactive use cases, such as CLI usage.
  `planet auth login --auth-api-key YOUR_API_KEY` may be used to initialize the SDK
  with API key based authentication where the use case requires it.

### Session Persistence
Both version 2 and version 3 of the SDK use the `~/.planet.json` file in the user's
home directory to store the user's API key. If this file is present and was configured
by version 2 of the SDK, it should continue to work.

While the `~/.planet.json` file continues to be used by version 3, and version 3
understands files written by version 2, version 3 will not write the same information
to this file that version 2 did.  Version 3 uses this file in conjunction with the
`~/.planet` directory and subdirectories to store OAuth2 tokens and additional
session information needed for a smooth user experience.

Version 3 of the SDK provides a [`planet auth reset`](../../cli/cli-reference/#reset)
command to reset all saved state should it become corrupted.  When this command is run,
the old files are moved aside rather than deleted.

### SDK Session Initialization
See the [Client Authentication Guide](../auth/auth-overview.md) for a complete
discussion of all options now available.

Basic SDK use cases should work with no alterations.
User sessions initialized by [`planet auth login`](../../cli/cli-reference/#login)
will be detected by an application using a default Planet client when
run in an environment with access to the user's home directory.  For example:

```python linenums="1"
{% include 'auth-session-management/cli_managed_auth_state__implicit.py' %}
```

Applications may also continue to initialize the SDK with a specific API key as follows:
```python linenums="1"
{% include 'auth-session-management/app_managed_auth_state__in_memory__api_key.py' %}
```

Users developing new applications should consult the [Client Authentication Guide](../auth/auth-overview.md)
for a complete discussion of all OAuth2 based mechanisms.  OAuth2 mechanisms
should be preferred to the use of Planet API keys.

----

---
title: CLI for Orders API Tutorial
---

## Introduction

The `planet orders` command enables interaction with the [Orders API](https://developers.planet.com/apis/orders/),
which lets you activate and download Planet data products in bulk, and apply various
'tools' to your processes. This tutorial takes you through all the main capabilities
of the CLI for creating and downloading orders. It depends on several more advanced
command-line concepts, but this tutorial should let you get a sense of what you can do,
with enough examples that you should be able to adapt the commands for what you want to do.
If you’re interested in deeper understanding what is going on
then check out our [CLI Concepts](cli-intro.md) guide.

## Core Workflows

### List Orders

You can use the `list` command to see details of existing orders. By default they will be sorted
by most recently created.

```sh
planet orders list
```

If you’ve not placed any orders with Explorer, the CLI or the API directly, then the results
of this call will be blank, so you may want to try out some of the create order commands below.

Sometimes that list gets too long, so you can put a limit on how many are returned using the
`--limit` parameter.

#### Formatting

You can also print the list of orders more nicely:

```sh
planet orders list --pretty
```

The `--pretty` flag is built into most Planet CLI commands, and it formats the JSON to be
more readable.

You can also use `jq`, a powerful command-line JSON-processing tool, that is mentioned in
the [CLI introduction]((cli-intro.md#jq).

```sh
planet orders list | jq
```

Piping any output through jq will format it nicely and do syntax highlighting. You can
also `jq` to just show select information, which can be useful for getting a quick sense
of the state of the state of things and pull out id’s for other operations:

```sh
planet orders list | jq -rs '.[] | "\(.id) \(.created_on) \(.state) \(.name)"'
```

You can customize which fields you want to show by changing the values.

A list of your orders can also be viewed in a UI at https://www.planet.com/account/#/orders

#### Number of existing orders

You can use `jq` to process the output for more insight, like get a count of how many existing
orders you have. Orders are automatically deleted 90 days after completion, so this number
roughly is equivalent to the number of orders created in the last 90 days.

```sh
planet orders list | jq -s length
```

This uses `-s` to collect the output into a single array, and `length` then tells the
length of the array.

#### Filtering

The `list` command supports filtering on a variety of fields:
* `--state`: Filter by order state. Options include `queued`, `failed`, `success`, `partial` and `cancelled`.
* `--source-type`: Filter by source type. Options include `scenes`, `basemaps`, or `all`. The default is `all`.
* `--name`: Filter by name.
* `--name-contains`: Only return orders with a name that contains the provided string.
* `--created-on`: Filter on the order creation time or an interval of creation times.
* `--last-modified`: Filter on the order's last modified time or an interval of last modified times.
* `--hosting`: Filter on orders containing a hosting location (e.g. SentinelHub). Accepted values are `true` or `false`.

Datetime args (`--created-on` and `--last-modified`) can either be a date-time or an interval, open or closed. Date and time expressions adhere to RFC 3339. Open intervals are expressed using double-dots.
* A date-time: `2018-02-12T23:20:50Z`
* A closed interval: `2018-02-12T00:00:00Z/2018-03-18T12:31:12Z`
* Open intervals: `2018-02-12T00:00:00Z/..` or `../2018-03-18T12:31:12Z`

To list orders in progress:
```sh
planet orders list --state running
```

To list orders with the `scenes` source type:
```sh
planet orders list --source-type scenes
```

To list orders that were created in 2024:
```sh
planet orders list --created-on 2024-01-01T00:00:00Z/2025-01-01T00:00:00Z
```

To list orders with a hosting location:
```sh
planet orders list --hosting true
```

To list orders with the name `my location xyz`:
```sh
planet orders list --name "my location xyz"
```

To list orders with a name containing `xyz`:
```sh
planet orders list --name-contains xyz
```

#### Sorting

The `list` command also supports sorting the orders on one or more fields: `name`, `created_on`, `state`, and `last_modified`. The sort direction can be specified by appending ` ASC` or ` DESC` to the field name (default is ascending).

When multiple fields are specified, the sort order is applied in the order the fields are listed.

Sorting examples:
* `--sort-by name`: sorts orders by name alphabetically.
* `--sort-by "created_on DESC"`: sorts orders by most recently created.
* `--sort-by "last_modified DESC"`: sorts subscriptions by most recently modified.
* `--sort-by "state ASC"`: sorts orders by state alphabetically.
* `--sort-by "name,last_modified DESC"`: sorts subscriptions by name first, and most recently modified second.

### Info on an Order

For a bit more information about an order, including the location of any downloads, use
the `get` command, using the order id.

```sh
planet orders get 782b414e-4e34-4f31-86f4-5b757bd062d7
```

### Create an Order Request

To create an order you need a name, a [bundle](https://developers.planet.com/apis/orders/product-bundles-reference/),
 one or more id’s, and an [item type](https://developers.planet.com/docs/apis/data/items-assets/#item-types):

First lets get the ID of an item you have download access to, using the Data API:

```sh
planet data filter | planet data search PSScene --limit 1 --filter - | jq -r .id
```

If you don't have access to PlanetScope data then replace PSScene with SkySatCollect.
Then make the following call:

```sh
planet orders request \
    --item-type PSScene \
    --bundle analytic_sr_udm2 \
    --name 'My First Order' \
    20220605_124027_64_242b
```

Running the above command should output the JSON needed to create an order:

```json
{"name": "My First Order", "products": [{"item_ids": ["20220605_124027_64_242b"], "item_type": "PSScene", "product_bundle": "analytic_sr_udm2"}], "metadata": {"stac": {}}}
```

You can also use `jq` here to make it a bit more readable:

```sh
planet orders request \
    --item-type PSScene \
    --bundle analytic_sr_udm2 \
    --name 'My First Order' \
    20220605_124027_64_242b \
    | jq
```

```json
{
  "name": "My First Order",
  "products": [
    {
      "item_ids": [
        "20220605_124027_64_242b"
      ],
      "item_type": "PSScene",
      "product_bundle": "analytic_sr_udm2"
    }
  ],
  "metadata": {
    "stac": {}
  }
}
```

#### Fallback bundles
Orders API will deliver [fallback bundles](https://developers.planet.com/apis/orders/scenes/#order-type-and-fallback-bundles) if the first choice product bundle fails for any reason.  You can specify one or more fallback bundles by using the `--fallback-bundle` option which accepts a comma separated string of fallback bundles:

```sh
planet orders request \
    --item-type PSScene \
    --bundle analytic_8b_udm2 \
     --fallback-bundle 'analytic_udm2,analytic_3b_udm2' \
    --name 'My First Order' \
    '20250130_035211_69_2516'
```

#### Zip archives of bundles and orders

You can request that all files of a bundle be zipped together by using the `--archive-type` option. The only type of archive currently available is "zip".

```sh
planet orders request \
    --item-type PSScene \
    --bundle analytic_sr_udm2 \
    --name 'My First Zipped Order' \
    --archive-type zip \
    20220605_124027_64_242b
```

You can request that all files of the entire order be zipped together by using the `--single-archive` option.

```sh
planet orders request \
    --item-type PSScene \
    --bundle analytic_sr_udm2 \
    --name 'My First Zipped Order' \
    --archive-type zip \
    --single-archive \
    20220605_124027_64_242b,20220605_124025_34_242b
```

*New in version 2.1*

#### Sentinel Hub Hosting

You can deliver your orders directly to Sentinel Hub using the hosting options.

```
planet orders request \
    --item-type PSScene \
    --bundle analytic_sr_udm2 \
    --name 'My First Order' \
    20220605_124027_64_242b \
    --hosting sentinel_hub \
    --collection-id ba8f7274-aacc-425e-8a38-e21517bfbeff
```

```
planet orders request \
    --item-type PSScene \
    --bundle analytic_sr_udm2 \
    --name 'My First Order' \
    20220605_124027_64_242b \
    --hosting sentinel_hub \
    --create-configuration
```

- The --hosting option is optional and currently supports sentinel_hub as its only value.
- The --collection-id is also optional. If you decide to use this, ensure that the order request and the collection have matching bands. If you're unsure, allow the system to create a new collection for you by omitting the --collection-id option. This will ensure the newly set-up collection is configured correctly, and you can subsequently add items to this collection as needed.
- The --create-configuration option will create a new [layer configuration](https://apps.sentinel-hub.com/dashboard/#/configurations) in Sentinel Hub on your behalf. This option cannot be used with --collection-id.

For more information on Sentinel Hub hosting, see the [Orders API documentation](https://developers.planet.com/apis/orders/delivery/#delivery-to-sentinel-hub-collection) and the [Linking Planet User to Sentinel Hub User
](https://support.planet.com/hc/en-us/articles/16550358397469-Linking-Planet-User-to-Sentinel-Hub-User) support post.

### Save an Order Request

The above command just prints out the necessary JSON to create an order. To actually use it you can
save the output into a file:

```sh
planet orders request \
    --item-type PSScene \
    --bundle analytic_sr_udm2 \
    --name "My First Order" \
    20220605_124027_64_242b \
    > request-1.json
```

Note that `\` just tells the command-line to treat the next line as the same one. It’s used here so it’s
easier to read, but you can still copy and paste the full line into your command-line and it should work.

This saves the above JSON in a file called `request-1.json`

### Create an Order

From there you can create the order with the request you just saved:

```sh
planet orders create request-1.json
```

The output of that command is the JSON returned from the server, that reports the status:

```json
{
  "_links": {
    "_self": "https://api.planet.com/compute/ops/orders/v2/2887c43b-26be-4bec-8efe-cb9e94f0ef3d"
  },
  "created_on": "2022-11-29T22:49:24.478Z",
  "error_hints": [],
  "id": "2887c43b-26be-4bec-8efe-cb9e94f0ef3d",
  "last_message": "Preparing order",
  "last_modified": "2022-11-29T22:49:24.478Z",
  "metadata": {
    "stac": {}
  },
  "name": "My First Order",
  "products": [
    {
      "item_ids": [
        "20220605_124027_64_242b"
      ],
      "item_type": "PSScene",
      "product_bundle": "analytic_sr_udm2"
    }
  ],
  "state": "queued"
}
```

Note the default output will be a bit more 'flat' - if you'd like the above formatting in your
command-line just use `jq` as above: `planet orders create request-1.json | jq` (but remember
if you run that command again it will create a second order).

#### Sentinel Hub Hosting

For convenience, `planet orders create` accepts the same `--hosting`, `--collection-id`, and `--create-configuration` options that [`planet orders request`](#sentinel-hub-hosting) does.

```sh
planet orders create request-1.json \
    --hosting sentinel_hub \
    --collection-id ba8f7274-aacc-425e-8a38-e21517bfbeff
```

```sh
planet orders create request-1.json \
    --hosting sentinel_hub \
    --create-configuration
```

### Create Request and Order in One Call

Using a unix command called a 'pipe', which looks like `|`, you can skip the step of saving to disk,
passing the output of the `orders request` command directly to be the input of the `orders create`
command:

```sh
planet orders request --item-type PSScene --bundle analytic_sr_udm2 --name 'Two Item Order' \
20220605_124027_64_242b,20220605_124025_34_242b | planet orders create -
```

The Planet CLI is designed to work well with piping, as it aims at small commands that can be
combined in powerful ways, so you’ll see it used in a number of the examples.

### Download an order

To download all files in an order you use the `download` command:

```sh
planet orders download 65df4eb0-e416-4243-a4d2-38afcf382c30
```

Note this only works when the order is ready for download. To do that you can
keep running `orders get` until the `state` is `success`. Or for a better
way see the next example.

### Wait then download an order

The `wait` command is a small, dedicated command that polls the server to
see if an order is ready for downloading, showing the status. It’s not
so useful by itself, but can be combined with the `download` command to
only start the download once the order is ready:

```sh
planet orders wait 65df4eb0-e416-4243-a4d2-38afcf382c30 \
&& planet orders download 65df4eb0-e416-4243-a4d2-38afcf382c30
```

This uses the logical AND operator (`&&`) to say "don't run the second command
until the first is done".

### Save order ID

You can also use a unix variable to store the order id of your most recently placed order,
and then use that for the wait and download commands:

```sh
orderid=$(planet orders list --limit 1 | jq -r .id)
planet orders wait $orderid
planet orders download $orderid
```

This can be nicer than copying and pasting it in.

You could also save the id right when you place the order:

```sh
orderid=`planet orders create request-1.json | jq -r .id`
```

To check the current value of `orderid` just run `echo $orderid`.

### Create an order and download when ready

You can then combine these all into one call, to create the order and
download it when it’s available:

```sh
id=`planet orders create request-1.json | jq -r '.id'` && \
    planet orders wait $id && planet orders download $id
```

### Download to a different directory

You can use the `--directory` flag to save the output to a specific directory. This
call saves it to a directory called `psscene`, at whatever location you are at
currently:

```sh
mkdir psscene
planet orders download 782b414e-4e34-4f31-86f4-5b757bd062d7 --directory psscene
```

You can also specify absolute directories (in this case to my desktop):

```sh
planet orders download \
    782b414e-4e34-4f31-86f4-5b757bd062d7 \
    --directory /Users/cholmes/Desktop/
```

### Verify checksum

The `--checksum` command will do an extra step to make sure the file you got
wasn't corrupted along the way (during download, etc). It checks that the bytes
downloaded are the same as the ones on the server. By default it doesn't show
anything if the checksums match.

```sh
planet orders download 782b414e-4e34-4f31-86f4-5b757bd062d7 --checksum MD5
```

This command isn't often necessary in single download commands, but is quite
useful if you are downloading thousands of files with a script, as the likelihood
of at least one being corrupted in creases

## Tools with orders

Now we’ll dive into the variety of ways to customize your order. These can all be
combined with all the commands listed above.

### Clipping

The most used tool is the `clip` operation, which lets you pass a geometry to the
Orders API and it creates new images that only have pixels within the geometry you
gave it. The file given with the `--clip` option should contain valid [GeoJSON](https://geojson.org/).
It can be a Polygon geometry, a Feature, or a FeatureClass. If it is a FeatureClass,
only the first Feature is used for the clip geometry.

Example: `geometry.geojson`
```
{
    "geometry":
    {
        "type": "Polygon",
        "coordinates":
        [
            [
                [
                    -48.4974827,
                    -1.4967008
                ],
                [
                    -48.4225714,
                    -1.4702869
                ],
                [
                    -48.3998028,
                    -1.4756259
                ],
                [
                    -48.4146752,
                    -1.49898376
                ],
                [
                    -48.4737304,
                    -1.5277508
                ],
                [
                    -48.4974827,
                    -1.4967008
                ]
            ]
        ]
    }
}
```

We’ll work with a geojson that is already saved. You should download the
[geometry](https://raw.githubusercontent.com/planetlabs/planet-client-python/main/docs/cli/request-json/geometry.geojson)
(and you can see it [on github](https://github.com/planetlabs/planet-client-python/blob/main/docs/cli/request-json/geometry.geojson)
or it is also stored in the repo in the [request-json/](request-json/) directory.

You can move that geometry to your current directory and use the following command, or
tweak the geometry.geojson to refer to where you downloaded it.

```sh
planet orders request \
    --item-type PSScene \
    --bundle analytic_sr_udm2 \
    --clip geometry.geojson \
    --name clipped-geom \
    20220605_124027_64_242b \
    | planet orders create -
```

### Additional Tools

Since clip is so heavily used it has its own dedicated command in the CLI. All
the other tools use the `--tools` option, that points to a file. The file should
contain JSON that follows the format for a toolchain, the "tools" section of an order.
The toolchain options and format are given in
[Creating Toolchains](https://developers.planet.com/apis/orders/tools/#creating-toolchains).

Example: `tools.json`
```
[
    {
        "toar": {
            "scale_factor": 10000
        }
    },
    {
        "reproject": {
            "projection": "WGS84",
            "kernel": "cubic"
        }
    },
    {
        "tile": {
            "tile_size": 1232,
            "origin_x": -180,
            "origin_y": -90,
            "pixel_size": 2.7056277056e-05,
            "name_template": "C1232_30_30_{tilex:04d}_{tiley:04d}"
        }
    }
]
```

!!!note Note
    Future of the versions of the CLI will likely add `tools` convenience methods,
    so composite, harmonize and other tools work like `--clip`. You can follow issue
    [#601](https://github.com/planetlabs/planet-client-python/issues/601):
    comment there if you'd like to see it prioritized

### Compositing

Ordering two scenes is easy, just add another id:

```sh
planet orders request \
    --item-type PSScene \
    --bundle analytic_sr_udm2 \
    --name 'Two Scenes' \
    20220605_124027_64_242b,20220605_124025_34_242b \
    | planet orders create -
```

And then you can composite them together, using the 'tools' json. You can
use this, just save it into a file called [tools-composite.json](https://raw.githubusercontent.com/planetlabs/planet-client-python/main/docs/cli/request-json/tools-composite.json).

```json
[
    {
      "composite": {
        }
    }
]
```

Once you’ve got it saved you call the `--tools` flag to refer to the JSON file, and you
can pipe that to `orders create`.

```sh
planet orders request \
    --item-type PSScene \
    --bundle analytic_sr_udm2 \
    --name 'Two Scenes Composited' \
    20220605_124027_64_242b,20220605_124025_34_242b \
    --no-stac \
    --tools tools-composite.json \
    | planet orders create -
```

Note that we add the `--no-stac` option as [STAC Metadata](#stac-metadata) is not yet supported by the composite
operation, but STAC metadata is requested by default with the CLI.

### Output as COG

If you'd like to ensure the above order is a Cloud-Optimized Geotiff then you can request it
as COG in the file format tool.

```json
[
    {
    "file_format": {
        "format": "COG"
      }
    }
]
```

The following command just shows the output with [tools-cog.json](https://raw.githubusercontent.com/planetlabs/planet-client-python/main/docs/cli/request-json/tools-cog.json):

```sh
planet orders request \
    --item-type PSScene \
    --bundle analytic_sr_udm2 \
    --name 'COG Order' \
    20220605_124027_64_242b,20220605_124025_34_242b \
    --tools tools-cog.json
```

As shown above you can also pipe that output directly in to `orders create`.

### Clip & Composite

To clip and composite you need to specify the clip in the tools (instead of `--clip`), as you can
not use `--clip` and `--tools` in the same call. There is not yet CLI calls to generate the `tools.json`,
so you can just use the [following json](https://raw.githubusercontent.com/planetlabs/planet-client-python/main/docs/cli/request-json/tools-clip-composite.json):

```json
[
    {
        "composite": {}
    },
    {
        "clip": {
            "aoi": {
                "type": "Polygon",
                "coordinates": [
                    [
                        [
                            -48.492541,
                            -1.404126
                        ],
                        [
                            -48.512879,
                            -1.504392
                        ],
                        [
                            -48.398017,
                            -1.52127
                        ],
                        [
                            -48.380419,
                            -1.423805
                        ],
                        [
                            -48.492541,
                            -1.404126
                        ]
                    ]
                ]
            }
        }
    }
]
```

```sh
planet orders request \
    --item-type PSScene \
    --bundle analytic_sr_udm2 \
    --no-stac \
    --name 'Two Scenes Clipped and Composited' \
    20220605_124027_64_242b,20220605_124025_34_242b \
    --tools tools-clip-composite.json \
    | planet orders create -
```

One cool little trick is that you can even stream in the JSON directly with `curl`, piping it into the request:

```sh
curl -s https://raw.githubusercontent.com/planetlabs/planet-client-python/main/docs/cli/request-json/tools-clip-composite.json \
    | planet orders request \
        --item-type PSScene \
        --bundle analytic_sr_udm2 \
        --name 'Streaming Clip & Composite' \
        --no-stac \
        20220605_124027_64_242b,20220605_124025_34_242b \
        --tools - \
    | planet orders create -
```

### Harmonize

The harmonize tool allows you to compare data to different generations of satellites by radiometrically harmonizing imagery captured by one satellite instrument type to imagery captured by another. To harmonize your data to a sensor you must define the sensor you wish to harmonize with in your `tools.json`. Currently, only "PS2" (Dove Classic) and "Sentinel-2" are supported as target sensors. The Sentinel-2 target only harmonizes PSScene surface reflectance bundle types (`analytic_8b_sr_udm2`, `analytic_sr_udm2`). The PS2 target only works on analytic bundles from Dove-R (`PS2.SD`).

```json
[
  {
    "harmonize": {
      "target_sensor": "Sentinel-2"
      }
    }
]
```

You may create an order request by calling [`tools-harmonize.json`](https://raw.githubusercontent.com/planetlabs/planet-client-python/main/docs/cli/request-json/tools-harmonize.json) with `--tools`.

```sh
planet orders request --item-type PSScene --bundle analytic_sr_udm2 --name 'Harmonized data' 20200925_161029_69_2223 --tools tools-harmonize.json
```

## More options

### STAC Metadata

A relatively recent addition to Planet’s orders delivery is the inclusion of [SpatioTemporal Asset Catalog](https://stacspec.org/en)
(STAC) metadata in Orders. STAC metadata provides a more standard set of JSON fields that work with
many GIS and geospatial [STAC-enabled tools](https://stacindex.org/ecosystem). The CLI `orders request` command currently requests
STAC metadata by default, as the STAC files are small and often more useful than the default JSON metadata.
You can easily turn off STAC output request with the `--no-stac` command:

```sh
planet orders request \
    --item-type PSScene \
    --bundle visual \
    --name 'No STAC' \
    --no-stac \
    20220605_124027_64_242b
```

Currently this needs to be done for any 'composite' operation, as STAC output from composites is not yet
supported (but is coming). You can explicitly add `--stac`, but it is the default, so does not need to
be included. For more information about Planet’s STAC output see the [Orders API documentation](https://developers.planet.com/apis/orders/delivery/#stac-metadata).

Orders with Google Earth Engine delivery will force the STAC flag to false.

### Cloud Delivery

Another option is to deliver your orders directly to a cloud bucket, like AWS S3 or Google Cloud Storage.
The file given with the `--delivery` option should contain JSON that follows
the options and format given in
[Delivery to Cloud Storage](https://developers.planet.com/docs/orders/delivery/#delivery-to-cloud-storage).

An example would be:

Example: `delivery.json`

```json
{
    "amazon_s3": {
        "aws_access_key_id": "aws_access_key_id",
        "aws_secret_access_key": "aws_secret_access_key",
        "bucket": "bucket",
        "aws_region": "aws_region"
    },
    "archive_type": "zip"
}
```

*New in 2.1*

!!! note

    `--cloudconfig` was the name of this option in version 2.0 and can continue to be used as an alias for `--delivery`.

### Using Orders output as input

One useful thing to note is that the order JSON that reports status and location is a valid Orders API request.
It reports all the parameters that were used to make the previous order, but you can also use it directly as a
request. So the following call is a quick way to exactly redo a previous order request:

```sh
planet orders get <order-id> | planet orders create -
```

Realistically you'd more likely want to get a previous order and then change it in some way (new id’s, different
tools, etc.). You can remove the 'extra' JSON fields that report on status if you'd like, but the Orders
API will just ignore them if they are included in a request.

There is planned functionality to make it easy to 'update' an existing order, so you can easily grab a past order
and use the CLI to customize it.

### Basemaps Orders

One of the newer features in Planet’s Orders API is the ability to [order basemaps](https://developers.planet.com/apis/orders/basemaps/).
The CLI does not yet support a 'convenience' method to easily create the JSON - you unfortunately
can't yet use `planet orders request` to help form an orders request. But all the other CLI functionality
supports ordering basemaps through the Orders API.

You’ll need to use a full orders request JSON.

```json
{
   "name": "basemap order with geometry",
   "source_type": "basemaps",
   "order_type":"partial",
   "products": [
       {
           "mosaic_name": "global_monthly_2022_01_mosaic",
           "geometry":{
               "type": "Polygon",
               "coordinates":[
                   [
                       [4.607406, 52.353994],
                       [4.680005, 52.353994],
                       [4.680005, 52.395523],
                       [4.607406, 52.395523],
                       [4.607406, 52.353994]
                   ]
               ]
           }
      }
  ],
    "tools": [
      {"merge": {}},
      {"clip": {}}
  ]
}
```

Once you’ve got the JSON, the other commands are all the same. Use create to submit it to the API:

```sh
planet orders create basemap-order.json
```

See the status of the order you just submitted:

```sh
planet orders list --limit 1
```

Extract the ID:

```sh
planet orders list --limit 1 | jq -r .id
```

Use that ID to wait and download when it’s ready:

```sh
orderid=605b5472-de61-4563-88ae-d43417d3ed96
planet orders wait $orderid
planet orders download $orderid
```

You can also list only the orders you submitted that are for basemaps, using `jq` to filter client side:

```sh
planet orders list | jq -s '.[] | select(.source_type == "basemaps")'
```

#### Bringing it all together

The cool thing is you can combine the data and order commands, to make calls
like ordering the most recent skysat image that was published:

```sh
latest_id=$(planet data filter \
    | planet data search SkySatCollect \
        --sort 'acquired desc' \
        --limit 1 \
        --filter - \
    | jq -r .id)

planet orders request \
    --item-type SkySatCollect \
    --bundle analytic \
    --name 'SkySat Latest' \
    $latest_id \
    | planet orders create -
```

Or get the 5 latest cloud free images in an area and create an order that clips to that area, using
[geometry.geojson](data/geometry.geojson) from above:

```sh
ids=$(planet data filter --geom geometry.geojson --range clear_percent gt 90 \
    | planet data search PSScene --limit 5 --filter - \
    | jq -r .id \
    | tr '\n' ',' \
    | sed 's/.$//'
)
planet orders request \
    --item-type PSScene \
    --bundle analytic_sr_udm2 \
    --name 'Clipped Scenes' \
    $ids \
    --clip geometry.geojson \
    | planet orders create -
```

This one uses some advanced unix capabilities like `sed` and `tr`, along with unix variables, so more
properly belongs in the [CLI Tips & Tricks](cli-tips-tricks.md), but we’ll leave it here to give a taste of what’s possible.

---
title: Command-line Interface (CLI) Introduction
---

## What is a CLI?

A command-line interface (CLI) was the original way everyone interacted with computers, before
the rise of '[Graphical User Interfaces](https://en.wikipedia.org/wiki/Graphical_user_interface)' (GUI).
With a CLI everything is done with text - you type commands in with your keyboard and the
responses are all textual. For more on what a command-line is see 
[this article](https://www.techtarget.com/searchwindowsserver/definition/command-line-interface-CLI).

## Why would I use Planet’s CLI?

Planet offers a number of ways to interact with its API’s, from 
[Planet Explorer](https://developers.planet.com/docs/apps/explorer/), which is a full 
web-based GUI, to [plug-ins for QGIS](https://developers.planet.com/docs/integrations/qgis/) 
and [ArcGIS Pro](https://developers.planet.com/docs/integrations/arcgis/) for those who want
to stay in their desktop GIS environment. 

The Planet CLI offers more direct interaction with the API’s, as its commands more directly
reflect what the API’s can do. Thus it can be a great way for developers to explore what is
possible. There are also many people who do lots of their day to day work on a command-line
and find it to be faster overall, so the Planet CLI will fit right in with their workflow. 

If you’re normally a GUI user but are curious about the command-line it does offer some
advantages. Once you’re comfortable with it, the CLI can be much faster for searching and
ordering lots of data. Many workflows that take lots of clicking in a UI can be just a
few keyboard commands. And you can further 'script' together many commands, so several
operations can be customized as one or two commands. So using a CLI can be a nice halfway
point between a full programming language and a GUI, offering a lot of power but without
having to become a programmer.

With Planet most new capabilities start in the API, and then the CLI often gets updated
before things are available in the UI’s. 

## How do I get started?

There are a couple main ways to get started, depending on how you like to learn. One way
is to just jump from here into all the examples in the [CLI for Data API Tutorial](cli-data.md)
and then the [CLI for Orders API Tutorial](cli-orders.md). You’ll quickly be able to get 
some results and start to get a feel for how things work, even if the exact commands make
less sense. Or you can continue in this document, and learn a bit more of the background
to understand what’s going on in the text you’re typing in. Or feel free to jump around
between the two.

### Complete Beginners

If you have never used a command-line interface before, we recommend learning some of the
basics before diving in here. One great place to start is the 
[Learn Enough Command Line to Be Dangerous](https://www.learnenough.com/command-line-tutorial),
but there are other options as well. Just be sure you are comfortable navigating through
different directories and modifying files, and the rest of this guide should teach you 
enough to understand Planet’s CLI.

## Core Unix Concepts

There are a few key CLI concepts that are worth understanding in order to get the most
out of Planet’s CLI. These are all built into any unix command-line, including Linux and 
the Mac terminal. If you’re on Windows you can use 
[Windows Subsytem for Linux](https://docs.microsoft.com/en-us/windows/wsl/about)
or [Cygwin](https://www.cygwin.com/).

### Piping & Redirection

Several commands in the Planet CLI are used to create files that are used as input to 
other commands. The default of these commands is to just print the output on your screen.
Seeing it on the screen can be useful for making sure it’s right, but you’ll most likely
want to make use of it. This is where the concept of ’redirection' comes in. If you use the 
`>` character and then specify a file name the command-line will save its output to that file.
So if you say:

```
 planet data filter --range cloud_percent lt 10 > filter.json
```

Then the output will be saved. This output is referred to as STDOUT, or 'standard output'. 
There is much more in this vein that you can do, like use `>>` to append to an existing
file, or `<` to send what’s in the file as input for a command. 

One of the most powerful concepts that we use extensively in the Planet CLI is 'piping'. 
The `|` is the pipe symbol, and it’s a special command that lets you pass the output from
one command to be the input for the next one. So instead of having to save to a file and
then referring to it you can just do it all in one call:

```
planet data filter --range cloud_percent lt 10 | planet data search PSScene --filter -
```

The pipe says to take the output of the first command and pass it to the input of 
the second. You’ll notice that the planet command has a dash (`-`), this is a convention
that is often used by different CLI programs to explicitly say ’read from
standard out'. Using the dash to mean
’read from standard out' is a general convention used by many programs, but it’s 
not universal, so check the docs of the program you’re using as to how it reads 
from piped input. For example GDAL/OGR uses a specific `/vsistdin/` convention to 
read from a pipe.

If you'd like to learn more about these topics then check out 
[this tutorial](https://ryanstutorials.net/linuxtutorial/piping.php). And if you'd
like to learn more about the dash (`-`) see 
[this tutorial](https://www.baeldung.com/linux/dash-in-command-line-parameters).

### Logical AND operator

Another command that is used in common Planet CLI is the `&&` command, which 
you put between two commands to say that the second command should only execute
when the first one is complete. It is used in `orders` to 
[wait and download](cli-orders.md#wait-then-download-an-order), so that the CLI
doesn't call the download command until the order is actually ready. 

### Variables

One of the more powerful constructs you can do in command-line environments is
to set and retrieve 'variables'. This starts you to get into true programming,
where you are saving values that you can retrieve at any time. This is often
useful with Planet’s CLI, especially in workflows that move between multiple 
different commands. You can find an introduction to variables and some powerful
constructs in this [tutorial](https://www.shellscript.sh/variables1.html).


### Running a command within another

While piping can take you quite far, there are some situations where it doesn't
quite handle exactly what you want. In many command-lines you can use the 
\` characters to wrap a set of commands that run. This is commonly done to set
variables like

```console
orderid=`planet orders list --limit 1 | jq -r .id`
```

## JQ

All of Planet’s API’s use [JSON](https://www.json.org/json-en.html) as their
main interchange format. So one of the most useful command-line tools is 
[`jq`](https://stedolan.github.io/jq/), which is a 'lightweight and 
flexible command-line JSON processor.' This allows you to easily manipulate
the output, searching through results and transforming them. You can see it 
used in the example above to extract just the order ID from the full orders API
JSON response. It also makes the default CLI output of any JSON much prettier, 
so throwing `| jq` at the end of any command returning JSON will be much more
readable. 

Check out https://ente.io/blog/tech/jq-diff/ for a decent tutorial - suggestions
for any betters ones appreciated!

## cURL

Another incredibly powerful and useful tool is [cURL](https://curl.se/). It’s 
the key tool to make any HTTP request from the command-line. There’s a good
[hands-on introduction](https://www.freecodecamp.org/news/how-to-start-using-curl-and-why-a-hands-on-introduction-ea1c913caaaa/)
from freeCodeCamp. 

## sed

One final tool worth mentioning is [`sed`](https://www.gnu.org/software/sed/manual/sed.html)
which lets you edit any text stream. While `jq` is focused on JSON, `sed`
can handle any string, and its used a few times to help further process
piped output.

## Collecting Results with `planet collect`

The final tool worth mentioning is part of the `planet` CLI, but is fairly
generic functionality that can be used with any command-line JSON output.

Some API calls, such as searching for imagery and listing orders, return a
varying, and potentially large, number of results. These API responses are
paged. The SDK manages paging internally and the associated CLI commands
output the results as a sequence. These results can be converted to a JSON blob
using the `collect` command. When the results
represent GeoJSON features, the JSON blob is a GeoJSON FeatureCollection.
Otherwise, the JSON blob is a list of the individual results.

```console
planet data search PSScene | planet collect -
```

This gives you a fully compliant GeoJSON FeatureCollection, which is 
understood by many more programs than the default 
[newline-delimited GeoJSON](https://stevage.github.io/ndgeojson/). 

# Design

## Overview

This document outlines the high-level design that informs the development of
the Planet SDK for Python.

## Scope

The scope of this package is to provide a low-level Python API and CLI for
Planet’s services. Commands map close to 1:1 with service APIs and all service
operations are supported.

## Principles

### Interface

The principles of the interface design, ordered according to priority, are:
* Map the API names and endpoints as close as possible
* Synchronoize the Python API and CLI
* Adhere to command line design in:
  * Popular SDKs (aws and gcloud)
  * The geospatial toolset (gdal, rasterio)
  * GNU standards
* Support JSON in stdin/stdout

### Implementation

The principles of the implementation design, in no particular order, are:

* Auto-generate as much as possible from the API specifications
* The CLI is a thin wrapper around the Python API
* Python API is asynchronous, CLI is synchronous

## Errors

### API Exceptions

Exception hierarchy:
 - Every exception inherits from the base exception, `PlanetError`.
 - All client-side exceptions are raised as `ClientError`.
 - All server-side errors are raised as specific exceptions based on the
http code. They all inherit from `APIError` and contain the unedited server
error message.

### CLI Return Codes

The following are the values and descriptions of all return codes
that can be returned at the end of running a Planet CLI command.

| Value | Description |
| ----------- | ----------- |
| 0 | Command was run successfully. |
| 1 | An error occured while the command was running. |
| 2 | Command was not run due to invalid syntax or unknown or invalid parameter.|

# Authentication with the SDK

## Overview
The [`planet.Auth`](../../python/sdk-reference/#planet.auth.Auth) class is the
main class that is responsible for managing how clients built with the SDK
authenticate to the Planet Insights Platform API services.  By default,
API clients provided by the SDK will create an `Auth` instance that is connected
to login sessions managed by the [`planet auth`](../../cli/cli-reference/#auth)
CLI utility, with state saved to the `.planet.json` file and `.planet`
directory in the user's home directory.

When applications require more control over the authentication process,
constructor methods on the [`planet.Auth`](../../python/sdk-reference/#planet.auth.Auth)
class may be used to create instances with specific configurations.
`Auth` instances may then be wrapped in [`planet.Session`](../../python/sdk-reference/#planet.http.Session)
objects so they can be attached to the
[`planet.Planet`](../../python/sdk-reference/#planet.client.Planet) synchronous
client, or various [asynchronous API clients](../../python/async-sdk-guide/) provided by the SDK.

## Configuration

When determining how to authenticate requests made against the Planet
APIs, the default behavior of the SDK and the Planet CLI is to load
configuration from a number of sources at runtime:

- Highest priority is given to arguments passed to the [`Auth`](../../python/sdk-reference/#planet.auth.Auth)
  class (when using the SDK) or via the command line (when using the CLI).
  When saving preferences using the CLI, configuration is saved to
  configuration files (below).
- Next, environment variables are checked.
  Of these, `PL_API_KEY` has been used by Planet software for many years,
  and is the most likely to be set in a user's environment.
  The other environment variables are new to version 3 of the Planet Python SDK.
  **Note**: This means that environment variables override configuration
  saved by the `planet` CLI program.  See [Environment Variables](#environment-variables)
  below.
- Then, the configuration file `.planet.json` and files underneath
  the `.planet` directory in the user's home directory are consulted.
  These configuration files may be managed with the
  [`planet auth profile`](../../cli/cli-reference/#profile) CLI command.
- Finally, built-in defaults will be used.

### Environment Variables
When the SDK is not otherwise explicitly configured by an application,
or behavior is not overridden by command-line arguments, the following
environment variables will be used:

| Variable                    | Description                                                                                                                   |
|-----------------------------|-------------------------------------------------------------------------------------------------------------------------------|
| **`PL_AUTH_PROFILE`**       | Specify a custom CLI managed auth client profile by name.  This must name a valid CLI managed profile or an error will occur. |
| **`PL_AUTH_CLIENT_ID`**     | Specify an OAuth2 M2M client ID.  `PL_AUTH_CLIENT_SECRET` must also be specified, or this will be ignored.                    |
| **`PL_AUTH_CLIENT_SECRET`** | Specify an OAuth2 M2M client secret. `PL_AUTH_CLIENT_ID` must also be specified, or this will be ignored.                     |
| **`PL_AUTH_API_KEY`**       | Specify a legacy Planet API key.                                                                                              |

When multiple conflicting environment variables are set, `PL_AUTH_PROFILE` is
preferred over `PL_AUTH_CLIENT_ID` and `PL_AUTH_CLIENT_SECRET`, which are
preferred over `PL_AUTH_API_KEY`.

### Reset User Configuration
The following commands may be used to clear an environment of any
previously configured settings:

```sh title="Clear saved authentication settings"
unset PL_API_KEY
unset PL_AUTH_PROFILE
unset PL_AUTH_CLIENT_ID
unset PL_AUTH_CLIENT_SECRET
planet auth reset
```

## Profiles
Collectively, the configuration of the SDK to use a specific authentication
protocol (see [overview](../auth-overview#authentication-protocols)) and a
working set of session state information is termed a _profile_ by the SDK 
and the CLI.  Profiles are an abstraction of the SDK and the CLI, and are 
not inherent to authentication to the Planet platform generally.

The [`planet auth profile`](../../cli/cli-reference/#profile) CLI command
is provided to manage persistent profiles and sessions in the user's home
directory. These home directory persisted profiles are shared between the CLI
and applications built using the SDK.

Applications built using the SDK may be configured to bypass home directory
profile and session storage, if this better suits the needs of the application.
See [Applicaiton Managed Sessions](../auth-dev-app-managed-oauth) for detailed
examples.

## Sessions

Before any calls can be made to a Planet API using the SDK, it is
necessary for the user to login and establish an authentication session.
Exactly how this should be done with the SDK depends on the
application's complexity and needs.

In simple cases, this may be managed external to the application
by using the [`planet auth`](../../cli/cli-reference/#auth)
command-line utility.  See [CLI Managed Sessions](../auth-dev-cli-managed)
for examples.

In more complex cases, an application may need to manage the
stored session itself independent of utilities provided by the CLI. In such
cases, the application will be responsible for instantiating a `planet.Auth`
object, initiating user login, and saving the resulting session information.
Session information may contain sensitive information such as access and
refresh tokens, and must be stored securely by the application.  Session
information will also be regularly updated during SDK operations, so the
application must handle callbacks to store updated session information.
See [Application Managed Sessions](../auth-dev-app-managed-oauth)
for examples.

### Session Persistence

Once a user login session is established using any method, the state should be
saved to secure persistent storage to allow for continued access to the Planet
platform without the need to perform the login repeatedly.  If state cannot
be persisted in the application environment, the application can operate in
in-memory mode, but will be forced to create a new login session every time the
application is run.  If the rate of repeated logins is too great, this may
result in throttling by the authorization service.  Particular attention should
be paid to this when creating automated processes that utilize service users.

The SDK provides the option to save session state in the user's
home directory in a way that is compatible with the CLI.
When [CLI Managed Sessions](../auth-dev-cli-managed) are used, no additional
steps should be required of the application developer.

The SDK also provides a way for the application to provide its own secure
storage.  Applications needing to use their own storage will do so by
providing the `Auth` layer in the SDK with a custom implementation of the
[`planet_auth.ObjectStorageProvider`](https://planet-auth.readthedocs.io/en/latest/api-planet-auth/#planet_auth.ObjectStorageProvider)
abstract base class.

----

# Contributing

Thank you for your interest in contributing to the Planet SDK for Python! This
document explains how to contribute successfully.

## Workflows

### Development

#### Development Branch

The default branch is always `main` and should be always considered in-development.  Feature enhancements, bug fixes, and other maintenance should be performed in a development branch, starting with the appropriate base branch and merged back into that branch:

```console
git checkout main
git pull
git checkout -b new-branch-name
```

#### Branch Naming

Branch names should describe the work performed within the branch, and include a ticket number if applicable.  For example, a branch that corrects typos in documentation and is not ticketed could be named `fix-documentation-typos`, and a branch that adds a new feature and is ticketed could be named `new-feature-123` (where 'new-feature' is the name of the feature and '-123' is the ticket number).

### Pull Requests

NOTE: Make sure to set the appropriate base branch for PRs. See Development Branch above for appropriate branch.

The Pull Request requirements are included in the pull request template as a list of checkboxes.

Not listed in the PR template, but enforced by the system, are the additional requirements that the PR pass Continuous Integration (CI) checks and that the PR have at least one approval by a project maintainer.

The CI checks:

* all tests on all supported versions of Python
* test coverage
* linting / formatting
* type annotation
* docs build successfully

To minimize the feedback loop, we have configured Nox so that it can be used to run all of the CI checks on the local machine. See the [Development Tools](#development-tools) section for information on running CI checks locally with Nox.

### Releasing

The release process is outlined in [RELEASE.md](RELEASE.md).

## <a name="development-tools"></a>Development Tools

This repository uses two primary tools for development:
* [Nox](https://nox.thea.codes/) to automate testing
* [YAPF](https://github.com/google/yapf) to enforce style guidelines

Install Nox in your local dev environment:

```console
    $ pip install nox
```

Install YAPF in your local dev environment:

```console
    $ pip install yapf
```

### Nox

In this repository, Nox is used to automate testing, linting, and to build
documentation. Nox manages virtual environments for you, specifying Python
versions and installing the the local, dynamic version of the Plant SDK for
Python and required development packages.

To run nox with the default sessions (same checks as CI: lint, analyze, test,
coverage, docs) type "nox".

```console
    $ nox
```

If no changes have been made to the Nox environment since it was last run,
speed up the run by reusing the environment:

```console
    $ nox -r
```

If only one test is desired, specify it with `-s`. To only run linting:

```console
$ nox -s lint
```

To determine which tests are available:

```console
    $ nox --list
```

The configuration for Nox is given in `noxfile.py`. See the Nox link above for
advanced usage.

##### Alternative to Nox
Nox is the recommended way to manage local testing. With Nox it is not necessary
to install the Planet SDK for Python on the local machine for testing.
However, Nox is not necessary for local testing. Where Nox is not used, a
virtual environment is highly recommended.
[pyenvwrapper](https://github.com/pyenv/pyenv-virtualenv) manages virtual
environments and works well with pyenv. To install the local, dynamic version
of the Planet SDK for Python and required development packages into the virtual
environment use:

```console
    $ pip install -e .'[dev]'
```

### YAPF

Code in this repository follows the
[PEP8](https://www.python.org/dev/peps/pep-0008/) style guide and uses
[YAPF](https://github.com/google/yapf) to enforce and automate formatting.
Linting in Nox will fail if YAPF would reformat a portion of the code.
Helpfully, YAPF can be used to automatically reformat the code for you so you
don't have to worry about formatting issues. WIN!

To see how YAPF would reformat a file:

```console
    $ yapf --diff [file]
```

To reformat the file:

```console
    $ yapf --in-place [file]
```

These commands can be performed on the entire repository, when run from the repository root directory, with:

```console
    $ yapf --diff -r .
```

and

```console
    $ yapf --in-place -r .
```
The configuration for YAPF is given in `setup.cfg` and `.yapfignore`.
See the YAPF link above for advanced usage.

##### Alternative to YAPF

YAPF is not required to follow the style and formatting guidelines. You can
perform all formatting on your own using the linting output as a guide. Painful,
maybe, but possible!

## Testing

Installing all supported Python versions locally is recommended. This allows
Nox to fully reproduce the CI tests.
One way of achieving this is with [pyenv](https://github.com/pyenv/pyenv).
If a specific Python version isn't available on your development machine,
Nox will just skip that version in the local tests.

Testing is performed with [pytest](https://docs.pytest.org/) and
[pytest-cov](https://pytest-cov.readthedocs.io/). The configuration for these
packages is given in `setup.cfg`.

Command-line arguments can be passed to pytest within Nox. For example, to only
run the tests on a certain file, use:

```console
    $ nox -- [file]
```

By default, Nox runs tests on all supported Python versions along with other
CI checks. However, Nox can run a test on a single Python version.

To run tests on python 3.13:

```console
    $ nox -s test-3.13
```

Configuration can be passed onto pytest through Nox.

To only run tests in a specific file:

```console
    $ nox -s test3.13 -- tests/unit/test_http.py
```

Or to only run tests filtered by keyword:

```console
   $ nox -s test3.13 -- -k test__Limiter
```

## Code coverage

To measure code coverage and see a report:

```console
    $ nox -s coverage
```

## Linting

Linting is performed using [flake8](https://flake8.pycqa.org/)
and YAPF (mentioned above). By default, Nox runs the lint check along with
all other CI checks. However, Nox can run just the linting check.

To run lint check:

```console
    $ nox -s lint
```

## Static code analysis

The project uses [mypy](https://mypy.readthedocs.io/en/stable/) for static
analysis of code. Mypy checks for correctness of type hints and can find other
type-related bugs. The nox session that calls mypy is named analyze.

```console
    $ nox -s analyze
```

## <a name="documentation"></a> Documentation

Documentation is built from Markdown files in the `docs` directory using
[MkDocs](https://www.mkdocs.org/) according to `mkdocs.yml`. The API reference
is auto-populated from code docstrings. These docstrings must be in the
[google format](https://mkdocstrings.github.io/handlers/python/#google-style)
(note: we use `Parameters` in our docstrings).

By default, Nox builds the docs along with other CI checks. However, Nox can
also be used to only build the docs or to build and serve the docs locally
to assist documentation development.

To build the documentation:

```console
    $ nox -s docs
```

To build and host an automatically-updated local version of the documentation:

```console
    $ nox -s watch
```

Copy the local url from the console output and paste it into your browser to view the live rendered docs.

In addition to verifying that the documentation renders correctly locally,
the accuracy of the code examples must be verified. See Testing Documentation
below.


### Testing Documentation

NOTE: Doc tests need to be reworked and are failing. See
[#275](https://github.com/planetlabs/planet-client-python/issues/275).

There are many code examples written into the documentation that need to be
tested to ensure they are accurate. These tests are not run by default because
they communicate with the Planet services, and thus are slower and also could
incur usages.

To test the documentation, run the Nox `docs_test` session:

```console
    $ nox -s docs_test
```

This will test all code examples in Markdown documents.
To only test one document:

```console
    $ nox -s docs_test -- <document_name>.md
```

### Testing Examples

The `examples` directory is populated with many helpful examples of how to
use the Planet SDK for Python in real use cases. These examples also need to
be tested to ensure they are accurate. These tests are not run by default
because they are long and communicate with the Planet services; and thus are
very slow and also could incur usages.

To test the examples, run the Nox `examples` session:

```console
    $ nox -s examples
```

This will test all scripts within the `examples` directory.
To only test one script:

```console
    $ nox -s examples -- <script_name>.py
```

For more information on developing examples, see the examples
[README.md](examples/README.md)

# Orders Command-Line Interface Specification

This document lays out the command-line interface to interact with the Planet
[Orders API](https://developers.planet.com/docs/orders/).

## list

### Interface

Usage: planet orders list [OPTIONS]

  List orders

  This command outputs a sequence of the returned order descriptions. If --pretty is specified, each order description is pretty-printed.

Options:
  --state CHOICE   Filter orders to given state.
  --limit INTEGER  Maximum number of results to return. Default is 100. A
                   value of 0 means no maximum.
  --pretty         Format JSON output.
  --help           Show this message and exit.


### Usage Examples

User Story: As a CLI user I would like to get a json blob that describes up to the last 100 of my orders so that I can use jq to get their dates.

```
$ planet orders list
```
```
{"_links": …}
{"_links": …}
{"_links": …}
…
```

User Story: As a CLI user I would like to get a json blob that describes all of my orders so that I can use jq to get their dates.
```
$ planet orders list --limit 0
```
```
{"_links": …}
{"_links": …}
{"_links": …}
…
```

User Story: As a CLI user I would like to get a json blob that describes my last 5 successful orders so that I can use jq to get their order dates.
```
$ planet orders list --state success --limit 1
```
response (pretty-printed)
```
{
  "_links": {
    "_self": "https://api.planet.com/compute/ops/orders/v2/193e5bd1-dedc-4c65-a539-6bc70e55d928"
  },
  "created_on": "2022-05-04T01:01:57.864Z",
  "error_hints": [],
  "id": "193e5bd1-dedc-4c65-a539-6bc70e55d928",
  "last_message": "Manifest delivery completed",
  "last_modified": "2022-05-04T01:09:36.037Z",
  "name": "test",
  "products": [
    {
      "item_ids": [
        "20210821_161925_80_2453"
      ],
      "item_type": "PSScene",
      "product_bundle": "visual"
    }
  ],
  "state": "success"
}
```

## get

### Interface
Usage: planet orders get [OPTIONS] ORDER_ID

  Get order

  This command outputs the order description, optionally pretty-printed.

Options:  
  --pretty  Format JSON output.



### Usage Examples

User Story: As a CLI user I would like to get a json blob that describes a
certain order so I can determine its status.

```
$ planet orders get 193e5bd1-dedc-4c65-a539-6bc70e55d928
{"_links": …}
```
response (pretty-printed)

**Note the `results` key in the `_links` section is present here but was not
a part of the response from `planet orders list`**
```
{
  "_links": {
    "_self": "https://api.planet.com/compute/ops/orders/v2/193e5bd1-dedc-4c65-a539-6bc70e55d928",
    "results": [
      {
        "delivery": "success",
        "expires_at": "2022-06-30T02:57:15.492Z",
        "location": "https://api.planet.com/compute/ops/download/?token={TOKEN}",
        "name": "193e5bd1-dedc-4c65-a539-6bc70e55d928/manifest.json"
      },
      {
        "delivery": "success",
        "expires_at": "2022-06-30T02:57:15.495Z",
        "location": "https://api.planet.com/compute/ops/download/?token={TOKEN}",
        "name": "193e5bd1-dedc-4c65-a539-6bc70e55d928/PSScene/20210821_161925_80_2453_metadata.json"
      },
      {
        "delivery": "success",
        "expires_at": "2022-06-30T02:57:15.498Z",
        "location": "https://api.planet.com/compute/ops/download/?token={TOKEN}",
        "name": "193e5bd1-dedc-4c65-a539-6bc70e55d928/PSScene/20210821_161925_80_2453_3B_Visual.tif"
      }
    ]
  },
  "created_on": "2022-05-04T01:01:57.864Z",
  "error_hints": [],
  "id": "193e5bd1-dedc-4c65-a539-6bc70e55d928",
  "last_message": "Manifest delivery completed",
  "last_modified": "2022-05-04T01:09:36.037Z",
  "name": "test",
  "products": [
    {
      "item_ids": [
        "20210821_161925_80_2453"
      ],
      "item_type": "PSScene",
      "product_bundle": "visual"
    }
  ],
  "state": "success"
}

```

## cancel

### Interface

Usage: planet orders cancel [OPTIONS] ORDER_ID

  Cancel order

  This command outputs the cancelled order details, optionally pretty-printed.

Options:  
  --pretty  Format JSON output.


### Usage Examples
User Story: As a CLI user I would like to cancel a certain order.

```
$ planet orders cancel 65df4eb0-e416-4243-a4d2-38afcf382c30
{"_links": …}
```

## wait

### Interface
Usage: planet orders wait [OPTIONS] ORDER_ID

  Wait for order to reach the desired state.

  Polls the service for order status and completes when the order has reached
  the desired state. By default, the desired state is any completed state.
  This can be overridden to any order state with the --state option. The
  polling period is one second, this can be overridden with the --period
  option.

  This command outputs the order details at the end of the wait, optionally
  pretty-printed.

Options:  
  --state TEXT   Stop waiting when order reaches this state  
  --period TEXT  Duration of time for one polling cycle, in seconds.  
  --pretty       Format JSON output.  


### Usage Examples

User Story: As a CLI user I would like to wait for an order to be ready for
download so I can send a message to another machine to do the download.

`$ planet orders wait 65df4eb0-e416-4243-a4d2-38afcf382c30`

User Story: As a CLI user I would like to wait for an order to be ready for
download and then I would like to download the order.

```
$ planet orders wait 65df4eb0-e416-4243-a4d2-38afcf382c30 \
&& planet orders download 65df4eb0-e416-4243-a4d2-38afcf382c30
```

User Story: As a CLI user I would like to create an order, wait for it to be
ready to download, then download the order.

```
$ id=`planet orders create request-1.json | jq -r '.id'` \
&& planet orders wait $id && planet orders download $id
<ANSI download status reporting>
```


## download


### Interface


Usage: planet orders download [OPTIONS] ORDER_ID

  Download order

  If --checksum is provided, the associated checksums given in the manifest
  are compared against the downloaded files to verify that they match.

Options:
  --checksum [MD5|SHA1]  Verify that checksums match.
  --directory DIRECTORY  Base directory for file download.
  --overwrite            Overwrite files if they already exist.
  --help                 Show this message and exit.


### Usage Examples

User Story: As a CLI user I would like to download an order to the current
directory for local processing.

Basic usage:

```
$ planet orders download 49b8d32e-2fba-4924-bd38-f7344aa48d91
<ANSI download status reporting>
```

User Story: As a CLI user I would like to download an order without ANSI reporting

```
$ planet –quiet orders download 49b8d32e-2fba-4924-bd38-f7344aa48d91
```

User Story: As a CLI user I would like to download an order to a custom
directory to support local file organization.

```
$ planet orders download \
--directory data \
49b8d32e-2fba-4924-bd38-f7344aa48d91
<ANSI download status reporting>
```

User Story: As a CLI user I would like to download an order, overwriting the
files if they exist to fix any corrupted files.

```
$ planet orders download \
--overwrite \
49b8d32e-2fba-4924-bd38-f7344aa48d91
<ANSI download status reporting>
```

User Story: As a CLI user I would like to download an order and check the md5
checksums against the manifest to ensure that no files are corrupt.

```
$ planet orders download \
--checksum md5 \
49b8d32e-2fba-4924-bd38-f7344aa48d91
<ANSI download status reporting>
<Error if check fails>
```

## create


### Interface

Usage: planet orders create [REQUEST]

  Create an order.

This command creates an order from an order request. It outputs the created order description, optionally pretty-printed.

REQUEST is the full description of the order to be created. It must be JSON
and can be specified a json string, filename, or '-' for stdin.
It defaults to reading from stdin.

Options:
  -pp, --pretty     Format JSON output.

### Usage Examples

User Story: As a CLI user I would like to create an order from a file.

```
$ planet orders create order_request.json
{"_links": …}
```

User Story: As a CLI user I would like to create an order from stdin.

```
$ cat order_request.json | planet orders create
{"_links": …}
```

User Story: As a CLI user I would like to duplicate an order.

```
$ planet orders get 65df4eb0-e416-4243-a4d2-38afcf382c30 | planet orders create
{"_links": …}
```

## request

### Interface

Usage: planet orders request NAME BUNDLE ITEM_TYPE IDS

NAME: Order name. Does not need to be unique.
BUNDLE: Product bundle.
ITEM_TYPE: Item Type.
IDS: One or more comma-separated item IDs.

Generate an order request.

This command builds an order description for use in creating an order. It
outputs the order request, optionally pretty-printed.

Support for building an order description is provided however it
has many limitations compared to what the Orders API supports. For creation
of more advanced order requests, create the order description manually or
use the Python library to aid in creating the order description.

Note that only one of --clip or --tools can be specified.

Options:

  --clip JSON        -              Clip feature GeoJSON. Can be a json string,
                                  filename, or '-' for stdin.
  --tools JSON         -           Toolchain JSON. Can be a json string,
                                  filename, or '-' for stdin.
  --email BOOLEAN         -          Send email notification when order is
                                  complete.
  --cloudconfig JSON     -         Credentials for cloud storage provider to
                                  enable cloud delivery of data. Can be a json
                                  string, filename, or '-' for stdin.
  --pretty                -        Format JSON output.


### Usage Examples

User Story: As a CLI user I would like to create a request for a basic order for
multiple scenes.

```
$ planet orders request test_order PSScene analytic_sr \
    20200922_183724_23_106a,20200922_183722_17_106a
```

User Story: As a CLI user I would like to create a request for an order with
email notification.

```
$ planet orders request test_order PSScene analytic_sr \
  20200922_183724_23_106a,20200922_183722_17_106a \
  –-email
```

NOT UPDATED BELOW

User Story: As a CLI user I would like to create a request for an order which
clips the scenes to a geojson geometry specified in a file.

```
$ planet orders request test_order PSScene analytic_sr \
    20200922_183724_23_106a,20200922_183722_17_106a \
    --clip aoi.geojson

{"name":"test_order",...}
```

User Story: As a CLI user I would like to create an order which clips the scenes
to a geojson geometry entered on the command line.

```
$ planet orders request test_order PSScene analytic_sr \
    20200922_183724_23_106a,20200922_183722_17_106a \
    --clip - < aoi.geojson

{"name":"test_order",...}
```

User Story: As a CLI user I would like to create a request for an order with a
toolchain specified in a file. NOTE: --tools and --clip cannot both be used.

```
$ planet orders request test_order PSScene analytic_sr \
    20200922_183724_23_106a,20200922_183722_17_106a \
    --tools tools.json

{"name":"test_order",...}
```

User Story: As a CLI user I would like to create a request for an order with a
cloud configuration specified in a file.

```
$ planet orders request test_order PSScene analytic_sr \
    20200922_183724_23_106a,20200922_183722_17_106a \
    --cloudconfig cloudconfig.json

{"name":"test_order",...}
```

## request-update

It is a common use case to want to create an order that is just slightly
different from another order. Maybe the order has the same toolchain but just
new ids. Maybe the order has the same ids but just a different clip AOI. It
would be nice to just update the old order request with the new information
instead of having to start from scratch.

Making this its own command frees the `request` command from having a ton of
required options, which are a bit annoying from a user's perspective.


### Interface

Usage: planet orders request-update [OPTIONS] REQUEST

REQUEST: order request to be updated. Can be string, filename, or '-' for stdin.

Update an order request.

This command creates a new order description from an existing order description,
with certain entries changed according to the options specified. It outputs the
updated order request, optionally pretty-printed.

Support for updating an order description is provided however it
has many limitations compared to what the Orders API supports. For creation
of more advanced order requests, create the order description manually or
use the Python library to aid in creating the order description.

Note that if the order description contains a tool chain with more tools
than just clip, using --clip will override the entire tool chain, not just
the clip tool.

Options:

  --clip JSON        -              Clip feature GeoJSON. Can be a json string,
                                  filename, or '-' for stdin.
  --tools JSON         -           Toolchain JSON. Can be a json string,
                                  filename, or '-' for stdin.  
  --email BOOLEAN         -          Send email notification when order is
                                  complete.
  --cloudconfig JSON     -         Credentials for cloud storage provider to
                                  enable cloud delivery of data. Can be a json
                                  string, filename, or '-' for stdin.  
  --pretty                -        Format JSON output.

### Usage Examples

To create an order using an order id and override the item IDs:

```
$ planet orders get 49b8d32e-2fba-4924-bd38-f7344aa48d91 | \
  planet orders request-update \
  --id 20200922_183724_23_106a,20200922_183722_17_106a -
```
  To create an order using an order id and clip to an AOI:
```
$ planet orders get 49b8d32e-2fba-4924-bd38-f7344aa48d91 | \
  planet orders request-update --clip aoi.geojson -
```

User Story: As a CLI user I would like to create a request for an order from a
template, overriding the name.

```
$ planet orders request-update --name IAmACopy -  < request.json
```

User Story: As a CLI user I would like to create a new order that is just like
an order that has already been submitted but has an updated name.

```
$ planet orders get 49b8d32e-2fba-4924-bd38-f7344aa48d91 | \
planet orders request-update --name IAmACopy - 
```

---
title: CLI Reference
---

This page provides documentation for our command line tools.

{% raw %}
::: mkdocs-click
    :module: planet.cli.cli
    :command: main 
    :prog_name: planet
    :depth: 1
{% endraw %}

---
title: CLI for Data API Tutorial
---

## Introduction

The `planet data` CLI commands enable interaction with the [Data API](https://developers.planet.com/docs/apis/data/),
which lets you search Planet’s catalog (including select public datasets like Sentinel 2 and Landsat 8).
Currently the CLI has focused on the core search functionality, implementing
[Quick Search](https://developers.planet.com/docs/apis/data/reference/#tag/Item-Search/operation/QuickSearch)
and [stats](https://developers.planet.com/docs/apis/data/reference/#tag/Item-Stats/operation/Stats) plus some
partial saved search functionality.

## `data search` command basics

At this point you should have completed [Step 5](../get-started/quick-start-guide.md#step-5-search-for-planet-imagery)
of the quick start guide, and run your first full data search command:

```sh
planet data search PSScene --filter filter.json > recent-psscene.json
```

This saves the descriptions of the latest 100 standard-quality scenes you have permissions to download in a file, that you can open and look at.

### Pretty printing

You will likely notice that this file is quite wide, with one very long line for each Planet 
item returned. You can make for a more readable file by using the `--pretty` flag:

```sh
planet data search --pretty PSScene --filter filter.json > recent-psscene.json
```

The `--pretty` flag is built into most of the CLI calls. But you can also achieve the
same effect by using another CLI program: `jq`. It is a very powerful library, providing
extensive manipulation of JSON, but simply
piping any JSON output through it prints it in a more readable form. So the following
command will do the same thing as the previous one:

```sh
planet data search PSScene --filter filter.json | jq > recent-psscene.json
```

You can read a bit [more about jq]((cli-intro.md#jq) in the CLI intro.

### Output to stdin

You also don't have to save the output to a file. If you don't redirect it into a file then
it will just print out on the console.

```sh
planet data search PSScene --filter filter.json
```

If you enter this command you’ll see the output stream by. Here you can use jq again, and
it’ll often give you nice syntax highlighting in addition to formatting.

```sh
planet data search PSScene --filter filter.json | jq
```

### Create filter and search in one call

Using a unix command called a 'pipe', which looks like `|`, you can skip the step of saving to disk,
passing the output of the `data filter` command directly to be the input of the `data search`
command:

```sh
planet data filter --permission --std-quality | planet data search --pretty PSScene --filter -
```

Note the dash (`-`), which explicitly tells the CLI to use the output from the call that is piped into it.

You can learn more about the pipe command, as well as the `>` command above in the 
[Piping & redirection section](cli-intro.md#piping-redirection) of the CLI Introduction.

### Search without filtering

If no filtering is required, the search command can be called directly:

```sh
planet data search PSScene
```

This outputs the last 100 scenes.


### Search on Item Type

These first searches were done on the [PSScene](https://developers.planet.com/docs/data/psscene/) 'item type', but you
can use any [Item Type](https://developers.planet.com/docs/apis/data/items-assets/#item-types) that Planet offers in 
its catalog. The item type is the first argument of the `search` command, followed by the 'filter'. Note that
you can specify any number of item types here:

```sh
planet data search PSScene,Sentinel2L1C,Landsat8L1G,SkySatCollect
```

This will search for all the most recent images captured by PlanetScope, SkySat, Sentinel 2 and Landsat 8 satellites. 
Note that you’ll likely mostly see PlanetScope results, as they generate far more individual images than the others.
The filter you specify will apply to all item types, but not all filters work against all satellites, so you may 
inadvertently filter some out if you are filtering specific properties.

### Limits

By default the `search` command returns only the 100 first scenes. But with the CLI you can set any limit, and the SDK
under the hood will automatically page through all the results from the API. 

```sh
planet data search --limit 3000 PSScene
```

Note you can also do a call with no limits if you set the limit to `0`. Though don't use this haphazardly, or you’ll be
generating a lot of JSON from your request. It’s best to use it with a number of filters to constrain the search, so
you don't get hundreds of millions of results.

### Output as valid GeoJSON

By default the output of Planet’s Data API is [newline-delimited GeoJSON](https://stevage.github.io/ndgeojson/), which
is much better for streaming. While more and more programs will understand the format, the CLI also provides 
the `planet collect` method to transform the output from the Data API to valid GeoJSON. You just pipe the end
output to it:

```sh
planet data search PSScene | planet collect -
```

If you want to visualize this you can save it as a file:

```sh
planet data search PSScene | planet collect - > planet-search.geojson
```

This you can then open with your favorite GIS program, or see this 
[geometry visualization](cli-tips-tricks.md#geometry-inputs) section for some ideas that flow a bit better with 
the command-line.

### Sort

You can also specify the sorting with your searches. The default sort is ordered by the most recent published
images. But you can also sort by `acquired`, which is often more useful. You can sort in ascending or 
descending order. The options are are:

 * 'acquired asc'
 * 'acquired desc'
 * 'published asc'
 * 'published desc'

This lets you do things like get the ID of the most recent SkySat image taken (and that you have permissions to download):

```sh
planet data search SkySatCollect --sort 'acquired desc' --limit 1
```

And you can also just get the ID, using `jq`

```sh
planet data search SkySatCollect --sort 'acquired desc' --limit 1 - | jq -r .id
```

## Filtering

### Run a search on a bounding box

Most searches you’ll likely want to run on a geometry. To try this out you can use the following bounding box
of Iowa. You can copy it and save as a file called `geometry.geojson`

```json
{
  "type": "FeatureCollection",
  "features": [
    {
      "type": "Feature",
      "properties": {},
      "geometry": {
        "type": "Polygon",
        "coordinates": [
          [
            [
              -93.7353,
              41.6236
            ],
            [
              -92.2741,
              41.6236
            ],
            [
              -92.2741,
              42.3747
            ],
            [
              -93.7353,
              42.3747
            ],
            [
              -93.7353,
              41.6236
            ]
          ]
        ]
      }
    }
  ]
}
```

!!!note ".geojson and .json files both work"
    Here we save it as .geojson, but you can also save it as .json. The CLI is happy with any file
    extension, even .txt, but different extensions may make it easier to open the files with other
    programs. What’s important is that the text inside the file is valid geojson.

And then run it with this command:

```sh
planet data filter --geom geometry.geojson | planet data search PSScene --filter -
```

Note that by default all searches with the command-line return 100 results, but you can easily increase that with
the `--limit` flag:

```sh
planet data filter --geom geometry.geojson | planet data search --limit 500 PSScene --filter -
```

Creating geometries for search can be annoying in a command-line workflow, but there are some ideas in the
[Advanced CLI Tutorial](cli-tips-tricks.md#geometry-inputs).

### Date Filter

Some of the most common filtering is by date. You could get all imagery acquired before August 2021:

```sh
planet data filter --date-range acquired lt 2021-08-01 \
    | planet data search PSScene --filter -
```

The 'operator' in this case is 'less than' (`lt`). The options are:
 * `gt` - greater than
 * `gte` - greater than or equal to
 * `lt` - less than
 * `lte` - less than or equal to

You must specify which date field you want to use, either `acquired` or `published`.

You can use the flags multiple times, and they are logically 'AND'-ed together, so you can
do a search for all images in July of 2021:

```sh
planet data filter \
    --date-range acquired gte 2021-07-01 \
    --date-range acquired lt 2021-08-01 | \
planet data search PSScene --filter -
```

The date input understands [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) and 
[ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) formats. You can specify just the date,
or include the time, to search for all Planetscope images acquired within 5 seconds at a time
on July 1st 2021:

```sh
planet data filter \
    --date-range acquired gte 2021-07-01:06:20:10 \
    --date-range acquired lt 2021-07-01:06:20:15 \
    | planet data search PSScene --filter -
```

### Range Filter

The range filter uses the same operators as the date filter, but works against any numerical property. The most useful
of these tend to be ones about cloudy pixels. For example you can search for data with clear pixels greater than 90%:

```sh
planet data filter --range clear_percent gt 90 \
    | planet data search PSScene --filter -
```

### String-In Filter

For properties that are strings you can use the `string-in` filter. For example search for all planetscope imagery
with PS2 instrument:

```sh
planet data filter --string-in instrument PS2 \
    | planet data search PSScene --filter -
```

You can specify multiple strings to match, with a comma:

```sh
planet data filter --string-in instrument PS2,PSB.SD \
    | planet data search PSScene --filter -
```

Another example is to select all data in a single strip:

```sh
planet data filter --string-in strip_id 5743640 \
    | planet data search PSScene --filter -
```

Note that in all these commands we are piping the results into the search. If you don't include the pipe then you’ll
get the filter output, which can be interesting to inspect to see exactly what is sent to the server.

### Filter by asset

You can limit your search to only data with a particular asset, for example search just for 8-band analytic assets:

```sh
planet data filter --asset ortho_analytic_8b_sr \
    | planet data search PSScene --filter -
```

Or 8-band assets that also have a UDM.

```sh
planet data filter --asset ortho_analytic_8b_sr --asset udm2 \
    | planet data search PSScene --filter -
```

You can find the list of available assets in each Item Type Page, like 
[available assets](https://developers.planet.com/docs/data/psscene/#available-asset-types) for PSScene. You can see
[a table of all Item Types](https://developers.planet.com/docs/data/psscene/#available-asset-types), which links to 
the page for each with their list of asset types.

Note that the asset filter doesn't perform any validation, so if your searches aren't returning anything check to make
sure you got the asset right, and it’s valid for the item-types you’re searching.

### Permission Filter

By default, no search filters are applied. However, many people want to search only for data they have access to download
that are of standard (aka not test) quality. Therefore, these filters can be easily added with the `--permission` and
`--std-quality` flags. To use the permission and standard quality filters:

```sh
planet data filter --permission --std-quality --asset ortho_analytic_8b_sr \
    | planet data search PSScene --filter -
```

## Stats

One command that can be quite useful for getting a sense of a search is the `stats` command. It works with the
exact same filters as the main `search` command, but it just returns a count of the results, which can be 
binned by different time periods. 

This can be used for things like getting the number of items in a strip:

```sh
planet data filter --string-in strip_id 5743640 \
    | planet data stats PSScene --interval day --filter -
```

Or the number of PlanetScope scenes collected in California each year:

```
curl -s https://raw.githubusercontent.com/ropensci/geojsonio/main/inst/examples/california.geojson \
    | planet data filter --geom - \
    | planet data stats PSScene --interval year --filter - \
    | jq
```

Will result in output like:

```json
{
  "buckets": [
    {
      "count": 5261,
      "start_time": "2014-01-01T00:00:00.000000Z"
    },
    {
      "count": 34377,
      "start_time": "2015-01-01T00:00:00.000000Z"
    },
    {
      "count": 112331,
      "start_time": "2016-01-01T00:00:00.000000Z"
    },
    {
      "count": 504377,
      "start_time": "2017-01-01T00:00:00.000000Z"
    },
    {
      "count": 807086,
      "start_time": "2018-01-01T00:00:00.000000Z"
    },
    {
      "count": 806945,
      "start_time": "2019-01-01T00:00:00.000000Z"
    },
    {
      "count": 776757,
      "start_time": "2020-01-01T00:00:00.000000Z"
    },
    {
      "count": 684095,
      "start_time": "2021-01-01T00:00:00.000000Z"
    },
    {
      "count": 323557,
      "start_time": "2022-01-01T00:00:00.000000Z"
    },
    {
      "count": 56733,
      "start_time": "2023-01-01T00:00:00.000000Z"
    }
  ],
  "interval": "year",
  "utc_offset": "+0h"
}
```

You can see how the yearly output of Planet has gone up, though it actually went down in 2022 as the upgrade to SuperDove meant much larger swaths, so the number of individual items went down even as we captured the whole earth.

The API does not support an 'all time' interval to get the total of all collections for an area, but
you can easily use [jq]((cli-intro.md#jq) to total up the results of an interval count:

```sh
curl -s https://raw.githubusercontent.com/ropensci/geojsonio/main/inst/examples/california.geojson \
    | planet data filter --geom - \
    | planet data stats PSScene --interval year --filter - \
    | jq '.buckets | map(.count) | add'

```

Just pipe the results to `jq '.buckets | map(.count) | add'` and it’ll give you the total of all the values.

## Asset Activation and Download

While we recommend using the Orders or Subscriptions API’s to deliver Planet data, the Data API has the capability
to activate and download data. Only one asset can be activated at once, and there is no clipping or additional 
processing of the data like the great 'tools' of Subscriptions & Orders. But the advantage is that it can often
be faster for working with a small number of items & assets. 

### Activate an Asset

All items in the Data API have a list of assets. This includes the main imagery geotiff files, usually in a few
different formats, and also accompanying files like the [Usable Data Mask](https://developers.planet.com/docs/data/udm-2/)
 (UDM) and JSON metadata. You can't immediately download them, as they must first be created in the cloud, known as
'activated'. To activate data you need to get its item id, plus the name of the asset - the available ones
can be seen by looking at the Item’s JSON. Once you have the item id and asset type you can run the CLI

```sh
planet data asset-activate PSScene 20230310_083933_71_2431 ortho_udm2
```

This will kick off the activation process, and the command should return immediately. In this example
we’re activating the UDM, which is one of the most common things to do through the Data API, to 
first get a sense of where there are clouds before placing a proper clipping order.

### Download an Asset

Once an asset is ready you can use `asset-download` with a similar command:

```sh
planet data asset-download PSScene 20230310_083933_71_2431 ortho_udm2
```

While some assets activate almost immediately (if another user has requested
it recently), some can take a few minutes. If you try to download it before it’s active
you’ll get a message like: `Error: asset missing ["location"] entry. Is asset active?`

Thankfully the CLI has the great `asset-wait` command will complete when the asset is activated:

```sh
planet data asset-wait PSScene 20230310_083933_71_2431 ortho_udm2
```

And you can pair with download so that as soon as the asset is active it’ll be downloaded:

```sh
planet data asset-wait PSScene 20230310_083933_71_2431 ortho_udm2 && \
planet data asset-download PSScene 20230310_083933_71_2431 ortho_udm2
```

Download has a few different options:

 * `--directory` lets you specify a base directory to put the asset in.
 * `--filename` assigns a custom name to the downloaded file.
 * `--overwrite` will overwrite files if they already exist.
 * `--checksum` checks to make sure the file you downloaded is the exact same as the one on the server. This can be useful if you script thousands of files to download to detect any corruptions in that process.

## Saved Searches

The core `planet data search` command uses what is called a 'quick search' in the API. The API 
also supports what we call a '[saved searches](https://developers.planet.com/docs/apis/data/quick-saved-search/#saved-search)',
and the CLI supports this as well. 

### List Searches

You can easily get a list of all the searches you’ve made:

```sh
planet data search-list
```

This defaults to returning 100 results, but you can use `--limit` to return the number you 
specify, and set it to 0 to return all your searches. By default this returns both
your quick searches and saved searches, but you can also limit to to only return
your saved searches:

```sh
planet data search-list --search-type saved
```

If you’ve not created any saved searches it may be an empty list. You can create
saved searches with Planet Explorer, or it’s also easy with the command-line.

### Create Search

To make a new saved search you can use the exact same filter syntax as the regular `search` command,
but you must also add a 'name' to refer to the search by:

```sh
planet data filter --geom geometry.geojson \
    | planet data search-create PSScene --name 'my saved search' --filter -
```

### Run Search

When you save a new search you’ll get back the JSON describing the search. If you grab the 'id' field from it then
you can get the current results for that search:

```sh
planet data search-run da963039dbe94573a3ac9e4629d065b6
```

This is just like running a normal (quick) search, and takes similar arguments: `--limit` and `--pretty`, 
and also the same [sort](#sort) parameter (`--sort`). You can also run any previous `quick` search. 
They don't have names (the ID is just used as the name), but they are saved in the system and can be 
executed again. Searches (except those with an end date that has passed) show new results
if run later and match newly acquired imagery. 

### Update Search

You can also update an existing search to have a different set of values. This takes similar arguments, and
will overwrite the previous values.

```sh
planet data filter --string-in instrument PS2,PSB.SD \
    | planet data search-update da963039dbe94573a3ac9e4629d065b6 \
        --name 'my updated search' \
        --filter - SkySatCollect
```

### Delete Search

If you’re no longer using a search you can delete it:

```sh
planet data search-delete da963039dbe94573a3ac9e4629d065b6
```

If the deletion was successful the command-line won't print out anything except a new line. If the
search didn't exist it will say `Error: {"general": [{"message": "The requested search id does not exist"}], "field": {}}`.
You can also delete `quick` searches, which would remove them from your history.

# Subscriptions Command-Line Interface Specification

This documents lays out the command-line interface to interact with the 
Planet [Subscriptions API](https://developers.planet.com/docs/subscriptions/reference/)

A subscription connects catalog sources to a data processing pipeline. It can 
run those tools on new data when it is available. It can process existing data 
(backfilling). A subscription also specifies storage location for results and 
emits event notifications.

Unlike Orders, the Subscription CLI deals only with Subscriptions and their 
Results. Those are the only nouns. There is no downloader or waiter. It should 
be easier to design and implement.

**Major unknowns:**

* The org admin or superuser feature. Do we need it immediately? How is it going 
  to work with our new auth system?
* Request templates and parameterization. Which standards? How complete? The API
  requires full requests, so everything more surgical is up to the CLI.

**Essential reading:** 

https://developers.planet.com/docs/subscriptions/reference/
https://developers.planet.com/docs/subscriptions/

**Commands:**

The following 3 are backed by HTTP GET requests and are idempotent (run them as 
many times as you want and nothing changes on the server side). They return 
information about different resources in the subscriptions API.

```
planet subscriptions list
planet subscriptions describe
planet subscriptions results
```

The following 3 are backed by HTTP POST or PUT requests. They modify the state of individual subscriptions.

```
planet subscriptions create
planet subscriptions update
planet subscriptions cancel
```

`planet subscriptions list` has no arguments. `planet subscriptions create` 
takes text or a filename as its single argument and can also take text from 
stdin. The other commands all take a single string ID as a positional-only 
argument.

*Note:* `planet subscriptions cancel` doesn’t delete a subscription. It only 
stops it, permanently. The API and CLI have gaps. The gaps, if you squint, 
look a little like planet-subscriptions-delete and planet-subscriptions-resume. 
Addressing the gaps is not part of this work.

## List

### Interface

```
planet subscriptions list [OPTIONS]

Print JSON formatted descriptions of subscriptions.

Options:

–status (multi) running/completed etc. Default is all status.
–limit: optional limit to the number of results.
–pretty: option to pretty-print the output.

Output:
Sequence of JSON texts. Each describing a subscription and its current state. 
Like the result of “describe”.
```

See `planet-subscriptions-results` for implementation details of paging.

### Errors

In the case of invalid options, print an error message (stderr) and set the exit
code to 2. In the case of an API error response, print the response JSON and set
code to 1.

## Describe

### Interface

```
planet subscriptions describe [OPTIONS] ID

Print a JSON description of the subscription with ID.

Arguments:

ID: string. This is the identifier of a Subscription. It’s required. We won’t take identifiers from a file.

Options:
None.

Output:
One JSON text. Printing the JSON from the API response, verbatim, to stdout is 
one option. It seems to make sense to start with that.
```

### Errors

In the case of invalid options, print an error message (stderr) and set the exit
code to 2. In the case of an API error response, print the response JSON and 
set code to 1.

## Results

### Interface

```
planet subscriptions results [OPTIONS] ID

Arguments:

ID: string. This is the identifier of a Subscription. It’s required. We won’t take identifiers from a file.

Options:

–status: (multi) running/completed etc. Default is all status.
–created: timestamp instant or range.
–updated: timestamp instant or range.
–completed: timestamp instant or range.
–limit: optional limit to the number of results.

Output:
JSON text sequence. Default is to print all results from the API. As a starting point let’s print the API’s results verbatim.
```

### Implementation details 
Rhe API results are paged (default page size is 20, maximum is 10,000). The 
implementation is required to follow “next” links when there are more than fit 
in a page. Nice thing about using async Python internally is that the command 
can print one page of results to the terminal while the API is handling the 
request for the next page.

*Note: the org admin feature explained under `planet-subscriptions-list` applies
here. I think we can defer that for now, but will get a check from the API 
team.*

### Errors

In the case of invalid options, print an error message (stderr) and set the exit
code to 2. In the case of an API error response, print the response JSON and 
set code to 1.

## Create

### Interface

```
planet subscriptions create [OPTIONS] REQUEST

Create and launch a subscription.

Arguments

REQUEST: a string. This could be JSON text to be sent directly to the API. Alternatively, it may be a local file or “-” which means read the request from STDIN. Suggestion for the future, make “-” the default value.

Options:
None.

Output:
JSON description of the created Subscription, the API response verbatim, including its ID. 
```

### Errors

In the case of invalid options, print an error message (stderr) and set the exit
code to 2. In the case of an API error response, print the response JSON and 
set code to 1.

## Request

### Interface

```
planet subscriptions request [OPTIONS]

Generate a subscriptions request.

This command provides support for building the subscription request JSON used to create or
update a subscription. It outputs the subscription request.

Options:
  --name TEXT                     Subscription name. Does not need to be unique.
                                  [required]
  --source                        Source JSON. Can be a json string,
                                  filename, or '-' for stdin.
  --tools JSON                    Toolchain JSON. Can be a json string,
                                  filename, or '-' for stdin.
  --delivery JSON                 Credentials for cloud storage provider to
                                  enable cloud delivery of data. Can be a json
                                  string, filename, or '-' for stdin.
  --notifications JSON            Notification JSON to specify webhook topics.
                                  Can be a json string, filename, or '-' for
                                  stdin.
  --pretty                        Format JSON output.
  --help                          Show this message and exit.
```

### Usage Examples

```
planet subscription request \
    --name test \
    --source source.json \
    --delivery delivery.json | planet subscriptions create -
```

## Request-catalog

### Interface

```
planet subscriptions request-catalog [OPTIONS]

Generate a subscriptions request source JSON for a catalog.

Options:
  --asset-types TEXT              One or more comma-separated asset types. Required.
  --item-types TEXT               One or more comma-separated item-types. Required.
  --geometry JSON                 geometry of the area of interest of the subscription that will be used to determine matches.
                                  Can be a json string, filename, or '-' for stdin.
  --start-time DATETIME           Start date and time to begin subscription.
  --end-time DATETIME             Date and time to end the subscription.
  --rrule TEXT                    iCalendar recurrance rule to specify recurrances.
  --filter JSON                   A search filter can be specified a json string,
                                  filename, or '-' for stdin.
  --pretty                        Format JSON output.
  --help                          Show this message and exit.
```

### Usage Examples

```
planet subscriptions request-catalog \
        --item-types PSScene \
        --asset-types ortho_analytic_8b_sr,ortho_udm2 \
        --geometry aoi.geojson \
        --start-time 2022-01-01 > req_cat.json
```

## Request-other

### Interface

```
planet subscriptions request-other [OPTIONS]

Generate a subscriptions request source JSON for another product.

Options:
  --type                        Type.
  --id                          Id.
  --geometry JSON                      geometry of the area of interest of the subscription that will be used to determine matches.
                                  Can be a json string, filename, or '-' for stdin.
  --start-time DATETIME           Start date and time to begin subscription.
  --end-time DATETIME             Date and time to end the subscription.
  --rrule TEXT                    iCalendar recurrance rule to specify recurrances.
  --pretty                        Format JSON output.
  --help                          Show this message and exit.
```


## Update

Edit a subscription, such as one with a future start date, before it starts running.

https://developers.planet.com/docs/subscriptions/#edit-a-subscription mentions 
caveats and limitations:
 * Backfill cannot be updated.
 * After a subscription is running, only source items can be modified, and not 
   all of them.


### Interface

```

planet subscriptions update [OPTIONS] ID REQUEST

Update the subscription identified by ID.

Arguments:
ID: string. This is the identifier of a Subscription. It’s required. We won’t take identifiers from a file.

Options:
None.

Output:
JSON API response, verbatim.
```

### Errors

In the case of invalid options, print an error message (stderr) and set the exit
code to 2. In the case of an API error response, print the response JSON and 
set code to 1.

## Cancel

### Interface

```

planet subscriptions cancel [OPTIONS] ID

Permanently cancel the subscription identified by ID.

Arguments:
ID: string. This is the identifier of a Subscription. It’s required. We won’t take identifiers from a file.

Options:
None.

Output:

API response, verbatim.
```

### Errors

In the case of invalid options, print an error message (stderr) and set the exit
code to 2. In the case of an API error response, print the response JSON and set
code to 1.

# Data Command-Line Interface Specification

This document lays out the command-line interface to interact with the Planet
[Data API](https://developers.planet.com/docs/apis/data/).

## Meta: Errors

All commands have the same general error behavior:

In the case of invalid options, print an error message (stderr) and set the exit
code to 2. In the case of an API error response, print the response JSON and
set code to 1. In the case of an error occurring in the SDK, print the error
message and set code to 1.

## filter

### Interface

planet data filter [OPTIONS]

Create a structured item search filter.

This command provides basic functionality for specifying a filter by
creating an AndFilter with the filters identified with the options as
inputs. This is only a subset of the complex filtering supported by the API.
For advanced filter creation, either create the filter by hand or use the
Python API.

Options:
- asset TEXT -
Filter to items with one or more of
specified assets. VALUE is a comma-separated
list of entries. When multiple entries are
specified, an implicit 'or' logic is
applied.

- date-range FIELD COMP VALUE -
Filter by date range in field. FIELD is the
name of the field to filter on. COMP can be
lt, lte, gt, or gte. DATETIME can be an
RFC3339 or ISO 8601 string.
 Filter field by date. COMP can be lt, lte, gt, or gte. VALUE is an RFC 3339 date.

- geom JSON -
Filter to items that overlap a given
geometry. Can be a json string, filename, or
'-' for stdin.

- number-in FIELD VALUE -
Filter field by numeric in. FIELD is the
name of the field to filter on. VALUE is a
comma-separated list of entries. When
multiple entries are specified, an implicit
'or' logic is applied.

- permission BOOLEAN -
Filter to assets with download permissions.
[default: True]

- range FIELD COMP FLOAT -
Filter by number range in field. FIELD is
the name of the field to filter on. COMP can
be lt, lte, gt, or gte.

- std-quality BOOLEAN - Filter to standard quality.  [default: True]

- string-in FIELD TEXT -
Filter field by numeric in. FIELD is the
name of the field to filter on. TEXT is a
comma-separated list of entries. When
multiple entries are specified, an implicit
'or' logic is applied.

- update FIELD COMP DATETIME -
Filter to items with changes to a specified
field value made after a specified date.
FIELD is the name of the field to filter on.
COMP can be gt or gte. DATETIME can be an
RFC3339 or ISO 8601 string.

Output:

A full JSON description of the search criteria.


### Usage Examples

User Story: As a CLI user I want to create a filter for items within an aoi that
have both the analytic_sr and udm2 assets.

```console
$ planet data filter \
--geom aoi.geojson \
--asset analytic_sr --asset udm2
```
response (pretty-printed)
```
{
  "config": [
    {
      "config": [
        "udm2"
      ],
      "type": "AssetFilter"
    },
    {
      "config": {
        "coordinates": [
          [
            [
              7.05322265625,
              46.81509864599243
            ],
            [
              7.580566406250001,
              46.81509864599243
            ],
            [
              7.580566406250001,
              47.17477833929903
            ],
            [
              7.05322265625,
              47.17477833929903
            ],
            [
              7.05322265625,
              46.81509864599243
            ]
          ]
        ],
        "type": "Polygon"
      },
      "field_name": "geometry",
      "type": "GeometryFilter"
    },
    {
      "config": [
        "assets:download"
      ],
      "type": "PermissionFilter"
    },
    {
      "config": [
        "standard"
      ],
      "field_name": "quality_category",
      "type": "StringInFilter"
    }
  ],
  "type": "AndFilter"
}
```

User Story: As a CLI user I want to create a filter for items with clear pixel
percent greater than 98% acquired in July 2021.

```console
$ planet data filter \
--range clear_percent gt 98 \
--date-range acquired gte 2021-07-01 \
--date-range acquired lt 2021-08-01
```
response (pretty-printed)
```
{
  "config": [
    {
      "config": {
        "gte": "2021-07-01T00:00:00Z"
      },
      "field_name": "acquired",
      "type": "DateRangeFilter"
    },
    {
      "config": {
        "lt": "2021-08-01T00:00:00Z"
      },
      "field_name": "acquired",
      "type": "DateRangeFilter"
    },
    {
      "config": {
        "gt": 98.0
      },
      "field_name": "clear_percent",
      "type": "RangeFilter"
    },
    {
      "config": [
        "assets:download"
      ],
      "type": "PermissionFilter"
    },
    {
      "config": [
        "standard"
      ],
      "field_name": "quality_category",
      "type": "StringInFilter"
    }
  ],
  "type": "AndFilter"
}
```

## search

### Interface

planet data search [OPTIONS] ITEM_TYPES [FILTER]

Execute a structured item search.

Quick searches are stored for approximately 30 days and the --name parameter will be applied to the stored quick search.

Arguments:
ITEM_TYPES - string. Comma-separated item type identifier(s).
FILTER - string. A full JSON description of search criteria. Supports file, str, and stdin.
Defaults to reading from stdin.

Options:
--pretty - flag. Pretty-print output
--limit - int. Maximum number of results to return. Defaults to 100.
--name - string. Name of the saved search.

Output:
A series of GeoJSON descriptions for each of the returned items.


### Usage Examples

User Story: As a CLI user I want to create a filter and then search for items
with clear pixel percent greater than 98% acquired in July 2021.

```
$ planet data filter \
--range clear_percent gt 98 \
--date-range acquired gte 2021-07-01 \
--date-range acquired lt 2021-08-01 | planet data search --limit 1 PSScene
```
response (pretty-printed)
```
{
  "_links": {
    "_self": "https://api.planet.com/data/v1/item-types/PSScene/items/20210709_175710_72_105e",
    "assets": "https://api.planet.com/data/v1/item-types/PSScene/items/20210709_175710_72_105e/assets/",
    "thumbnail": "https://tiles.planet.com/data/v1/item-types/PSScene/items/20210709_175710_72_105e/thumb"
  },
  "_permissions": [
    "assets.basic_analytic_4b:download",
    "assets.basic_analytic_4b_rpc:download",
    "assets.basic_analytic_4b_xml:download",
    "assets.basic_udm2:download",
    "assets.ortho_analytic_4b:download",
    "assets.ortho_analytic_4b_sr:download",
    "assets.ortho_analytic_4b_xml:download",
    "assets.ortho_udm2:download",
    "assets.ortho_visual:download",
    "assets.ps3b_analytic:download",
    "assets.ps3b_analytic_dn:download",
    "assets.ps3b_analytic_dn_xml:download",
    "assets.ps3b_analytic_xml:download",
    "assets.ps3b_basic_analytic:download",
    "assets.ps3b_basic_analytic_dn:download",
    "assets.ps3b_basic_analytic_dn_rpc:download",
    "assets.ps3b_basic_analytic_dn_xml:download",
    "assets.ps3b_basic_analytic_rpc:download",
    "assets.ps3b_basic_analytic_xml:download",
    "assets.ps3b_basic_udm:download",
    "assets.ps3b_udm:download",
    "assets.ps3b_visual_xml:download",
    "assets.ps4b_analytic:download",
    "assets.ps4b_analytic_dn:download",
    "assets.ps4b_analytic_dn_xml:download",
    "assets.ps4b_analytic_sr:download",
    "assets.ps4b_analytic_xml:download",
    "assets.ps4b_basic_analytic:download",
    "assets.ps4b_basic_analytic_dn:download",
    "assets.ps4b_basic_analytic_dn_nitf:download",
    "assets.ps4b_basic_analytic_dn_rpc:download",
    "assets.ps4b_basic_analytic_dn_rpc_nitf:download",
    "assets.ps4b_basic_analytic_dn_xml:download",
    "assets.ps4b_basic_analytic_dn_xml_nitf:download",
    "assets.ps4b_basic_analytic_nitf:download",
    "assets.ps4b_basic_analytic_rpc:download",
    "assets.ps4b_basic_analytic_rpc_nitf:download",
    "assets.ps4b_basic_analytic_xml:download",
    "assets.ps4b_basic_analytic_xml_nitf:download",
    "assets.ps4b_basic_udm:download",
    "assets.ps4b_udm:download"
  ],
  "assets": [
    "basic_analytic_4b",
    "basic_analytic_4b_rpc",
    "basic_analytic_4b_xml",
    "basic_udm2",
    "ortho_analytic_4b",
    "ortho_analytic_4b_sr",
    "ortho_analytic_4b_xml",
    "ortho_udm2",
    "ortho_visual",
    "ps3b_analytic",
    "ps3b_analytic_dn",
    "ps3b_analytic_dn_xml",
    "ps3b_analytic_xml",
    "ps3b_basic_analytic",
    "ps3b_basic_analytic_dn",
    "ps3b_basic_analytic_dn_rpc",
    "ps3b_basic_analytic_dn_xml",
    "ps3b_basic_analytic_rpc",
    "ps3b_basic_analytic_xml",
    "ps3b_basic_udm",
    "ps3b_udm",
    "ps3b_visual_xml",
    "ps4b_analytic",
    "ps4b_analytic_dn",
    "ps4b_analytic_dn_xml",
    "ps4b_analytic_sr",
    "ps4b_analytic_xml",
    "ps4b_basic_analytic",
    "ps4b_basic_analytic_dn",
    "ps4b_basic_analytic_dn_nitf",
    "ps4b_basic_analytic_dn_rpc",
    "ps4b_basic_analytic_dn_rpc_nitf",
    "ps4b_basic_analytic_dn_xml",
    "ps4b_basic_analytic_dn_xml_nitf",
    "ps4b_basic_analytic_nitf",
    "ps4b_basic_analytic_rpc",
    "ps4b_basic_analytic_rpc_nitf",
    "ps4b_basic_analytic_xml",
    "ps4b_basic_analytic_xml_nitf",
    "ps4b_basic_udm",
    "ps4b_udm"
  ],
  "geometry": {
    "coordinates": [
      [
        [
          -90.29653391265096,
          65.41358418134989
        ],
        [
          -90.41598325057312,
          65.27385324441894
        ],
        [
          -89.91560785061391,
          65.19794655099538
        ],
        [
          -89.79334184267987,
          65.33769971680782
        ],
        [
          -90.29653391265096,
          65.41358418134989
        ]
      ]
    ],
    "type": "Polygon"
  },
  "id": "20210709_175710_72_105e",
  "properties": {
    "acquired": "2021-07-09T17:57:10.722684Z",
    "anomalous_pixels": 0,
    "clear_confidence_percent": 93,
    "clear_percent": 100,
    "cloud_cover": 0,
    "cloud_percent": 0,
    "ground_control": true,
    "gsd": 3.8,
    "heavy_haze_percent": 0,
    "instrument": "PS2.SD",
    "item_type": "PSScene",
    "light_haze_percent": 0,
    "pixel_resolution": 3,
    "provider": "planetscope",
    "published": "2021-09-20T03:03:40Z",
    "publishing_stage": "finalized",
    "quality_category": "standard",
    "satellite_azimuth": 285.7,
    "satellite_id": "105e",
    "shadow_percent": 0,
    "snow_ice_percent": 0,
    "strip_id": "4673073",
    "sun_azimuth": 176.4,
    "sun_elevation": 46.9,
    "updated": "2021-09-20T09:21:14Z",
    "view_angle": 3.1,
    "visible_confidence_percent": 72,
    "visible_percent": 100
  },
  "type": "Feature"
}

```

## search-create

### Interface

```
planet data search-create [OPTIONS] NAME ITEM_TYPES [FILTER]

Create a new saved structured item search.

Arguments:
NAME - string. The name to give the saved search.
ITEM_TYPES - string. Comma-separated item type identifier(s).
FILTER - string. A full JSON description of search criteria. Supports file and stdin. Defaults to stdin.

Options:
--daily-email - flag. Send a daily email when new results are added.
--pretty - flag. Pretty-print output

Output:
A full JSON description of the created search.
```

### Usage Examples

User Story: As a CLI user I want to create a filter and then create a saved
search for items with clear pixel percent greater than 98% acquired in July 2021.

```
$ planet data filter \
--range clear_percent gt 98 \
--date-range acquired gte 2021-07-01 \
--date-range acquired lt 2021-08-01 | planet data search-create test PSScene
```
response (pretty-printed)
```
{
  "__daily_email_enabled": false,
  "_links": {
    "_self": "https://api.planet.com/data/v1/searches/ebd2eaf451d24d6f91a8d721fdeb6a1b",
    "results": "https://api.planet.com/data/v1/searches/ebd2eaf451d24d6f91a8d721fdeb6a1b/results"
  },
  "created": "2022-06-28T18:05:56.763106Z",
  "filter": {
    "config": [
      {
        "config": {
          "gte": "2021-07-01T00:00:00Z"
        },
        "field_name": "acquired",
        "type": "DateRangeFilter"
      },
      {
        "config": {
          "lt": "2021-08-01T00:00:00Z"
        },
        "field_name": "acquired",
        "type": "DateRangeFilter"
      },
      {
        "config": {
          "gt": 98.0
        },
        "field_name": "clear_percent",
        "type": "RangeFilter"
      },
      {
        "config": [
          "assets:download"
        ],
        "type": "PermissionFilter"
      },
      {
        "config": [
          "standard"
        ],
        "field_name": "quality_category",
        "type": "StringInFilter"
      }
    ],
    "type": "AndFilter"
  },
  "id": "ebd2eaf451d24d6f91a8d721fdeb6a1b",
  "item_types": [
    "PSScene"
  ],
  "last_executed": null,
  "name": "test",
  "search_type": "saved",
  "updated": "2022-06-28T18:05:56.763106Z"
}
```

## search-update

### Interface

```
planet data search-update [OPTIONS] SEARCH_ID NAME ITEM_TYPES FILTER

Update a saved search with the given search request.

Arguments:
SEARCH_ID - string. A saved search identifier.
NAME - string. The name to give the saved search.
ITEM_TYPES - string. Comma-separated item type identifier(s).
FILTER - string. A full JSON description of search criteria. Supports file and stdin.

Options:
--daily-email - flag. Send a daily email when new results are added.
--pretty - flag. Pretty-print output

Output:
A full JSON description of the updated search.
```

## search-delete

### Interface

```
planet data search-delete SEARCH_ID

Delete the existing saved search.

Arguments:
SEARCH_ID - string. A saved search identifier.

Output:
None.
```

## search-get

### Interface

```
planet data search-get [OPTIONS] SEARCH_ID

Get the existing saved search.

Arguments:
SEARCH_ID - string. A saved search identifier.

Options:
--pretty - flag. Pretty-print output

Output:
A full JSON description of the identified search.
```

## search-list

### Interface

```
planet data search-list [OPTIONS]

Options:
--pretty - flag. Pretty-print output
--limit - int. Maximum number of results to return. Defaults to 100.
--search-type - choice. Filter to a specific search type.
--sort - string. Sort order (created_asc, created_desc)

Output:
A series of JSON descriptions for each of the returned items.
```

## search-run

### Interface

```
planet data search-run SEARCH_ID

Execute a saved search.

Arguments:
REQUEST - string. A full JSON description request.

Options:
--pretty - flag. Pretty-print output
--limit - int. Maximum number of results to return. Defaults to 100.

Output:
A series of GeoJSON descriptions for each of the returned items.
```

## item-get

### Interface

```
planet data item-get [OPTIONS] ID ITEM_TYPE

Get an item.

Arguments:
ID - string. Item identifier.
ITEM_TYPE - string. Item type identifier.


Options:
--pretty - flag. Pretty-print output

Output:
A full GeoJSON description of the returned item.
```

### Usage Examples

User Story: As a CLI user I would like to get the details of an item

```
$ planet data item-get 20210819_162141_68_2276 PSScene

{"_links": {...}, ..., "type": "Feature"}
```

## asset-activate

### Interface

```
planet data asset-activate ID ITEM_TYPE ASSET_TYPE

Activate an asset.

Arguments:
ID - string. Item identifier.
ITEM_TYPE - string. Item type identifier.
ASSET_TYPE - string. Asset type identifier.

Output:
None.
```

### Usage Examples

User Story: As a CLI user I would like to activate an asset for download.

```
$ planet data asset-activate 20210819_162141_68_2276 PSScene analytic
```

User Story: As a CLI user I would like to activate, wait, and then download an
asset.

```
$ ID=20210819_162141_68_2276 && \
ITEM_TYPE=PSScene && \
ASSET_TYPE=analytic && \
planet data asset-activate $ID $ITEM_TYPE $ASSET_TYPE && \
planet data asset-wait $ID $ITEM_TYPE $ASSET_TYPE && \
planet data asset-download --directory data \
$ID $ITEM_TYPE $ASSET_TYPE

data/<psscene_naming 20210819_162141_68_2276>.tif
```

## asset-wait

### Interface

```
planet data asset-wait ID ITEM_TYPE ASSET_TYPE

Wait for an asset to be activated.

Returns when the asset state has reached ‘activated’ and the asset is available.

Arguments:
ID - string. Item identifier.
ITEM_TYPE - string. Item type identifier.
ASSET_TYPE - string. Asset type identifier.

Output:
None.
```

## asset-download

### Interface

```
planet data asset-download [OPTIONS] ID ITEM_TYPE ASSET_TYPE

Download an activated asset.

Will fail if the asset state is not activated. Consider calling `asset-wait` before this command to ensure the asset is activated.

Arguments:
ID - string. Item identifier.
ITEM_TYPE - string. Item type identifier.
ASSET_TYPE - string. Asset type identifier.

Options:
--directory - string. Download directory.
--overwrite - flag. Overwrite file if it already exists.

Output:
The full path of the downloaded file. If the quiet flag is not set, this also provides ANSI download status reporting.
```

### Usage Examples

User Story: As a CLI user I would like to download one asset into the data
directory, overwriting if the file already exists, and silencing reporting.

```
$ planet --quiet data asset-download \
--directory data \
--overwrite \
20210819_162141_68_2276 PSScene analytic
data/<psscene_naming 20210819_162141_68_2276>.tif
```

## stats

### Interface

```
planet data stats [OPTIONS] ITEM_TYPES INTERVAL FILTER

Get a bucketed histogram of items matching the filter.

Arguments:
ITEM_TYPES - string. Comma-separated item type identifier(s).
INTERVAL - string. The size of the histogram buckets (<hour, day, week, month, year>)
FILTER - string. A full JSON description filter. Supports file and stdin.

Output:
A full JSON description of the returned statistics result.
```

### Usage Examples

User Story: As a CLI user I would like to get the stats of multiple item types
with a utc offset using a file to specify the filter.

```
$ planet data stats --utc-offset +1:00 \
PSScene,REOrthoTile day filter-desc.json

<unedited API response json>
```

# CLI Managed Sessions
For simple programs and scripts, it is easiest for the program to defer
session management to the [`planet auth`](../../cli/cli-reference/#auth)
CLI.   This method will store session information in the user's home directory
in the `~/.planet.json` file and `~/.planet/` directory.  The Python SDK will
use the information saved in these locations to make API calls.

When this approach is taken, the authentication session will be shared between
actions taken by the `planet` utility and those taken by programs built
using the SDK.  Changes made by one will impact the behavior of the other.

CLI managed sessions can be used for all authentication protocols supported
by the SDK library.

**Requirements and Limitations:**

* The program must have read and write access to the user's home directory.
* This method requires that the end-user has access to and understands
  the [`planet`](../../cli/cli-reference) CLI command needed to manage
  authentication.
* This approach should not be used on public terminals or in cases where the
  user's home directory cannot be kept confidential.

## Initialize Session - CLI Login
Session login can be performed using the following command.  This command can
be used to initialize sessions using any of the supported authentication methods,
and will default to creating an OAuth2 user session.
Refer to the command's `--help` for more information.

<a name="planet-auth-login"></a>
```shell title="Initialize session using planet CLI."
planet auth login
```

A particular configuration may be selected by using the `--auth-profile` option.
`planet-user` is the default, but may be [overridden](../auth-sdk/#configuration)
by the runtime environment.

<a name="planet-auth-login-planet-user"></a>
```shell title="Initialize session using planet CLI, forcing the built-in user interactive OAuth2 login flow."
planet auth login --auth-profile planet-user
```

<a name="planet-auth-login-planet-m2m"></a>
```shell title="Initialize session using planet CLI, forcing the use of the specified service principal."
planet auth login --auth-client-id <your-client-id> --auth-client-secret <your-client-secret>
```

<a name="planet-auth-login-planet-apikey"></a>
```shell title="Initialize session using planet CLI, forcing the use of a legacy Planet API key."
planet auth login --auth-api-key <your-api-key>
```

## Using Saved Session
Using a CLI managed session is the default behavior for SDK functions.
Developing an application that uses a CLI managed session requires no additional
action by the developer.  When a developer chooses to create an application
that behaves in this way, it will most often be done implicitly by relying
on SDK default behavior, but it may also be done explicitly.

### CLI Selected Session
The default behavior of the SDK is to defer which session is loaded to CLI.

<a name="use-cli-session-implicit"></a>
```python linenums="1" title="Implicitly use CLI managed login sessions, deferring session selection to the user and the CLI."
{% include 'auth-session-management/cli_managed_auth_state__implicit.py' %}
```
<a name="use-cli-session-explicit"></a>
```python linenums="1" title="Explicitly use CLI managed login sessions, deferring session selection to the user and the CLI."
{% include 'auth-session-management/cli_managed_auth_state__explicit.py' %}
```

### Application Selected Session
Applications may be developed to always select a specific CLI managed profile.
This may be useful in cases where an application wishes to guide the user
experience towards expecting an auth session that is separate from the default
sessions used by the CLI.

In cases where the application has access to the
user's home directory and saved sessions, forcing the use of a particular
profile circumvents the user's CLI managed preferences.

<a name="use-cli-session-force-custom"></a>
Note: This first example does not create the session `my-app-profile`.
This must be created either through a separate code path as show in
the [Application Managed Sessions](../auth-dev-app-managed-oauth) guide,
or by using a CLI command to copy an existing profile such as
`planet auth profile copy planet-user my-app-profile`.

```python linenums="1" title="Use a specific session that is shared with the CLI."
{% include 'auth-session-management/cli_managed_auth_state__specific_auth_profile.py' %}
```

<a name="use-cli-session-force-builtin"></a>
It is also possible to force the use of the SDK's built-in OAuth2 application ID
for interactive user applications.  This capability is provided for developer
convenience, primarily for smaller programs and scripts. Larger applications
developed for multiple users should
[register](../auth-dev-app-managed-oauth/#oauth2-user-client-registration)
a unique application ID.

This second example also initiates a login and does not save session state to storage.
This means this example does not depend on the CLI, and may be considered a simple
example of an [Application Managed Session](../auth-dev-app-managed-oauth).

```python linenums="1" title="Use the Planet SDK with an OAuth2 user session initialized by the application and utilizing the SDK's built-in OAuth2 application ID."
{% include 'auth-session-management/app_managed_auth_state__using_sdk_app_id.py' %}
```

---

---
title: Python SDK API Reference
---

## ::: planet.Auth
    rendering:
      show_root_full_path: false

## ::: planet.Session
    rendering:
      show_root_full_path: false

## ::: planet.OrdersClient
    rendering:
      show_root_full_path: false

## ::: planet.order_request
    rendering:
      show_root_full_path: false

## ::: planet.DataClient
    rendering:
      show_root_full_path: false

## ::: planet.data_filter
    rendering:
      show_root_full_path: false

## ::: planet.SubscriptionsClient
    rendering:
      show_root_full_path: false

## ::: planet.subscription_request
    rendering:
      show_root_full_path: false

## ::: planet.reporting
    rendering:
      show_root_full_path: false

# Application Managed Sessions - Planet API Key

## Planet API Key Sessions
Legacy applications that need to continue to support Planet API keys may do so
until API keys are deprecated. This method should not be adopted for new
development if possible.

### Examples - Planet API Keys

#### In Memory Session State
Once provided with an API key, an application may operate with the API key
in memory indefinitely without the need to prompt the user for re-authentication.
```python linenums="1" title="Access APIs using Planet API keys in memory"
{% include 'auth-session-management/app_managed_auth_state__in_memory__api_key.py' %}
```

#### Version 2 Compatibility
The SDK continues to support files written by version 2 of the SDK to save
auth state.
```python linenums="1" title="Access APIs using Planet API keys using the on disk file format used by older versions of the SDK"
{% include 'auth-session-management/app_managed_auth_state__on_disk_legacy__api_key.py' %}
```

```json linenums="1" title="Legacy API Key file example"
{% include 'auth-session-management/legacy_api_key_file.json' %}
```

#### Session State Shared with CLI
```python linenums="1" title="Access APIs using Planet API keys with CLI managed shared state on disk"
{% include 'auth-session-management/app_managed_auth_state__on_disk_cli_shared__api_key.py' %}
```

####  Session State Saved to Application Storage

```python linenums="1" title="Access APIs using Planet API keys with sessions persisted to application provided storage"
{% include 'auth-session-management/app_managed_auth_state__app_custom_storage__api_key.py' %}
```

----

---
title: More CLI Tips & Tricks
---

## About

This document shows off a range of more advanced command-line workflows, making use of a wider range
of tools in the command-line & geospatial ecosystem. Some of them can be a pain to install, like
GDAL/OGR, and several pop in and out of web tools, so these are kept out of the main tutorial
section.

**WORK IN PROGRESS**: This document is still under construction, with a number of TODO’s remaining,
but we are publishing as there’s a lot of good information here.

## Tools used

* **[GDAL/OGR](https://gdal.org)** - We’ll mostly use OGR, the vector tooling.
Great for things like format conversion and basic simplification.
* **[Keplergl_cli](https://github.com/kylebarron/keplergl_cli#usage)** - Nice tool to call the
awesome kepler.gl library from the commandline. Useful for visualization of large amounts of
geojson.
* **[GeoJSON.io](https://geojson.io/)** - Simple tool to do editing of geojson, useful for creating
AOI’s. It integrates with github, but the ability to save a GeoJSON to github doesn't seem to work so well.
* **[Placemark.io](https://placemark.io)** - More advanced tool from the creator of GeoJSON.io, very
nice for creating AOI’s and piping them in, with lots of rich geometry editing features.
* **[MapShaper](https://github.com/mbloch/mapshaper)** - Tool to do interactive simplification of
GeoJSON, has a nice CLI.
* **[STACTools](https://github.com/stac-utils/stactools)** - CLI for working with STAC data. There
is also a [planet plugin](https://github.com/stactools-packages/planet) that may be useful in the
future.
* **[Github commandline](https://cli.github.com/)** - Nice CLI for quickly posting things to gists.

## Workflows

### Geometry Inputs

While the command-line can often be quicker than using a UI, one place that can be slower is
getting the geometry input for searching or clipping. Hand-editing GeoJSON is a huge pain, so most
people will open up a desktop tool like QGIS or ArcGIS Pro and save the file. But there are a few
tools that can get you back into the CLI workflow more quickly.

#### Use the Features API
Rather than using GeoJSON in the SDK, upload your GeoJSON to the [Features API](https://developers.planet.com/docs/apis/features/) and use references
across the system with the sdk.
References are used in the geometry block of our services in a GeoJSON blob like:
```json
"geometry":
    {
        "content": "pl:features/my/[collection-id]/[feature-id]",
        "type": "ref"
    }
```
Or as a string in a geometry option like `"pl:features/my/[collection-id]/[feature-id]"`


#### Draw with GeoJSON.io

One great tool for quickly drawing on a map and getting GeoJSON output is
[GeoJSON.io](https://geojson.io). You can draw and save the file, but an even faster workflow
is to use your operating system’s clipboard to command-line tools.

Just draw with the tools, then copy (with right click and 'copy' from the menu or 'ctrl c') the
JSON from the text box:

![Select on GeoJSON.io](https://user-images.githubusercontent.com/407017/179411184-fe3061aa-32ad-4bf7-bf6a-18c59bfdfff7.png)

On a mac you can use `pbpaste` to grab whatever is currently in your clipboard:

```console
pbpaste | planet data filter --geom -  | planet data search SkySatCollect --filter -
```

(TODO: Find alternatives for windows and linux)

#### Draw with Placemark

A really fantastic tool for working with GeoJSON is [Placemark](https://placemark.io). It is a
commercial tool that you’ll have to pay for, but it’s got a really nice feature that makes it very
compatible with command-line workflows. You can easily grab the URL of any individual GeoJSON
feature and stream it in as your geometry using `curl`:

![Stream from Placemark](https://user-images.githubusercontent.com/407017/179412209-2365d79a-9260-47e5-9b08-9bc5b84b6ddc.gif)

```console
curl -s https://api.placemark.io/api/v1/map/a0BWUEErqU9A1EDHZWHez/feature/278cd610-05ee-11ed-8fdd-15633e4f8f01 | \
planet data filter --geom - | jq
```

### Geometry Visualization

Looking at a big list of GeoJSON is a lot less useful then actually being able to see the footprints. This is often
done by saving the output files and opening with a desktop GIS program, but there are some nice alternatives that
let you pipe (`|`) the output more directly.

#### Copy GeoJSON to clipboard

One of the quicker routes to visualizing search output is to copy the output to your clipboard and paste into a
tool that will take GeoJSON and visualize it.

You can do this on GeoJSON.io:

(TODO: record example)

Or also on Placemark, which tends to perform a bit better (especially when you get above 1000 features).

(TODO: record example)

For both it’s recommended to pass the output through `planet collect` to get properly formatted GeoJSON:

```console
planet data filter --string-in strip_id 5743669 | planet data search PSScene --filter - | planet collect - | pbcopy
```

(TODO: Get pbcopy equivalents for windows and linux)

#### Post to Github as gist

Another easy option that is a bit more persistent is to post to Github using the
[`gh` cli tool](https://github.com/cli/cli). Specifically using the `gist create` command.

The following command will get the latest SkySat image captured, upload to github, and open
your browser to see it:

```console
planet data search SkySatCollect --sort 'acquired desc' --limit 1 \
| planet collect - | jq | gh gist create -f latest-skysat.geojson -w
```

Or you can show all ps-scenes in a strip on github gist.
(You may need to reload the page, for some reason it doesn't always showing up immediately after open)

```console
planet data filter --string-in strip_id 5743640 | planet data search PSScene --filter - \
| planet collect - | gh gist create -f ps-search.geojson -w
```


TODO: get a command that gets the latest strip id and uses that as input in one line. May need to update filter commands to take stdin?
This current command doesn't quite work.

```console
strip-id=`planet data search PSScene --limit 1 \
| jq -r '.properties.strip_id' | sed 's/\\[tn]//g'`
planet data filter --string-in strip_id $stripid | planet data search PSScene --filter -
```


#### Kepler.gl

One of the best tools to visualize large numbers of imagery footprints is a tool called [kepler.gl](https://kepler.gl/),
which has a really awesome command-line version which is perfect for working with Planet’s CLI. To get the CLI go to
[keplergl_cli](https://github.com/kylebarron/keplergl_cli) and follow the
[installation instructions](https://github.com/kylebarron/keplergl_cli#install). Be sure to get a Mapbox API key (from
the [access tokens](https://account.mapbox.com/access-tokens/) page) - just sign up for a free account if you don't have
one already. The kepler CLI won't work at all without getting one and setting it as the `MAPBOX_API_KEY` environment
variable.

Once it’s set up you can just pipe any search command directly to `kepler` (it usually does fine even without
`planet collect` to go from ndgeojson to geojson). For example:

```console
curl -s https://storage.googleapis.com/open-geodata/ch/vermont.json \
| planet data filter --geom -  \
| planet data search PSScene --filter - \
| kepler
```

(TODO: Add animated gif, showing some options)

Kepler really excels at larger amounts of data, so try it out with larger limits:

```console
curl -s https://storage.googleapis.com/open-geodata/ch/vermont.json \
| planet data filter --geom - \
| planet data search PSScene,Sentinel2L1C,Landsat8L1G,SkySatCollect,Sentinel1 \
--sort 'acquired desc' --limit 1500 --filter - \
| kepler
```

(show animated gif with 600 - lower amount so it takes less time to load).

And you can bring it all together using Placemark for input and Kepler for output:

(TODO: Figure out why this link isn't working... Maybe needs to be smaller?)

![Placemark and Kepler with Planet CLI](https://storage.googleapis.com/open-geodata/ch/planet-cli-pm-kepler.gif)

```console
curl -s https://api.placemark.io/api/v1/map/a0BWUEErqU9A1EDHZWHez/feature/91a07390-0652-11ed-8fdd-15633e4f8f01 \
| planet data filter --geom - \
| planet data search PSScene,Landsat8L1G,SkySatCollect,Sentinel1 --filter - | kepler
```

#### Large Dataset Visualization

Oftentimes it can be useful to visualize a large amount of data, to really get a sense of the
coverage and then do some filtering of the output. For this we recommend downloading the output
to disk. Getting 20,000 skysat collects will take at least a couple of minutes, and will be over
100 megabytes of GeoJSON on disk.

```console
planet data search SkySatCollect --limit 20000 > skysat-large.geojsons
```

Kepler can fairly easily handle 20,000 skysat footprints, try:

```console
kepler skysat-large.geojsons
```

Many GIS programs will open that geojson file by default. But if you have any trouble it can be useful to run it
through `planet collect`:

```console
planet data collect skysat-large.geojsons > skysat-large-clean.geojson
```
This turns it into a real GeoJSON, instead of a newline-delimited one, which more programs understand.

If you want to visualize even larger sets of footprints there’s a few things we recommend:

##### Convert to GeoPackage

GeoJSON is an amazing format for communicating online, but is less good with
really large amounts of data, so we recommend converting it to a format that
has a spatial index and isn't so large on disk. We recommend
[geopackage](https://www.geopackage.org/), but shapefile can work as well.

The `ogr2ogr` of [GDAL/OGR](https://gdal.org/) is a great tool for this. We
recommend using the [binaries](https://gdal.org/download.html#binaries), or if
you’re on a Mac then use [homebrew](https://brew.sh/) (run `brew install gdal`
after you get it set up). If you’re having trouble getting GDAL working well a
good backup can be to use docker and the
[osgeo/gdal](https://hub.docker.com/r/osgeo/gdal) package.

To convert to a geopackage run:

```console
ogr2ogr skysat-large.gpkg skysat-large.geojsons
```

The Python program `fio` from
[Fiona](https://fiona.readthedocs.io/en/stable/cli.html) and plugin commands
from the [fio-planet](https://fio-planet.readthedocs.io/en/latest/) package are
another option for converting and manipulating GeoJSON. Fiona and fio-planet
are easy to install alongside the Planet SDK and CLI. The Fiona way to convert
a sequence of GeoJSON features from a search to Geopackage is this:

```console
cat skysat-large.geojsons | fio load -f GPKG skysat-large.gpkg
```

##### Simplification with Fiona and fio-planet

There are a number of ways to [simplify areas of
interest](https://fio-planet.readthedocs.io/en/latest/topics/simplification/).
The one that best balances effectiveness with ease of use is the union, or
merger, of concave hulls.

```console
cat skysat-large.geojsons \
| fio map 'concave_hull g :ratio 0.4' --dump-parts \
| fio reduce 'unary_union c' \
| fio load -f GPKG skysat-large-simplified.gpkg
```

The `ratio` parameter describes the desired distance from the `convex_hull`
algorithm. A ratio of 1.0 produces hulls that are the same as convex hulls.
Smaller ratios preserve the character of concave features better.

##### Simplification with OGR

The other thing you’ll likely want to do to visualize large amounts of data is to simplify it
some. Many simplification tools call for a 'tolerance', often set in degrees. For SkySat some useful values are:

| tolerance | result                                                                                                          |
|-----------|-----------------------------------------------------------------------------------------------------------------|
| 0.001     | Mostly removes unnecessary points, visually looks pretty much the same, but much easier for programs to render. |
| 0.01      | Messes with the shape a bit, but the footprint generally looks the same, with a couple vertices off.            |
| 0.1       | Mashes the shape, often into a triangle, but still useful for understanding broad coverage.                     |

It’s worth experimenting with options between these as well. The more simplification the easier it is for programs to
render the results. `ogr2ogr` includes the ability to simplify any output:

```console
ogr2ogr skysat-large.gpkg skysat-large.json -simplify .008
```

Alternative - use convex hull. TODO: test this, write it up

```console
ogr2ogr skysat-convex.gpkg skysat.geojson ogr2ogr -sql "select st_convexhull(geometry) from skysat" -dialect sqlite
```

Other alternative for really big ones, centroid. GDAL should be able to do this, need to figure out the similar
sql.

#### Simplification with Mapshaper

Another great tool is [Mapshaper](https://github.com/mbloch/mapshaper), which excels at simplification. It offers a
web-based user interface to see the results of simplification, and also a command-line tool you can use if you
find a simplification percentage you’re happy with. After you get it
[installed](https://github.com/mbloch/mapshaper#installation) you can fire up the UI with:

```console
mapshaper-gui skysat-large.geojson
```

(TODO: Show animated gif of recording)

It’s easy to get a sense of how much simplification affects the shape. You can download the output from the web
interface, or you can also run the command-line program:

```console
mapshaper -i footprints.geojson -simplify 15% -o simplified.geojson
```

Once you find a simplification amount you’re happy with you can use it as a piped output.

```console
planet data search --limit 20 SkySatCollect - | planet collect - | mapshaper -i - -simplify 15% -o skysat-ms2.geojson
```

Mapshaper also has more simplification algorithms to try out, so we recommend diving into the
[CLI options](https://github.com/mbloch/mapshaper/wiki/Command-Reference).

#### Simplification with QGIS

Another good tool for simplification is QGIS.

TODO: Flesh out this section, add in command-line qgis_processing option.

Other simplification options for large datasets:

* Use QGIS, run 'convex hull' (Vector -> Geoprocessing -> Convex Hull). Good idea to convert to gpkg or shapefile before you open in qgis if large.

### Advanced jq

- do a limit 0 (unlimited) on a constrained search (geom and time range) with jq count to see how many scenes are in the area
 (note you can also do `stats`)

- get id by array number

```console
planet orders list | jq -rs '.[3] | "\(.id) \(.created_on) \(.name) \(.state)"'
```
(limit can get the most recent, but not a second or third)

* Use jq to show just orders that have a given item type, like just skysat.

```console
planet orders list | jq -rs '.[] | "\(.id) \(.created_on) \(.state) \(.products[0].item_type)"'
```

will show the item type https://gist.github.com/ipbastola/2c955d8bf2e96f9b1077b15f995bdae3 has ideas for contains, but haven't got it right yet

* use jq to get the id of the an order by it’s name

* get total number of items, add up each year of `stats`

### Simplify Geometries to 500 vertices

One of the limits of Planet’s API’s is that they demand geometries have less than 500 vertices. This section shows some
tools that can help you to do that simplification.

TODO: flesh these out.

#### Mapshaper

- simplify CLI
- simplify UI, download and use
- count number of resulting vertices
`ogrinfo -al simplify_test.geojson | grep POLYGON | sed 's/$/,/' | tr -d -c "," | wc`
But there should be a JQ way to do the same...

#### Placemark

- see count of vertices
- union together
- buffer and union
- simplify

# Planet CLI Interface

## Introduction

This document serves as the root document to outline the Command-Line Interface
(CLI). It includes the interface for the 'base' and 'auth' commands as well as
helper commands. and then links to other documents for orders, data and 
subscriptions. 

### CLI Sections

* [CLI Base](#cli-base)
* [Authentication](#authentication)
* [Helper](#Helper)
* [Orders](CLI-Orders.md)
* [Data](CLI-Data.md)
* [Subscriptions](CLI-Subscriptions.md)

## CLI Base

### General Interface

```
Usage: `planet [OPTIONS] COMMAND [ARGS]...`

 Planet Command Line Interface

Options:
  --verbosity [warning|info|debug|none]
                                  Logging verbosity level.
  --quiet                         Disable all reporting.
  --version                       Show the version and exit.
  --help                          Show this message and exit.

Commands:
  auth    Commands for working with Planet authentication
  data    Commands for interacting with the Data API
  orders  Commands for interacting with the Orders API
```

### Options

#### Verbosity

User Story: As a CLI user I would like to adjust the verbosity between warning, info, debug, and disabled.

Report warning logging (default)

`$ planet <command>`

Report info+ logging

`$ planet --verbosity info <command>`

Report debug+ logging

`$ planet --verbosity debug <command>`

Disable logging

$ `planet --verbosity none <command>`

#### Quiet

User Story: As a CLI user I would like to disable all reporting because I am using the CLI within a script.

$ `planet --quiet <command>`

## Authentication

### Group Interface

```
Usage: planet auth [OPTIONS] COMMAND [ARGS]...

  Commands for working with Planet authentication

Options:
  --help           Show this message and exit.

Commands:
  list       List authorization accounts
  login      Obtain and store authorization credentials
  login-key  Obtain and store api key authorization credentials
  print-key  Print the stored api key
```

### login-key [?]

NOTE: --account support is post-initial release


Logistics: The user is prompted for email and password (hidden) in the shell. 
The api key is downloaded and stored in a local secret file.

#### Interface

```
Usage: planet auth login-key [OPTIONS]

  Obtain and store api key authorization credentials

  If --account is specified, the active account is switched to the specified
  account. If valid credentials already exist for the account, the account is
  set to active without rerunning authorization.

Options:
  --account TEXT  Identifier for authorization account.
  --help          Show this message and exit.
```

#### Usage Examples

User Story: As a CLI user I would like to obtain and store my api key for authorization.

`$ planet auth login-key`

email:

Password:

Authorized

### print-key

#### Interface

```
Usage: planet auth print-key [OPTIONS]

  Print the stored api key.

  Returns nothing if no api key is stored.

Options:

  --help  Show this message and exit.
```

### store-key

#### Interface

```
Usage: planet auth store-key [OPTIONS]

  Store authorization API key.

  The API key can be obtained from the Planet account page at https://www.planet.com/account.

Options:
  --help  Show this message and exit.
```

## Helper

These commands are utility functions that assist in other functions in the CLI.

### Collect

#### Interface

```
planet collect SEQUENCE

Collect a sequence of JSON into a JSON blob. If the sequence is GeojSON, create a FeatureCollection.

Arguments:
SEQUENCE - sequence of JSON blobs.

Options:
--pretty - flag. Pretty-print output
```

#### Usage Examples

User Story: As a CLI user I want to create a FeatureCollection of PSScene 
scenes that intersect an AOI and were acquired in July 2021 .

```
$ planet data filter \
--geom aoi.geojson \
--date-range acquired gte 2021-07-01 \
--date-range acquired lt 2021-08-01 | \
planet data search-quick PSScene - | planet collect
{"type": "FeatureCollection", "features" [...]}
```

---
title: Async SDK User Guide
---

This guide is for the Planet Async SDK for Python users who want to use asynchronous Python code to search, order, customize, and deliver Planet imagery and data. If you’re new to Python, you may want to choose the no-code option of using the [command-line interface (CLI)](../../cli/cli-guide), or the non-async [Planet Python SDK](./sdk-guide.md). If you're ready to get started using Planet data in your asyncio-based applications, read ahead.

This guide walks you through the steps:

* **[Authenticate](#authenticate-with-planet-services)**—pass your username and password to Planet services to verify your permissions to data.
* **[Create a session](#create-a-session)**—set up a context for calling on Planet servers and receiving data back.
* **[Create an order](#create-an-order)**—build an orders client, send the request within the session context, and download it when it’s ready.
* **[Collect and list data](#collecting-results)**—handle the potentially large number of results from a search for imagery.
* **[Query the data catalog](#query-the-data-catalog)**—search the catalog based on a filter, activate the assets you want, and download and validate it when it’s ready.

## Install the Planet Python SDK

Use a package manager (such as `pip`) to install the Planet Python SDK:

```sh
pip install planet
```

## Authenticate with Planet services

An SDK `Session` requires authentication to communicate with Planet services. This
authentication information is retrieved when a `Session` is created. By default,
a `Session` retrieves authorization key from the environment variable `PL_API_KEY` or a secret file, in that order of priority.

The SDK provides the `auth.Auth` class for managing authentication information.
This module can be used to obtain authentication information from the username
and password with `Auth.from_login()`. Additionally, it can be created with
the API key obtained directly from the Planet account site with `Auth.from_key(<API_KEY>)`.

Once you have provided the authentication information (in other words, the username and API key), it can be accessed by way of the `Auth.value`. The most convenient way of managing it for local use is to write it to a secret file using `Auth.write()`. For example, to obtain and store authentication information:

Once you have provided the authentication information (in other words, the account username and password), it can be accessed by way of `Auth.value`. The most convenient way of managing it for local use is to write it to a secret file using `Auth.write()`.
It can also be accessed, for example, to store in an environment variable, such as
`Auth.value`.

Here is an example of retrieving and storing authentication information:

```python
# Get the user account name and password
# from the command line and environment,
# and store credentials in an Auth object
import getpass
from planet import Auth

user = input("Username: ")
pw = getpass.getpass()
auth = Auth.from_login(user,pw)
auth.store()
```

The default authentication behavior of the `Session` can be modified by specifying
`Auth` explicitly using the methods `Auth.from_file()` and `Auth.from_env()`.
While `Auth.from_key()` and `Auth.from_login` can be used, it is recommended
that those functions be used in authentication initialization. Authentication
information should be stored using `Auth.store()`.

You can customize the manner of retrieval and location to read from when retrieving the authorization information. The file and environment variable read from can be customized in the respective functions. For example, authentication can be read from a custom
environment variable, as in the following code:

```python
import asyncio
import os
from planet import Auth, Session

auth = Auth.from_env('ALTERNATE_VAR')
async def main():
    async with Session(auth=auth) as sess:
        # perform operations here
        pass

asyncio.run(main())

```

## Create your first session

Communication with the Planet services is provided by way of the `Session` class. The `Session` class automatically implements rate limiting that allows for smooth asynchronous communication with Planet servers. Note that this rate-limiting only works when one `Session` is being used. Employing multiple sessions will cause the rate-limiting to be bypassed and can cause collisions.

To use `Session`, it’s recommended to use it as a context manager. In this way, your session is clearly defined and is handled as part of the context. For example, the context manager handles automatic cleanup of connections when the context is left, such as when an exception occurs.

```python
import asyncio
import os
from planet import Session

async def main():
    async with Session() as sess:
        # perform operations here
        pass

asyncio.run(main())
```

Alternatively, you may need to manually manage the lifecycle of the session, for example to reuse it across multiple asynchronous functions. In this case, you may consider using `await Session.aclose()` and close that `Session` explicitly:

```python
async def main():
    sess = Session()
    # perform operations here
    await sess.aclose()

asyncio.run(main())
```

### Use asyncio to order Planet data

As noted above, to ensure your session is properly managed and cleaned up when it’s no longer needed, create a session using the `Session` class and use it as a context manager.

The proper implementation of the `Session` class:

* uses it as a context manager, with rate limiting which allows for smooth asynchronous communication with Planet servers
* works with one `Session` at a time—multiple sessions bypass rate-limiting and can cause collisions

!!!warning "Caution"
    Do not use multiple `Sessions` as it can cause collisions and bypass rate-limiting.

For an example of using `asyncio` to order Planet data with a rate-limited session, you can see in the <a href="https://github.com/planetlabs/planet-client-python/blob/main/examples/orders_create_and_download_multiple_orders.py" target="_blank">Create and download multiple orders</a> example. The main function in that example creates a client session and pulls in multiple request objects (an area of interest in Iowa and another in Oregon that were created in a `create_requests()` function). The requests are dynamically generated and queued. Finally, orders are delivered into your preferred location (using a `create_and_download()` function).

```python
import asyncio
import os

import planet
.
.
.
async def main():
    async with planet.Session() as sess:
        client = sess.client('orders')

        requests = create_requests()

        await asyncio.gather(*[
            create_and_download(client, request, DOWNLOAD_DIR)
            for request in requests
        ])


if __name__ == '__main__':
    asyncio.run(main())
```

## Create an order

The Orders Client mostly mirrors the [Planet Orders API](https://developers.planet.com/docs/orders/reference/#tag/Orders). This SDK provides additional abilities, for example to poll for order completion and to download an entire order.

### Create an order request

As a first step in ordering, you create an order request object. This request object is transmitted to the Planet service as a JSON object. The SDK provides a way for you to build up that object: `planet.order_request.build_request()`. The following code returns an order request object, with the values you’ve provided for:

* a name for your order
* what product to order—in this example, `PSScene` items with `analytic_udm2` product bundle asset types
* what tools to use—here, the clip tool with the area of interest (AOI) to clip within

```python
def create_request():
    # This is your area of interest for the Orders clipping tool
    oregon_aoi = {
       "type":
       "Polygon",
       "coordinates": [[[-117.558734, 45.229745], [-117.452447, 45.229745],
                        [-117.452447, 45.301865], [-117.558734, 45.301865],
                        [-117.558734, 45.229745]]]
   }

   # In practice, you will use a Data API search to find items, but
   # for this example take them as given.
   oregon_items = ['20200909_182525_1014', '20200909_182524_1014']

   oregon_order = planet.order_request.build_request(
       name='oregon_order',
       products=[
           planet.order_request.product(item_ids=oregon_items,
                                        product_bundle='analytic_8b_udm2',
                                        item_type='PSScene'
                                        fallback_bundle='analytic_udm2,analytic_3b_udm2')
       ],
       tools=[planet.order_request.clip_tool(aoi=oregon_aoi)])

   return oregon_order
```

This would be equivalent to a manually created JSON object with the following description:

```json
{
   "name":"oregon_order”,
   "products":[
      {
         "Item_ids":["20200909_182525_1014",
                     "20200909_182524_1014"],
         "item_type":"PSScene",
         "product_bundle":"analytic_8b_udm2,analytic_udm2,analytic_3b_udm2"
      }
   ],
  "tools": [
    {
      "clip": {
        "aoi": {
          "type": "Polygon",
          "coordinates": [
            [[-117.558734, 45.229745], [-117.452447, 45.229745],
             [-117.452447, 45.301865], [-117.558734, 45.301865],
             [-117.558734, 45.229745]]
          ]
        }
      }
    }
  ]
}
```

Once the order request is built, create an order within the context of a `Session` with the `OrdersClient` `create_order()` function and pass the order request object in:

```python
async def main():
    async with Session() as sess:
        cl = sess.client('orders')
        order = await cl.create_order(request)

asyncio.run(main())

```

So given the order object created with the call to `create_request()`, [above](#create-an-order-request), the following code creates an Orders API client and uses that client to create and order.

```python
async def main():
    # Create a session and client
    # The Orders API client is also a subclass of the Session
    # class, so it has all the same methods.
    async with planet.Session() as sess:

        # 'orders' is the service name for the Orders API.
        cl = sess.client('orders')

        request = create_request()
        order = await cl.create_order(request)
```

If you run the code now, it appears as if nothing happens, because the order is being created and more importantly because you haven’t described where the order should be delivered to.

At this point, you can go into your account dashboard and select My Orders to see the order. And if the order is finished, you can select “download” (the default delivery mechanism) to view the order, see a preview of the clipping tool, and download the assets.

But of course, the point is to use the SDK to also deliver the ordered assets to a specified location automatically, which the next section describes.

### Waiting and downloading an order

After creating an order client, there is typically a waiting period before the assets can be downloaded. During this time, the order is being processed and customized according to the specifications provided in the order request. To monitor the progress of the order creation process and determine when the assets are ready for download, you can use the wait method provided by the Orders API client.

With wait and download, it is often desired to track progress as these
processes can take a long time. To track the progress of the order, the following example code uses a progress bar from the reporting module to report the wait status. The `download_order` method has built-in reporting capabilities, so we don’t need to use a progress bar for the download process.

```python
from planet import reporting

async def create_wait_and_download():
    async with Session() as sess:
        cl = sess.client('orders')
        with reporting.StateBar(state='creating') as bar:
            # create order
            order = await cl.create_order(request)
            bar.update(state='created', order_id=order['id'])

            # poll
            await cl.wait(order['id'], callback=bar.update_state)

        # download
        await cl.download_order(order['id'])

asyncio.run(create_poll_and_download())
```

Following on the the request object you created with the `create_request()`, [above](#create-an-order-request), the following function provides the status as you wait for the file to be downloaded to the current directory:

```python
async def create_and_download(client, order_detail, directory):
   with planet.reporting.StateBar(state='creating') as reporter:
       order = await client.create_order(order_detail)
       reporter.update(state='created', order_id=order['id'])
       await client.wait(order['id'], callback=reporter.update_state)

   await client.download_order(order['id'], directory, progress_bar=True)

async def main():
   async with planet.Session() as sess:
       cl = sess.client('orders')

       # Create the order request
       request = create_request()

       # Create and download the order
       order = await create_and_download(cl, request, DOWNLOAD_DIR)
```

Now, instead of going to your account dashboard to see the order request running, you can see the status as output on your output. For example:

```console
02:06 - order [id number] - state: running
```

And when your order is ready, it will download into the current directory, while writing status to the output:

```console
order-id/PSScene/20200909_182524_1014_metadata.json: 100%|█| 0.00k/0.00k [0
order-id/PSScene/20200909_182524_1014_3B_AnalyticMS_metadata_clip.xml: 100%
order-id/PSScene/20200909_182524_1014_3B_udm2_clip.tif: 100%|█| 0.55k/0.55k
order-id/PSScene/20200909_182524_1014_3B_AnalyticMS_clip.tif: 100%|█| 25.5k
order-id/PSScene/20200909_182525_1014_metadata.json: 100%|█| 0.00k/0.00k [0
order-id/PSScene/20200909_182525_1014_3B_AnalyticMS_metadata_clip.xml: 100%
order-id/PSScene/20200909_182525_1014_3B_udm2_clip.tif: 100%|█| 0.52k/0.52k
order-id/PSScene/20200909_182525_1014_3B_AnalyticMS_clip.tif: 100%|█| 27.1k
order-id/manifest.json: 100%|██████████| 0.00k/0.00k [00:00<00:00, 788kB/s]
```

### Validating checksums

Checksum validation provides for verification that the files in an order have
been downloaded successfully and are not missing, corrupted, or changed. This
functionality is included in the OrderClient, but does not require an instance
of the class to be used.

To perform checksum validation:

```python
from pathlib import Path

# path includes order id
order_path = Path('193e5bd1-dedc-4c65-a539-6bc70e55d928')
OrdersClient.validate_checksum(order_path, 'md5')
```

## Collecting results

Some API calls, such as searching for imagery and listing orders, return a
varying, and potentially large, number of results. These API responses are
paged. The SDK manages paging internally and the associated client commands
return an asynchronous iterator over the results. These results can be
converted to a JSON blob using the `collect` command. When the results
represent GeoJSON features, the JSON blob is a GeoJSON FeatureCollection.
Otherwise, the JSON blob is a list of the individual results.

```python
import asyncio
from planet import collect, Session

async def main():
    async with Session() as sess:
        client = sess.client('orders')
        orders_list = collect(client.list_orders())

asyncio.run(main())

```

Alternatively, these results can be converted to a list directly with

```python
orders_list = [o async for o in client.list_orders()]
```

## Query the data catalog

The Data Client mostly mirrors the
[Data API](https://developers.planet.com/docs/apis/data/reference/),
with the only difference being the addition of functionality to activate an
asset, poll for when activation is complete, and download the asset.

```python
async def main():
    async with Session() as sess:
        client = sess.client('data')
        # perform operations here

asyncio.run(main())
```

### Filter

When performing a quick search, creating or updating a saved search, or
requesting stats, the data search filter must be provided to the API
as a JSON blob. This JSON blob can be built up manually or by using the
`data_filter` module.

An example of creating the request JSON with `data_filter`:

```python
from datetime import datetime
from planet import data_filter
sfilter = data_filter.and_filter([
    data_filter.permission_filter(),
    data_filter.date_range_filter('acquired', gt=datetime(2022, 6, 1, 1))
])
```

The same thing, expressed as a `JSON` blob:

```python
sfilter = {
    'type': 'AndFilter',
    'config': [
        {'type': 'PermissionFilter', 'config': ['assets:download']},
        {
            'type': 'DateRangeFilter',
            'field_name': 'acquired',
            'config': {'gt': '2022-06-01T01:00:00Z'}
        }
    ]
}
```

Once the filter is built up, performing a search is done within
the context of a `Session` with the `DataClient`:

```python
async def main():
    async with Session() as sess:
        cl = sess.client('data')
        items = [i async for i in cl.search(['PSScene'], sfilter)]

asyncio.run(main())
```

### Downloading an asset

Downloading an asset is a multi-step process involving: activating the asset,
waiting for the asset to be active, downloading the asset, and, optionally,
validating the downloaded file.

With wait and download, it is often desired to track progress as these
processes can take a long time. Therefore, in this example, we use a simple
print command to report wait status. `download_asset` has reporting built in.

```python
async def download_and_validate():
    async with Session() as sess:
        cl = sess.client('data')

        # get asset description
        item_type_id = 'PSScene'
        item_id = '20221003_002705_38_2461'
        asset_type_id = 'ortho_analytic_4b'
        asset = await cl.get_asset(item_type_id, item_id, asset_type_id)

        # activate asset
        await cl.activate_asset(asset)

        # wait for asset to become active
        asset = await cl.wait_asset(asset, callback=print)

        # download asset
        path = await cl.download_asset(asset)

        # validate download file
        cl.validate_checksum(asset, path)
```

### Features API Collections and Features

The Python SDK now supports Features API Collections and Features (note: in the SDK and API, Features are often referred to as items in a collection).

Collections and Features/items that you create in in the SDK will be visible in Features API and Features Manager.

#### Creating a collection

You can use the Python SDK to create Features API collections.

```python
async with Session() as sess:
  client = FeaturesClient(sess)
  new_collection = await client.create_collection(title="my collection", description="a new collection")
```

#### Listing collections

```python
async with Session() as sess:
  client = FeaturesClient(sess)
  collections = client.list_collections()
  async for collection in collections:
    print(collection)
```

#### Listing features/items in a collection

```python
async with Session() as sess:
  client = FeaturesClient(sess)
  items = client.list_items(collection_id)
  async for item in items:
    print(items)
```

#### Using items as geometries for other methods

You can pass collection items/features directly to other SDK methods. Any method that requires a geometry will accept
a Features API Feature.

```python
async with Session() as sess:
  client = FeaturesClient(sess)
  items = client.list_items(collection_id)
  example_feature = await anext(items)

  data_client = DataClient(sess)
  results = data_client.search(["PSScene"], geometry=example_feature, limit=1)
  async for result in results:
    print(result)
```

## API Exceptions

When errors occur, the Planet SDK for Python exception hierarchy is as follows:

* All exceptions inherit from the base exception called `PlanetError`.
* Client-side errors are raised as `ClientError`.
* Server-side errors are raised as specific exceptions based on the http code. These specific exceptions all inherit from `APIError`  and contain the original error message returned by the server.

---
title: Get Your Planet Account
---

Whenever you use the Planet SDK for Python to connect to Planet’s APIs, you’ll need to authenticate with the Planet server. To do so, you need a Planet account with your own username and password.

## Confirm your Planet account

### Sign on to Planet Explorer

If you go to <a href="https://www.planet.com/explorer/#" target="_blank" >Planet Explorer</a>, and you have an account, you’ll be prompted to enter your account username and password. That’s the same username and password you’ll use to authenticate with the Planet servers, here.

Once in Explorer, you can select the user icon in the upper right corner to go to your Account page:

<img src="../images/my-account-in-planet-explorer.png"
     style="
     display: block;
     margin-left: auto;
     margin-right: auto;
     width:50%;
     "
     alt="My Account Icon in Planet Explorer" >

### Sign up for the Planet Developer Program

If you don’t have an account, but you’d like to take our APIs for a spin and see how you might intergrate Planet into your existing geospatial workflows, you can sign up for the <a href="https://developers.planet.com/devtrial/" target="_blank">Developer Program</a>.

## Authenticating with the Planet server

After you’ve installed the Planet SDK, you can authenticate with the Planet server as outlined in the [No-Code CLI Guide](../../cli/cli-guide/#authentication)

## Next steps

Now that you have confirmed your Planet account username and password, you can take the other steps in the [Quick Start](../quick-start-guide).

# Content Plan Planet SDK (v2)

This document is a response to the issue #353: Quantify 'accurate and complete documentation' required for initial release. After a review of existing content, the following recommendations have been accepted as part of the V2 release. Documentation tickets will be derived from the recommendations, below.

## Overview

The list of documentation issues for this project can be found at: [https://github.com/planetlabs/planet-client-python/labels/documentation](https://github.com/planetlabs/planet-client-python/labels/documentation)


For a complete list of the project board, source, and current documentation builds, see [SDK Source & Docs in References](#SDK-Source-and-Docs).

# Planned Documentation Updates

## A note regarding location of qualification documentation:

The SDK and CLI are low-level interfaces mirroring much of the API, itself. While this documentation should make it easy for developers to use the SDK and CLI, core Planet API concepts, clarifying content, and considerations might be better located in the core API documentation on [Planet](https://developers.planet.com/docs/apis/), and then linked to from content produced here.

## SSoT

We are currently publishing documentation on [planet.com](https://developers.planet.com/docs/pythonclient/), [github.io](https://planetlabs.github.io/planet-client-python/index.html), [github wiki](https://github.com/planetlabs/planet-client-python/wiki), and on [readthedocs.com](https://planet-sdk-for-python.readthedocs.io/en/latest/). Providing a single source of truth (SSoT) ensures one definitive source of documentation, reducing the dilution of information, errors, and maintenance efforts.

### Ticket to be filed

Implement mkdocs to leverage features of readthedocs.com, but publish only on one platform. This would be planet.com unless we are making a concerted effort to recruit 3rd party contributors to the SDK, in which case, it could stay on readthedocs.com. So the publication landscape would be as follows:

* Publish the SDK V2 documentation on readthedocs.com.
* Do not mirror the SDK V2 documentation on developers.planet.com.
* End-of-life the GitHub wiki content for V2, and rely on the readme, the contributing, the changes, and the published documentation to convey information published at the wiki in 2017.
* End-of-life the github.io channel for V2, and rely on readthedocs.com as the single source of truth.

If V1 and V2 are supported at the same time, they need to be clearly demarcated, published relative to each other, and referring to each other at the page level.

Request design assets, including “open-source” design brief, or at least colors and fonts.

## Getting started experience

The SDK and CLI technical user may not have developer experience and are unfamiliar with SDKs and CLIs. A getting started experience would help them set up their environment more efficiently.

### Ticket to be filed

Provide a getting started experience that presumes the user has not used an SDK or CLI before.

Provide a relational visualization (e.g.: a dashboard of sorts) of the SDK, CLI, and API, and link to the landing page for each.

Platform overview documentation should be created on the DevCenter to explain the SDK and CLI in the context of the other Planet offerings, within the Planet platform. (This is an internal ticket on developers.planet.com, not the SDK GitHub project issues list.) The SDK should reference this overview.

## Code snippets

For the sake of this document, a code snippet is a block of code in the documentation that provides a code example of how to use the command being documented. A code snippet is not the output of the source code in the SDK. A code snippet for the SDK is not the CLI string.

### Ticket to be filed

Provide a code snippet for each call, using real-life terms (i.e., not foo & bar).

Provide a CLI cheat sheet (separate from the SDK) with examples using real-life terms. (See, for example, [The gcloud CLI cheat sheet](https://cloud.google.com/sdk/docs/cheatsheet).)

## Code samples

For the sake of this document, a code sample is a block of code that combines more than one SDK call to accomplish a task that would most likely be used in real life.

### Ticket to be filed

For every significant user story or user workflow, create a code sample. This sample could be at the bottom of each SDK section, implementing a useful group of features described above.

## Code running reference

A reference implementation is essential for creating working code snippets and samples.

### Ticket to be filed

A reference implementation of the SDK and CLI needs to be created and placed into source control.

Automated triggers should ensure the update of this implementation against the latest SDK and CLI changes.

Automated testing will prevent code from falling.

## Features list (architectural decisions & capabilities)

A new user would get context from a picture of the relationship between the core Planet API, and the SDK and the CLI.

### Ticket to be filed

Describe the architecture to the extent it’s helpful to the user, and from the user’s perspective. Explain what capabilities we’re providing in the SDK & CLI. For example:

The SDK and CLI provide low-level clients to the core Planet APIs, with a one-to-one match between function calls and API endpoints. The SDK and CLI also provide:

* Retry logic
* Some pre-validation of inputs
* Helper functions for creating JSON request arrays
* Some state management
* Managing paged responses
* Download file checksum validation

## Considerations section (like tips, but more)

Developers who are asked to implement a programmatic solution may not have experience with GIS workflows and formats. As noted above, might be better located in the core API documentation, and possibly linked from the SDK and CLI documentation. For example:

### Ticket to be filed

Add a considerations section to the documentation, either to the getting started experience or in context, that calls out useful tips and preparatory steps needed for success.

!!!note Consideration
    Orders records are kept for 90 days. After that, you'll need to work with support to retrieve older orders.

## readme.rst

The [current readme file](https://github.com/planetlabs/planet-client-python%23readme) follows industry standards and is adequate.

### Ticket to be filed

As more introductory documentation is created, it would be best to update the links in this document, with care to call out any getting started experience as well as the documentation.

A more awesome readme is possible. See a list of examples in the References section, Awesome readmes, below.

## changes.txt

The [current changes.txt](https://github.com/planetlabs/planet-client-python/blob/main/CHANGES.txt) follows industry standards and is adquate.

## contributing.md

The [current contributing.md](https://github.com/planetlabs/planet-client-python/blob/v2/CONTRIBUTING.md) file provides information about how to load the development environment. It does not provide any guidance on who might contribute or how to get involved.

This document explains how to generate a local environment and documentation, but does not provide the final locations of the builds and does not instruct on how to view the documentation.

### Ticket to be filed

Update the contributing.md file with end-to-end steps to build, change, test, and view documentation.

## GitHub wiki

The [wiki for the GitHub project](https://github.com/planetlabs/planet-client-python/wiki) has not been updated since 2017. It appears to be a getting-started guide.

### Ticket to be filed

Delete wiki content and do not use the wiki.

## Global content

Versioning, date|time stamp, licensing, privacy, security, and global navigation terms and titles should have their own review and update.

On the mkdocs version of the library:

* The versioning on the [early access V2 documentation](https://planet-sdk-for-python.readthedocs.io/en/latest/upgrading/) is wrong.
* There is no date|time stamp on the documentation releases.
* There is no copyright date on the documentation.
* There is no licensing documentation.
* There are no security & privacy links.

### Ticket to be filed

* Consider versioning a part of branding. Establish a versioning schema that works hand-in-hand with the name brand.
* Do not expose development version schemas if they confuse or contradict the brand versioning.
* Include a copyright and date|time stamp on the documentation, which can help situate the reader and provide maintenance information.
* Correct the versioning on the [early access V2 documentation](https://planet-sdk-for-python.readthedocs.io/en/latest/upgrading/) at the earliest possible time.
* Add pointers to licensing, security & privacy docs.

## Cost difference between API & SDK call
Are there any batch calls or “quick” calls that could inadvertently incur costs?

### Ticket to be filed

Call out what costs are being generated by using the SDK against the account in a considerations section.

Recommendations for batch & bulk routines.

Calls will hit the quotas, just like the APIs.

## Feedback & analytics

As this is an open source project living on GitHub, issues can be used to track user feedback.

### Ticket to be filed

Link to issues from documentation to encourage users to engage with the development team.

Consider messaging in the CLI that points to the feedback channel, such as GitHub issues and [discussions](https://docs.github.com/en/discussions).

## MkDocs plugins

Documentation components may be derived from source using MkDocs.

### Ticket to be filed

Investigate using MkDocs plugin to generate code snippets (defined above) from folder within the source or

Investigate using MkDocs plugin to derive changes.txt items.


# References
### Designs and Drafts

[design.md](https://github.com/planetlabs/planet-client-python/commit/c07afb1203d9ed0951b4cd33ef084c119f6740a9)

### Published

[Readme](https://github.com/planetlabs/planet-client-python/tree/ef8a27178d21316256ef8a5de6ee6d0758be981c%23readme)

[GitHub Wiki](https://github.com/planetlabs/planet-client-python/wiki)

[SDK Devcenter landing page](https://developers.planet.com/open/)

[planet · PyPI](https://pypi.org/project/planet/)

#### SDK Source and Docs

#### Issues & project sprints

[https://github.com/planetlabs/planet-client-python/projects/2](https://github.com/planetlabs/planet-client-python/projects/2)

[Documentation issues](https://github.com/planetlabs/planet-client-python/issues?q%3Dis%253Aissue%2Bis%253Aopen%2Blabel%253Adocumentation)

#### V2 team code source branch

[https://github.com/planetlabs/planet-client-python/](https://github.com/planetlabs/planet-client-python/)

#### Current V2 docs (erroneously tagged V1.4.9)
[https://planet-sdk-for-python.readthedocs.io/en/latest/](https://planet-sdk-for-python.readthedocs.io/en/latest)

#### Current V1.4.9 docs
[https://developers.planet.com/docs/pythonclient/](https://developers.planet.com/docs/pythonclient/)

and

[https://planetlabs.github.io/planet-client-python/index.html](https://planetlabs.github.io/planet-client-python/index.html)

#### Current V1.4.9 docs source
[https://github.com/planetlabs/planet-client-python/tree/master/docs](https://github.com/planetlabs/planet-client-python/tree/master/docs)

and

[https://github.com/planetlabs/planet-client-python//docs](https://github.com/planetlabs/planet-client-python//docs)

## GitHub flavored markdown

This document was created using [GitHub flavored markdown](https://docs.github.com/en/get-started/writing-on-github/getting-started-with-writing-and-formatting-on-github/basic-writing-and-formatting-syntax#GitHub-flavored-markdown)

---
title: Upgrade from Version 1 to Version 2
---

The Planet SDK for Python is Version 2 of what was previously referred to as the Planet API client. This V2 is a major update of the V1 SDK. As such, there are major structural changes to how it operates. However, many aspects are still quite similar to V1. Follow this migration guide to upgrade an application developed with V1 of the SDK to V2 with minimal fuss.

## Imports

The V2 SDK has a flatter code structure. Everything of note previously found under `planet.api` is now available from the `planet` module. So, `import planet` should give you everything you need.

If you are migrating from V1, and are using the Data API filter builder (from `planet.api import filters`), we do recommend also including `from planet import data_filter as filters` in your imports for an easy migration from the old filter module to the new one.

## Authentication

If you have your API key stored in the `PL_API_KEY` environment variable you will be automatically authenticated to the V2 API, similar to how V1 worked. For other methods for authenticating against the V2 SDK, check out [Authenticate with the Planet server](quick-start-guide/#authenticate-with-the-planet-server).

## Session for all communication

In Version 2, sessions are used to manage all communication with the Planet APIs. This provides for multiple asynchronous connections. For each API, there is a specific client object. This client manages polling and downloading, along with any other capabilities provided by the API.

Each client now requires a `Session` object, which stores connection information and authentication and manages an HTTP connection pool.

The best way of doing this is wrapping any code that invokes a client class in a block like so:

```python
from planet import OrdersClient, Session

async with Session() as session:
    client = OrdersClient(session)
    result = await client.create_order(order)
# Process result
```

You will see this usage in the project’s tests and in the `planet.cli`
package. As a convenience, you may also get a service client instance from a
session’s `client()` method.

```python
async with Session() as session:
    client = session.client('orders')
    result = await client.create_order(order)
# Process result
```

For more information about Session, refer to the [Python SDK User Guide](../../python/sdk-guide/#session).

## Asynchronous Methods

With the V1 client, all communication was synchronous. Asynchronous bulk support was provided with the `downloader` module. There was no built-in support for polling when an order was ready to download or tracking when an order was downloaded.

In V2, all `*Client` methods (for example, `DataClient().search`, `OrderClient().create_order`) are asynchronous. Any functions that call such methods must include `async` in their definition. To invoke asynchronous methods from synchronous code, you can wrap the async method calls in `asyncio.run()`. The following is an example of using async with session.

```python
import asyncio
from datetime import datetime
from planet import Session
from planet import data_filter as filters
 
async def do_search():
    async with Session() as session:
        client = session.client('data')
        date_filter = filters.date_range_filter('acquired', gte=datetime.fromisoformat("2022-11-18"), lte=datetime.fromisoformat("2022-11-21"))
        cloud_filter = filters.range_filter('cloud_cover', lte=0.1)
        download_filter = filters.permission_filter()
        return [item async for item in client.search(["PSScene"], filters.and_filter([date_filter, cloud_filter, download_filter]))]
 
items = asyncio.run(do_search())
```

For more details on interacting with the asynchronous portions of the SDK, refer to the [Python SDK User Guide](../../python/sdk-guide/#session).

## Data API
The Data API portion of SDK V2 is quite similar to V1, although some filters have been renamed for consistency (also reference the note on imports):

* `date_range` to `date_range_filter`
* `geom_filter` to `geometry_filter`
* `and_filter` and `or_filter` now takes a list of filters instead of multiple arguments, so just wrap the contents in `[]` 
* `permissions_filter` is now split into `permissions_filter` and `asset_filter`, reflecting a recent change in API structure. If you were using this previously, you’ll want to convert the old `permissions_filter` into an `asset_filter` (this also involves changing the filter values, e.g. `assets.ortho_analytic_8b_sr:download` will become `ortho_analytic_8b_sr`) and adding an empty `permissions_filter`.

`filters.build_seach_request` no longer exists, and has instead been integrated into the replacement for `client.quick_seach`. For example:

```python
planet.api.ClientV1().quick_search(filters.build_search_request(all_filters, ["PSScene"]))
```

Is now

```python
async with Session() as session:
    items = [i async for i in session.client('data').search(["PSScene"], all_filters)]
```

## Orders API

The Orders API capabilities in V1 were quite primitive, but those that did exist have been retained in much the same form; `ClientV1().create_order` becomes `OrdersClient(session).create_order`. (As with the `DataClient`, you must also use `async` and `Session` with `OrdersClient`.)

Additionally, there is now also an order builder in `planet.order_request`, similar to the preexisting search filter builder. For more details on this, refer to the [Creating an Order](../../python/sdk-guide/#create-an-order).

---
title: Virtual Environments and the Planet SDK for Python
---

This tutorial is aimed at Planet SDK for Python users who have little or no experience with virtual environments, especially those who want to be early users of v2 of the Planet SDK for Python (and still use v1 while evaluating v2).

A virtual environment is a space you create to pull in the resources you need for a specific project. In Python, virtual environments are used to install tools that work well together in their own isolated area. While you may have Python installed already, this overview focuses on installing a version of Python in a way that ensures you have the right virtual environment for using this Planet SDK. 

Using the default Python installation without a virtual environment is not recommended, because it’s so easy to get a combination of tools installed that don’t work well with each other. The great thing about installing a virtual environment is that if you get a combination of tools that don’t work well together, you can “throw away” that virtual environment and create a new one with a few lines in the terminal.

So while it may feel inconvenient at first, spinning up virtual environments will be your go-to setup step for trying out a new idea, testing a routine, or repeating a process at scale.

## Conda vs venv

There are two main options in the Python world for virtual environments:

* [venv](https://docs.python.org/3/library/venv.html)
* [Conda](https://conda.io)

Both are great options. venv is built into Python (version 3.3 and above), so if you’ve got Python
then it’s already there. Conda does a bit ‘more,’ as venv just works for Python, while Conda
creates virtual environments for all libraries and languages (but was designed for Python). We
recommend venv, as [GDAL](https://gdal.org/), arguably the most useful geospatial command-lines,
can sometimes be a pain with Conda. And our releases are not (yet) targeting Conda packaging.

## venv prerequisites

The main prerequisite for venv is that you have Python 3.3 and above. To check your Python
version type:

```console
 $ python --version
```

 If you installed on Windows or Linux you most likely have Python 3. Mac OS ships by default with
 Python 2, so you’ll need to install Python 3. 

### Installing Python 3 on a Mac

 Our recommended route is to install [homebrew](https://brew.sh/). To do that you just run the 
 following on your command-line:

```console
 $ /bin/bash -c "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/HEAD/install.sh)"
```

After it download and installs you just run:

```console
 $ brew install python
```

That will set up a command called `python3` that you can use to call Python 3.

## Setting your virtual environments

It’s good to read up on how venv works, we recommend 
[this tutorial](https://www.dataquest.io/blog/a-complete-guide-to-python-virtual-environments/)
to get a solid understanding.

To be able to work with both the v1 stable and v2 pre-release we recommend setting up 2 virtual environments. A good place to put them is in a .venv directory. The following commands creates a `.venv` directory at your root, user home directory and then switches into that new directory.

```console
 $ mkdir ~/.venv
 $ cd ~/.venv
```

Then you’ll want to create a venv for v1 and v2.

### Install a virtual environment for version 1 of the SDK

#### Install and activate version 1

First create the v1 virtual environment with:

```console
  $ python3 -m venv ~/.venv/planet-v1
```

Then activate the virtual environment. On a Mac or Linux with, you can do so with the following command:

```console
 $ source ~/.venv/planet-v1/bin/activate
```

Or, on Windows with:

```console
  $ planet-v1\Scripts\activate.bat
```

If you haven’t installed version 1, you can do so with:

```console
  $ pip install planet
```

If you already have v1 of the Planet SDK installed, you can check to see if it’s recognized in your new virtual environment by making a command call to get the version number.

Check the version again to confirm it was installed:

```console
 $ planet --version
```

You should see a number that begins with 1.

!!!note "If a version 1 doesn’t appear"
    If you don’t see a version 1 number, then you may need to adjust your path. If you have trouble getting the version for the Planet SDK v1 that you know you’ve installed, feel free to [discuss with us](https://github.com/planetlabs/planet-client-python/discussions). We can troubleshoot together and then update the steps here.

#### Deactivate version 1

As we mentioned, the point to creating virtual environments is to have a place to install the right packages together. This virtual environment is for version 1 of the SDK. For version 2, we’ll need to set up a separate virtual environment. To do so, we must first deactivate the version 1 virtual environment.

Deactivate the virtual environment you’ve activated with a call to `deactivate`:

```console
 $ deactivate
```

This call takes you out of the virtual environment, back to only your base install.

### Install a virtual environment for version 2 of the SDK

#### Install and activate version 2

Set up a virtual environment for version 2 with the following command line Python call:

```console
 $ python3 -m venv ~/.venv/planet-v2
```

Then activate the virtual environment. On a Mac or Linux with, you can do so with the following command:

```console
 $ source ~/.venv/planet-v2/bin/activate
```

Or, on Windows with:

```console
  $ planet-v2\Scripts\activate.bat
```

Now that your `planet-v2` virtual environment is activated, it’s time to install the Planet SDK for Python! Find instructions on how to do so in the [Quick Start Guide](quick-start-guide.md).

## Working with virtual environments

It’s easy to switch in and out of the virtual environments, just `activate` and `deactivate`. You can 
install additional tools with pip on each. The core directories and files remain the same, so you can 
use both v1 and v2 in the same directory. You can even work with them side by side, just open two 
different terminal windows, and activate v1 in one, and v2 in the other.

You should see a different command-line prompt for each, to easily tell which one you are in:

```console
 $ (planet-v1) user@computer ~ $
 ```

!!!note "This is a Python-specific virtual environment"
    Note that non-Python programs (like from node, or C/C++) will be available in both environments. If you want to manage those in a virtual environment then Conda is the way to go, or even full on [docker](https://www.docker.com/) containers.

# Create a Getting Started Experience (GSX)

We'd like to make sure folks who come to the docs site can get started easily. We'd like them to know how to:

* Get an API key
* Authenticate against the service
* Search and download data using the CLI
* Search and download data using the Python calls
* Find key content and support

# A clear top nav will help with the GSX

## Here are some mockups of the global nav changes:

### Home splash screen

<img src="./img/home_1.png"
     style="
     display: block;
     margin-left: auto;
     margin-right: auto;
     width:50%;
     "
     alt="home mock" >

<img src="./img/home_2.png"
     style="
     display: block;
     margin-left: auto;
     margin-right: auto;
     width:50%;
     "
     alt="home mock" >

<img src="./img/home_3.png"
     style="
     display: block;
     margin-left: auto;
     margin-right: auto;
     width:50%;
     "
     alt="home mock" >

### Getting started landing page

<img src="./img/getting-started-docs.png"
     style="
     display: block;
     margin-left: auto;
     margin-right: auto;
     width:50%;
     "
     alt="Getting started landing page mock" >

### Python landing page

<img src="./img/python-docs.png"
     style="
     display: block;
     margin-left: auto;
     margin-right: auto;
     width:50%;
     "
     alt="Python landing page mock" >

### CLI landing page

<img src="./img/no-code-cli-docs.png"
     style="
     display: block;
     margin-left: auto;
     margin-right: auto;
     width:50%;
     "
     alt="No Code CLI landing page mock" >

### Resources landing page

<img src="./img/resources-docs.png"
     style="
     display: block;
     margin-left: auto;
     margin-right: auto;
     width:50%;
     "
     alt="Resources landing page mock" >

## Add a clear top nav to mkdocs materials using a custom home page

" if the theme.custom_dir configuration value is used in combination with an existing theme, the theme.custom_dir can be used to replace only specific parts of a built-in theme" 

"built-in themes are implemented in a base.html file, which main.html extends"

[mkdocs.org dev-guide themes ](https://www.mkdocs.org/dev-guide/themes/)

### Create a custom theme

1. Create a main jinga template file that is not a child of docs, as in:

```custom_theme/main.html```

2. Add that custom dir to the mkdocs.yml file, under `theme`:

```custom_dir: 'custom_theme/'```

3. Add metadata to docs/index.md:

```
---
title: Title
template: home.html
---
```


### Notes

[Developing Themes : A guide to creating and distributing custom themes.](https://www.mkdocs.org/dev-guide/themes/)

[Steps to creating a similar homepage](https://github.com/squidfunk/mkdocs-material/issues/1996#issuecomment-855086383)

[Template Designer Documentation](https://jinja.palletsprojects.com/en/3.1.x/templates/)


### Open questions

#### will we ever distribute theme? If so, then:

["when a theme is packaged up for distribution, and loaded using the theme.name configuration option, then a mkdocs_theme.yml file is required for the theme."](https://www.mkdocs.org/dev-guide/themes/)

---
title: Resources
---

## Examples

### SDK examples

The following examples were created specifically to show you how to use the SDK and CLI:

* [data_download_multiple_assets.py](https://github.com/planetlabs/planet-client-python/blob/main/examples/data_download_multiple_assets.py) - this Python script orders, activates, and downloads two assets
* [orders_create_and_download_multiple_orders.py](https://github.com/planetlabs/planet-client-python/blob/main/examples/orders_create_and_download_multiple_orders.py) - this Python script creates two orders, each with unique Area of Interest (AoI), preventing a combined download
* [Planet API Python Client](https://github.com/planetlabs/notebooks/blob/master/jupyter-notebooks/data-api-tutorials/planet_python_client_introduction.ipynb) - a Python notebook to introduce Planet’s Data API and the `planet` module
* [Orders API & Planet SDK](https://github.com/planetlabs/notebooks/blob/665f165e59f2c3584976ad2dde569c649e631c0b/jupyter-notebooks/orders_api_tutorials/Planet_SDK_Orders_demo.ipynb) - a Python notebook shows how to get started with Planet SDK and the Orders API.
* [Analysis Ready Data Tutorial Part 1: Introduction and Best Practices](https://github.com/planetlabs/notebooks/blob/6cc220ff6db246353af4798be219ee1fe7e858b0/jupyter-notebooks/analysis-ready-data/ard_1_intro_and_best_practices.ipynb) - this Python notebook uses the SDK to prepare Analysis Ready Data.
* [Analysis Ready Data Tutorial Part 2](https://github.com/planetlabs/notebooks/blob/6cc220ff6db246353af4798be219ee1fe7e858b0/jupyter-notebooks/analysis-ready-data/ard_2_use_case_1.ipynb) - the first use case in this Python notebook leverages the SDK’s `order_request` feature to prepare an NDVI time stack and the second use case visualizes the NDVI imagery.

### Other examples

Besides the SDK-specific examples, above, you can find many examples that show how to access Planet data in the documentation and Planet School at the [Planet Developers Center](https://developers.planet.com).Also, more working examples are on the [Planet Labs Python notebooks](https://github.com/planetlabs/notebooks) on GitHub.

## Planet APIs

This pre-release SDK has implemented interfaces for several Planet APIs. Check out the documentation for the underlying API:

* [Data](https://developers.planet.com/docs/apis/data/)
* [Orders](https://developers.planet.com/apis/orders/)
* [Subscriptions](https://developers.planet.com/docs/subscriptions/)

## Email Developer Relations

We are eager to share this pre-release with you and encourage you to test your workflows rigorously. Based on your feedback, we may roll out additional updates to improve your experience. Besides joining the discussion, and filing issues and pull requests here, feel free to share your general feedback with us at developers@planet.com.
## Contribute to this open source project

To contribute or develop with this library, see
[CONTRIBUTING](https://github.com/planetlabs/planet-client-python/blob/main/CONTRIBUTING.md).

## Build Status

[Planet Software Development Kit (SDK) for Python main branch](https://github.com/planetlabs/planet-client-python)

[![Build Status](https://github.com/planetlabs/planet-client-python/actions/workflows/test.yml/badge.svg)](https://github.com/planetlabs/planet-client-python/actions/workflows/test.yml)

## Version 1 of this SDK

[Version 1 of this SDK](https://github.com/planetlabs/planet-client-python/tree/1.5.2) is significantly different (see the [documentation](https://planet-sdk-for-python.readthedocs.io/en/latest/)). Version 2 is not backward compatible. Make sure to create a separate virtual environment if you need to work with both versions. For more information on how to do this, see the [Virtual Environments and the Planet SDK for Python](https://planet-sdk-for-python-v2.readthedocs.io/en/latest/get-started/venv-tutorial/).

---
title: Planet Client Quick Start
---

The Planet SDK for Python makes it easy to access Planet’s massive repository of satellite imagery and add Planet
data to your data ops workflow.

**Note:** This is the new, non-asyncio client. If you want to take advantage of asyncio, check the [asyncio client quick start guide](quick-start-guide.md).

Your feedback on this version of our client is appreciated. Please raise an issue on [GitHub](https://github.com/planetlabs/planet-client-python/issues) if you encounter any problems.

## Dependencies

This package requires [Python 3.9 or greater](https://python.org/downloads/). A virtual environment is strongly recommended.

You will need your Planet API credentials. You can find your API key in [Planet Explorer](https://planet.com/explorer) under Account Settings.

## Installation

Install from PyPI using pip:

```bash
pip install planet
```

## Usage

### Authentication

Use the `PL_API_KEY` environment variable to authenticate with the Planet API.

```bash
export PL_API_KEY=your_api_key
```

These examples will assume you are using the `PL_API_KEY` environment variable. If you are, you can skip to the next section.

#### Authenticate using the Session class

Alternately, you can also authenticate using the `Session` class:

```python
from planet import Auth, Session, Auth
from planet.auth import APIKeyAuth

pl = Planet(session=Session(auth=APIKeyAuth(key='your_api_key')))
```


### The Planet client

The `Planet` class is the main entry point for the Planet SDK. It provides access to the various APIs available on the Planet platform.

```python
from planet import Planet
pl = Planet()  # automatically detects PL_API_KEY
```

The Planet client has members `data`, `orders`, and `subscriptions`, which allow you to interact with the Data API, Orders API, and Subscriptions API.

### Search

To search for items in the Planet catalog, use the `data.search()` method on the `Planet` client. The return value is an iterator that yields search
results:

```python
from planet import Planet

pl = Planet()
for item in pl.data.search(['PSScene'], limit=5):
    print(item)
```

#### Geometry

Use the `geometry` parameter to filter search results by geometry:

```python
geom = {
  "coordinates": [
    [
      [
        -125.41267816101056,
        46.38901501783491
      ],
      [
        -125.41267816101056,
        41.101114161051015
      ],
      [
        -115.51426167332103,
        41.101114161051015
      ],
      [
        -115.51426167332103,
        46.38901501783491
      ],
      [
        -125.41267816101056,
        46.38901501783491
      ]
    ]
  ],
  "type": "Polygon"
}
for item in pl.data.search(['PSScene'], geometry=geom, limit=5):
    print(item)
```

#### Filters

The Data API allows a wide range of search parameters. Whether using the `.search()` method, or
creating or updating a saved search, or requesting stats, a data search filter
can be provided to the API as a JSON blob. This JSON blob can be built up manually or by using the
`data_filter` module.

An example of creating the request JSON with `data_filter`:

```python
from datetime import datetime
from planet import data_filter

def main():
    pl = Planet()

    sfilter = data_filter.and_filter([
        data_filter.permission_filter(),
        data_filter.date_range_filter('acquired', gt=datetime(2022, 6, 1, 1))
    ])

    for item in pl.data.search(['PSScene'], filter=sfilter, limit=10):
        print(item["id"])
```

This returns scenes acquired after the provided date that you have permission to download using
your plan.

If you prefer to build the JSON blob manually, the above filter would look like this:

```python
sfilter = {
    'type': 'AndFilter',
    'config': [
        {'type': 'PermissionFilter', 'config': ['assets:download']},
        {
            'type': 'DateRangeFilter',
            'field_name': 'acquired',
            'config': {'gt': '2022-06-01T01:00:00Z'}
        }
    ]
}
```

This means that if you already have Data API filters saved as a query, you can copy them directly into the SDK.

### Placing an Order

Once you have a list of scenes you want to download, you can place an order for assets using the Orders API client. Please review
[Items and Assets](https://developers.planet.com/docs/apis/data/items-assets/) in the Developer Center for a refresher on item types
and asset types.

Use the `order_request` module to build an order request, and then use the `orders.create_order()` method to place the order.

Orders take time to process. You can use the `orders.wait()` method to wait for the order to be ready, and then use the `orders.download_order()` method to download the assets.

Warning: running the following code will result in quota usage based on your plan.

```python
from planet import Planet, order_request

def main():
    pl = Planet()
    image_ids = ["20200925_161029_69_2223"]
    request = order_request.build_request(
        name='test_order',
        products=[
           order_request.product(
               item_ids=image_ids,
               product_bundle='analytic_udm2',
               item_type='psscene')
       ]
    )

    order = pl.orders.create_order(request)

    # wait for the order to be ready
    # note: this may take several minutes.
    pl.orders.wait(order['id'])

    pl.orders.download_order(order['id'], overwrite=True)
```

### Creating a subscription

#### Prerequisites

Subscriptions can be delivered to a destination. The following example uses Amazon S3.
You will need your ACCESS_KEY_ID, SECRET_ACCESS_KEY, bucket and region name.

#### Scene subscription

To subscribe to scenes that match a filter, use the `subscription_request` module to build a request, and
pass it to the `subscriptions.create_subscription()` method of the client.

Warning: the following code will create a subscription, consuming quota based on your plan.

```python
from planet.subscription_request import catalog_source, build_request, amazon_s3

source = catalog_source(
    ["PSScene"],
    ["ortho_analytic_4b"],
    geometry={
        "type": "Polygon",
        "coordinates": [
            [
                [37.791595458984375, 14.84923123791421],
                [37.90214538574219, 14.84923123791421],
                [37.90214538574219, 14.945448293647944],
                [37.791595458984375, 14.945448293647944],
                [37.791595458984375, 14.84923123791421],
            ]
        ],
    },
    start_time=datetime.now(),
    publishing_stages=["standard"],
    time_range_type="acquired",
)

request = build_request("Standard PSScene Ortho Analytic", source=source, delivery={})

# define a delivery method. In this example, we're using AWS S3.
delivery = amazon_s3(ACCESS_KEY_ID, SECRET_ACCESS_KEY, "test", "us-east-1")

# finally, create the subscription
subscription = pl.subscriptions.create_subscription(request)
```

---
title: CLI for Subscriptions API Tutorial
---

## Introduction

The `planet subscriptions` command enables interaction with the
[Subscriptions API](https://developers.planet.com/apis/subscriptions/)
that make it possible to set up a recurring search criteria. Using `planet subscriptions`, you can automatically process
and deliver new imagery to a cloud bucket. It also has a powerful 'backfill' capability
to bulk order historical imagery to your area of interest. This tutorial takes you
through the main commands available in the CLI.

## Core Workflows

### Create a Subscription

Since there is no UI to easily create subscriptions we’ll start with making a new one.

```json
{
  "name": "First Subscription",
  "source": {
    "parameters": {
      "asset_types": [
        "ortho_analytic_8b"
      ],
      "end_time": "2023-11-01T00:00:00Z",
      "geometry": {
        "coordinates": [
          [
            [
              139.5648193359375,
              35.42374884923695
            ],
            [
              140.1031494140625,
              35.42374884923695
            ],
            [
              140.1031494140625,
              35.77102915686019
            ],
            [
              139.5648193359375,
              35.77102915686019
            ],
            [
              139.5648193359375,
              35.42374884923695
            ]
          ]
        ],
        "type": "Polygon"
      },
      "item_types": [
        "PSScene"
      ],
      "start_time": "2023-03-17T04:08:00.0Z"
    }
  },
  "tools": [
    {
      "type": "clip",
      "parameters": {
        "aoi": {
          "coordinates": [
            [
              [
                139.5648193359375,
                35.42374884923695
              ],
              [
                140.1031494140625,
                35.42374884923695
              ],
              [
                140.1031494140625,
                35.77102915686019
              ],
              [
                139.5648193359375,
                35.77102915686019
              ],
              [
                139.5648193359375,
                35.42374884923695
              ]
            ]
          ],
          "type": "Polygon"
        }
      }
    }
  ],
  "delivery": {
    "type": "google_cloud_storage",
    "parameters": {
      "bucket": "pl-sub-bucket",
      "credentials": "<REDACTED>"
    }
  }
}
```

This is a full subscriptions JSON request, with the credentials redacted, so you’ll have
to replace your own for it to work. Below we’ll show the convenience methods that will
help create a custom one more easily. If you'd like to get things working for now then
just replace the 'delivery' section with your cloud credentials, see the
[core subscriptions delivery docs](https://developers.planet.com/docs/subscriptions/delivery/)
for more information.

To create a new subscription with the CLI, use the `create` command and the json file you just created:

```sh
planet subscriptions create my-subscription.json
```

**Note:** The above command assumes that you’ve saved the subscriptions JSON as `my-subscription.json` and that you’ve replaced the delivery information with your own bucket and credentials.

### List Subscriptions

Now that you’ve got a subscription working you can make use of the other commands.

```sh
planet subscriptions list
```

outputs the JSON for your first 100 subscriptions. If you'd like more you can set the `--limit`
parameter higher, or you can set it to 0 and there will be no limit.  By default the `list` command will request Subscriptions API with a page size of 500 subscriptions, and can be set lower or higher with the `--page-size` parameter.

You can get nicer formatting with `--pretty` or pipe it into `jq`, just like the other Planet
CLI’s.

#### Filtering

The `list` command supports filtering on a variety of fields:
* `--created`: Filter on the subscription creation time or an interval of creation times.
* `--end-time`: Filter on the subscription end time or an interval of end times.
* `--hosting`: Filter on subscriptions containing a hosting location (e.g. SentinelHub). Accepted values are `true` or `false`.
* `--name-contains`: Filter on subscriptions with a name that contains the provided string.
* `--name`: Filter on subscriptions with a specific name
* `--source-type`: Filter by the source type of the subscription. For the full list of available source types, see [Subscription Source Types](https://developers.planet.com/docs/subscriptions/source/#subscription-source-types). Multiple source type args are allowed.
* `--start-time`: Filter on the subscription start time or an interval of start times.
* `--status`: Filter on the status of the subscription. Status options include `running`, `cancelled`, `preparing`, `pending`, `completed`, `suspended`, and `failed`. Multiple status args are allowed.
* `--updated`: Filter on the subscription update time or an interval of updated times.

Datetime args (`--created`, `end-time`, `--start-time`, and `--updated`) can either be a date-time or an interval, open or closed. Date and time expressions adhere to RFC 3339. Open intervals are expressed using double-dots.
* A date-time: `2018-02-12T23:20:50Z`
* A closed interval: `2018-02-12T00:00:00Z/2018-03-18T12:31:12Z`
* Open intervals: `2018-02-12T00:00:00Z/..` or `../2018-03-18T12:31:12Z`

To list currently active subscriptions:
```sh
planet subscriptions list --status running
```

To list subscriptions with the `catalog` source type:
```sh
planet subscriptions list --source-type catalog
```

To list subscriptions that were created in 2024:
```sh
planet subscriptions list --created 2024-01-01T00:00:00Z/2025-01-01T00:00:00Z
```

To list subscriptions with an end time after Jan 1, 2025:
```sh
planet subscriptions list --end-time 2025-01-01T00:00:00Z/..
```

To list subscriptions with a hosting location:
```sh
planet subscriptions list --hosting true
```

#### Sorting

The `list` command also supports sorting the subscriptions on one or more fields: `name`, `created`, `updated`, `start_time`, and `end_time`. The sort direction can be specified by appending ` ASC` or ` DESC` to the field name (default is ascending).

When multiple fields are specified, the sort order is applied in the order the fields are listed.

Sorting examples:
* `--sort-by name`: sorts subscriptions by name alphabetically.
* `--sort-by "created DESC"`: sorts subscriptions by most recently created.
* `--sort-by "updated DESC"`: sorts subscriptions by most recently updated.
* `--sort-by "start_time ASC"`: sorts subscriptions by start time (earliest to latest)
* `--sort-by "end_time DESC"`: sorts subscriptions by end time (latest to earliest)
* `--sort-by "name,start_time DESC"`: sorts subscriptions by name ascending first, and start time descending second.

### Get Subscription

To get the full details on a single subscription you can take the id from your list and use the
`get` command:

```sh
planet subscriptions get cb817760-1f07-4ee7-bba6-bcac5346343f
```

### Subscription Results

To see what items have been delivered to your cloud bucket you can use the `results` command:

```sh
planet subscriptions results SUBSCRIPTION_ID
```

`SUBSCRIPTION_ID` above is a placeholder for a unique subscription identifier, which will be a UUID like `cb817760-1f07-4ee7-bba6-bcac5346343f`.

By default this displays the first 100 results. As with other commands, you can use the `--limit` param to
set a higher limit, or set it to 0 to see all results (this can be quite large with subscriptions results).

You can also filter by status:

```sh
planet subscriptions results SUBSCRIPTION_ID --status processing
```

See the Subscriptions API documentation for the [official list of available statuses](https://developers.planet.com/docs/subscriptions/#subscription-status).

#### Results as comma-separated values (CSV)

Planetary Variable subscribers can benefit from retrieving results as a CSV. The results contain variable statistics and can serve as data for time series analysis and visualization.

```sh
planet subscriptions results SUBSCRIPTION_ID --csv
```

### Update Subscription

You can update a subscription that is running, for example to change the 'tools' it’s using or to alter
its geometry. To do this you must submit the full subscription creation JSON, so the easiest way is to
get it with `get` and then alter the values.

```sh
planet subscriptions update cb817760-1f07-4ee7-bba6-bcac5346343f \
    my-updated-subscriptions.json
```

### Update Subscription Via Patch

To update a running subscription with *only* the attributes to be updated, use the `patch` method.

```sh
planet subscriptions patch cb817760-1f07-4ee7-bba6-bcac5346343f \
    patched-attributes.json
```

### Cancel Subscription

Cancelling a subscription is simple with the CLI:

```sh
planet subscriptions cancel cb817760-1f07-4ee7-bba6-bcac5346343f
```

That will stop the subscription from producing any more results, but it will stay in the system so you can
continue to list and get it.

## Subscription Request Conveniences

There are a couple of commands that can assist in creating the subscription JSON, used for creation and updates.
A subscription request is a pretty complicated command, consisting of a search, a cloud delivery, as well as
tools to process the data plus notifications on the status.

### Catalog Request

The first place to start is the `request-catalog` command, which generates all the JSON for the
[catalog source](https://developers.planet.com/docs/subscriptions/source/#catalog-source-type) block. The core
of this is quite similar to a Data API search request, though with more required fields. The minimal
required commands would be a request like:

```sh
planet subscriptions request-catalog \
    --item-types PSScene \
    --asset-types ortho_analytic_8b \
    --geometry geometry.geojson \
    --start-time 2023-03-17T04:08:00.0Z
```

You request which item types you want to deliver, and the asset types for it. Note that the `asset-types` are a bit
different than the `--bundle` command in Orders, a bundle is a set of asset-types. You can see the list of asset types
for [PSScene](https://developers.planet.com/docs/data/psscene/#available-asset-types), [SkySatCollect](https://developers.planet.com/docs/data/skysatcollect/),
and [SkySatScene](https://developers.planet.com/docs/data/skysatscene/#available-asset-types). The other item-types
also have similar listings of their asset types. For the required `start-time` and optional `end-time` you must
use dates formatted as RFC 3339 or ISO 8601 formats. A nice time converter is available at [time.lol](https://time.lol/).
Just select 'ISO 8601' (third one on the list), or 'RFC 3339' (8th on the list).

#### Geometry

In this case we are using a locally saved `geometry.geojson`, which would look like the following if you wanted
it to match the subscription creation request at the top of this documentation page:

```json
{
    "coordinates":
    [
        [
            [
                139.5648193359375,
                35.42374884923695
            ],
            [
                140.1031494140625,
                35.42374884923695
            ],
            [
                140.1031494140625,
                35.77102915686019
            ],
            [
                139.5648193359375,
                35.77102915686019
            ],
            [
                139.5648193359375,
                35.42374884923695
            ]
        ]
    ],
    "type": "Polygon"
}
```

Note this is just the coordinates of either a polygon or multipolygon - the operation
is not flexible to input like the orders command.

#### RRule

RRule lets you specify a subscription that repeats at various time intervals:

```sh
planet subscriptions request-catalog \
    --item-types PSScene \
    --asset-types ortho_analytic_8b \
    --geometry geometry.geojson \
    --start-time 2023-03-17T04:08:00.0Z \
    --rrule 'FREQ=MONTHLY;BYMONTH=3,4,5,6,7,8,9,10'
```

For more information on the `rrule` parameter see the [recurrence rules](https://developers.planet.com/docs/subscriptions/source/#rrules-recurrence-rules)
documentation.

#### Filter

You can pass in a filter from the data API:

```sh
planet data filter --range clear_percent gt 90 > filter.json
planet subscriptions request-catalog \
    --item-types PSScene \
    --asset-types ortho_analytic_8b \
    --geometry geometry.geojson \
    --start-time 2022-08-24T00:00:00-07:00 \
    --filter filter.json
```

And you can even pipe it in directly:

```sh
planet data filter --range clear_percent gt 90 \
    | planet subscriptions request-catalog \
        --item-types PSScene \
        --asset-types ortho_analytic_8b \
        --geometry geometry.geojson \
        --start-time 2022-08-24T00:00:00-07:00 \
        --filter -
```

Do not bother with geometry or date filters, as they will be ignored in favor of the `--start-time` and `--geometry` values that are required.

#### Publishing stages and time range types

By using the `--time-range-type` you can choose to temporally filter by
acquisition or publication time. The `--publishing-stage` option allows you to
receive the earliest preview imagery or wait until finalized imagery is
available. See [Catalog Source
Types:Parameters](https://developers.planet.com/docs/subscriptions/source/#parameters)
for more details.

```sh
planet subscriptions request-catalog \
    --item-types PSScene \
    --asset-types ortho_analytic_8b \
    --geometry geometry.geojson \
    --start-time 2022-08-24T00:00:00-07:00 \
    --time-range-type acquired \
    --publishing-stage finalized \
    --filter filter.json
```

*New in version 2.1*

#### Saving the output

You’ll likely want to save the output of your `request-catalog` call to disk, so that you can more easily use it in constructing the complete subscription
request.

```sh
planet data filter --range clear_percent gt 90 > filter.json
planet subscriptions request-catalog \
    --item-types PSScene \
    --asset-types ortho_analytic_8b \
    --geometry geometry.geojson \
    --start-time 2022-08-24T00:00:00-07:00 \
    --filter filter.json > request-catalog.json
```

### Planetary Variable Request

Subscribing to Planetary Variables is much like subscribing to imagery from
Planet's catalog. The `planet subscriptions request-pv` command can construct the source
part of a Planetary Variable request like `request-catalog` does for cataloged
imagery. Planetary Variable subscriptions come in 4 types and are further
subdivided within these types by an identifier. See [Subscribing to Planetary
Variables](https://developers.planet.com/docs/subscriptions/pvs-subs/#planetary-variables-types-and-ids)
for details. To constrain data delivery by space and time, you will use the
`--geometry`, `start-time`, and `end-time` options described above.

```sh
planet subscriptions request-pv \
    --var-id BIOMASS-PROXY_V3.0_10 \
    --geometry geometry.geojson \
    --start-time 2022-08-24T00:00:00-07:00 > request-pv.json
```

### Subscription Tools

Now we’ll dive into some of the tools options for subscriptions. These are quite similar to the tools for
orders, but unfortunately the syntax is subtly different, and there are less tools supported. Just like
for Orders, future of the versions of the CLI will likely add `tools` convenience methods, you can follow issue
[#601](https://github.com/planetlabs/planet-client-python/issues/601).

#### Clipping

The most used tool is the `clip` operation, which lets you pass a geometry to the
Subscriptions API and it creates new images that only have pixels within the geometry you
gave it. 99% of the time you will want to clip to the subscription geometry. The easiest way to do this is to use the `--clip-to-source` option added to the `subscriptions request` command in version 2.1.

```sh
planet subscriptions request \
    --name 'Clipped Subscription' \
    --source request-catalog.json \
    --delivery cloud-delivery.json \
    --clip-to-source
```

*New in version 2.1*


#### Additional Tools

There are some other tools that are often good to include. To use more than one tool
just put them in an array in the JSON:

The toolchain options and format are given in
[Supported Tools](https://developers.planet.com/docs/subscriptions/tools/#supported-tools)
section of the subscriptions docs:

Example: `more-tools.json`
```
[
    {
        "type": "toar",
        "parameters":
        {
            "scale_factor": 10000
        }
    },
    {
        "type": "reproject",
        "parameters":
        {
            "projection": "WGS84",
            "kernel": "cubic"
        }
    },
    {
        "type": "harmonize",
        "parameters":
        {
            "target_sensor": "Sentinel-2"
        }
    },
    {
        "type": "file_format",
        "parameters":
        {
            "format": "COG"
        }
    }
]
```

### Delivery

One other essential block is the `delivery` JSON. Like with tools there is no convenience
method, as of yet. You must write out the JSON for this section.
You can find the full documentation for the delivery options in
the [Subscriptions Delivery documentation](https://developers.planet.com/docs/subscriptions/delivery/).

An example of a delivery.json file that you would save as a file to pass into the
`subscriptions request` command is:

```json
{
    "type": "azure_blob_storage",
    "parameters":
    {
        "account": "accountname",
        "container": "containername",
        "sas_token": "sv=2017-04-17u0026si=writersr=cu0026sig=LGqc",
        "storage_endpoint_suffix": "core.windows.net"
    }
}
```

The main documentation page also has the parameters for Google Cloud, AWS and Oracle.

### Subscriptions Request

Once you’ve got all your sub-blocks of JSON saved you’re ready to make a complete subscriptions request with the `subscriptions request` command:

The above will print it nicely out so you can see the full request. You can write it out
as a file, or pipe it directly into `subscriptions create` or `subscriptions update`:

```sh
planet subscriptions request \
    --name 'First Subscription' \
    --source request-catalog.json \
    --tools tools.json \
    --delivery cloud-delivery.json \
    | planet subscriptions create -
```

#### Sentinel Hub Hosting

When creating a new subscription, you can include hosting options directly using the --hosting, --collection-id, and --create-configuration flags.

- The --hosting option is optional and currently supports sentinel_hub as its only value.
- The --collection-id is also optional. If you decide to use this, ensure that the subscription request and the collection have matching bands. If you're unsure, allow the system to create a new collection for you by omitting the --collection-id option. This will ensure the newly set-up collection is configured correctly, and you can subsequently add items to this collection as needed.
- The --create_configuration option will create a new [layer configuration](https://apps.sentinel-hub.com/dashboard/#/configurations) in Sentinel Hub on your behalf. This option cannot be used with --collection-id.
- You may also input --hosting as a JSON file. The file should be formatted:

```sh
planet subscriptions request \
    --name 'First Subscription' \
    --source request-catalog.json \
    --tools tools.json \
    --hosting sentinel_hub \
    | planet subscriptions create -
```

For more information on Sentinel Hub hosting, see the [Subscriptions API documentation](https://developers.planet.com/docs/subscriptions/delivery/#delivery-to-sentinel-hub-collection) and the [Linking Planet User to Sentinel Hub User
](https://support.planet.com/hc/en-us/articles/16550358397469-Linking-Planet-User-to-Sentinel-Hub-User) support post.


#### Summaries

You can get two types of summaries using the CLI.

The first is a summary of all subscriptions created by the user, totaled by status.
```sh
planet subscriptions summarize
```

The second is a summary of _results_ for a specified subscription, totaled by status.
```sh
planet subscriptions summarize --subscription-id=cb817760-1f07-4ee7-bba6-bcac5346343f
```

# _ReadTheDocs.io_ Content Management

## Overview
Pursuant to the [Content Plan](./content-plan.md) developed as part of the
v2.0 release of the SDK, [_ReadTheDocs.io_](https://planet-sdk-for-python.readthedocs.io/)
is used to host the single source of truth for SDK documentation.  SDK documentation
is largely confined to the specifics of using the SDK.  More general Planet Platform
narrative and HTTP API documentation should be hosted on the Planet documentation site
at [docs.planet.com](https://docs.planet.com/).

## Version Management
_ReadTheDocs.io_ hosts multiple versions of the documentation simultaneously.
All versions of the documentation will be published under a _ReadTheDocs.io_
URL that explicitly includes the SDK version so that PyPi published packages
will always have corresponding _ReadTheDocs.io_ documentation for users.

Additionally, the following symbolic names are maintained:
* [**default**](https://planet-sdk-for-python.readthedocs.io/) - Should point to same version as `stable`.
* [**stable**](https://planet-sdk-for-python.readthedocs.io/en/stable/) - Should point to the highest stable release version.
* [**latest**](https://planet-sdk-for-python.readthedocs.io/en/latest/) - Should point to the most recent build from the current mainline major version branch.

Version management is handled by _ReadTheDocs.io_ [automation rules](https://app.readthedocs.org/dashboard/planet-sdk-for-python/rules/).

## _ReadTheDocs.io_ Planet PBC Account
Planet currently publishes to _ReadTheDocs.io_ as a [community](https://about.readthedocs.com/pricing/#/community)
project.  It is understood that this means that ads may be displayed on hosted documentation.  (Ref: cleared
with Planet Engineering Management in April 2025.)

----

# Version Release

*Planet maintainers only*

Releasing is a two-step process: (1) releasing on GitHub and test.pypi and (2) releasing to PyPI. Releasing on GitHub will automatically trigger a release on test.pypi via a GitHub Action. Following manual confirmation of a successful and satisfactory release on test.pypi, release on PyPI is triggered manually with the Github Action `Autopublish to TestPyPI`. There is also an option to publish to test.pypi and PyPI from your local machine.

NOTE: the version is detected from git using the tag name. There is no need to modify a version file.

If the repository is not on tag, the version will be computed using the default versioning scheme of [setuptools_scm](https://setuptools-scm.readthedocs.io/en/latest/usage/#default-versioning-scheme).

## Versions and Stability

The SDK follows [Semantic Versioning](https://semver.org/spec/v2.0.0.html) and therefore only major releases should break compatibility. Minor versions may include new functionality and patch versions address bugs or trivial changes (like documentation).

## Release Workflow

1. Create a new GitHub release:
   * From the GitHub UI:
     * Navigate to the [releases UI](https://github.com/planetlabs/planet-client-python/releases), and select "Draft a new release".
     * Choose or create a tag for the release version.  The is expected to simply be the [PEP 440](https://peps.python.org/pep-0440/)
       compliant semantic version number, without any prefix or other adornments.  Examples, from most to least mature:
       * Production release: `2.3.4`
       * Release candidate: `2.3.4rc1`
       * Beta release: `2.3.4b1`
       * Alpha release: `2.3.4a1`
       * Alpha development pre-release build: `2.3.4a1.dev1`
     * Set target the release branch.  This should normally be `main` for production releases.
     * Set title to tag release version
     * Describe the change(s) that are shipping with this version in the release description
   * Alternatively, create a release from the GitHub CLI:
     * Make sure the pre-requisite [gh](https://cli.github.com/manual/gh) CLI is installed, and optionally review the docs for CLI command [gh release create](https://cli.github.com/manual/gh_release_create)
     * By default, `gh release create` will automatically tag releases from the latest state of the default branch
     * Run CLI command `gh release create {VERSION} --notes "{RELEASE NOTES}"` where `VERSION` is the release version and `RELEASE NOTES` is the description of changes
2. Verify the successful run of the Github Action [`Autopublish to TestPyPI`](https://github.com/planetlabs/planet-client-python/actions/workflows/autopublish-testpypi.yml) and validate the test release on [test.pypi.org](https://test.pypi.org/project/planet/)
3. Run the Github Action [`Publish on PyPI`](https://github.com/planetlabs/planet-client-python/actions/workflows/publish-pypi.yml)
4. Verify the successful run of the Github Action `Publish on PyPI` and validate the release on [pypi.org](https://pypi.org/project/planet/)
5. Verify the successful and correct publishing of documentation to Read the Docs.
   Read the Docs publishing should be triggered automatically by Github
   [project webhooks](https://github.com/planetlabs/planet-client-python/settings/hooks).
   Correct publishing includes verifying that the `default`, `stable`, and `latest`
   versions of the documentation point to the correct versions, and that the version
   specific documentation URL also works as expected.  The management of these
   symbolic documentation versions is handled by Read the Docs
   [automation rules](https://app.readthedocs.org/dashboard/planet-sdk-for-python/rules/).
   * Published to [planet-sdk-for-python](https://planet-sdk-for-python.readthedocs.io/en/latest/) (Note the new version-less project slug in DNS name).
     * _`default`_: [https://planet-sdk-for-python.readthedocs.io/](https://planet-sdk-for-python.readthedocs.io/) - Should point to same version as `stable`.
     * `stable`: [https://planet-sdk-for-python.readthedocs.io/en/stable/](https://planet-sdk-for-python.readthedocs.io/en/stable/) - Should point to the highest stable release version.
     * `latest`: [https://planet-sdk-for-python.readthedocs.io/en/latest/](https://planet-sdk-for-python.readthedocs.io/en/latest/) - Should point to the most recent build from `main`.
     * _`version`_: [https://planet-sdk-for-python.readthedocs.io/en/X.YY.ZZ/](https://planet-sdk-for-python.readthedocs.io/en/X.YY.Z/) - Should point to version `X.YY.ZZ`.
   * Published to [planet-sdk-for-python-v2](https://planet-sdk-for-python-v2.readthedocs.io/en/latest/) (Note the older "v2" in the project slug in the DNS name).
     * _`default`_: [https://planet-sdk-for-python-v2.readthedocs.io/](https://planet-sdk-for-python-v2.readthedocs.io/) - Should point to same version as `stable`.
     * `stable`: [https://planet-sdk-for-python-v2.readthedocs.io/en/stable/](https://planet-sdk-for-python-v2.readthedocs.io/en/stable/) - Should point to the highest stable release version.
     * `latest`: [https://planet-sdk-for-python-v2.readthedocs.io/en/latest/](https://planet-sdk-for-python-v2.readthedocs.io/en/latest/) - Should point to the most recent build from `main`.
     * _`version`_: [https://planet-sdk-for-python-v2.readthedocs.io/en/X.YY.ZZ/](https://planet-sdk-for-python-v2.readthedocs.io/en/X.YY.ZZ/) - Should point to version `X.YY.ZZ`.
   * Pre-release versions should _not_ impact the default version of the documentation. Pre-release version may be published as the `latest` version.

## Local publishing

Publishing to testpypi and pypi can also be performed locally with:

```console
  $ nox -s build publish-testpypi
```
then
```console
  $ nox -s publish-pypi
```

This approach requires specifying the pypi/testpypi api token as the password at the prompt.


## Conda builds

When stable, not pre-release, files are uploaded to PyPI, a bot will detect them and make an automated PR to https://github.com/conda-forge/planet-feedstock/pulls. When a Conda-forge maintainer merges that PR, a package will be built for the new version and will be published to https://anaconda.org/conda-forge/planet/files.

# Authentication SDK Guide

For general information on how to authenticate to Planet APIs, see the
[Authentication](https://docs.planet.com/develop/authentication/) section of Planet's
Insights Platform documentation.

See [Client Authentication Overview](../../auth/auth-overview) for an overview
of authentication to the Planet Insights Platform that is geared towards SDK
users, and includes a discussion of authentication protocols that are under
construction and available for early access to SDK users.

[Authentication with the SDK](../../auth/auth-sdk) provides a primer
on how to use the Planet SDK for Python to authenticate to Planet APIs.

----

# Client Authentication Overview

## Introduction
All calls to Planet APIs must be authenticated.  Only authorized clients may
use Planet Platform APIs.

For general information on how to authenticate to Planet APIs, please see
the [Authentication](https://docs.planet.com/develop/authentication/) section of Planet's platform documentation.
This documentation focuses on the use of the Planet Python SDK and
[`planet`](../../cli/cli-reference) CLI.

!!! info
    Work to unify authentication practices between `api.planet.com` and `services.sentinel-hub.com`
    is ongoing and being rolled out in phases over time. Documentation referring
    to work in progress is marked as such 🚧.

    Of particular note is the general shift towards OAuth2 based authentication,
    and a corresponding move away from Planet API keys.

----

## Authentication Protocols
At the HTTP protocol level underneath the SDK, there are several distinct
ways a client may authenticate to the Planet APIs, depending on the use case.
See [Authentication Protocols](https://docs.planet.com/develop/authentication/#authentication-protocols) for a
complete discussion of when to choose a particular method.

* **OAuth2 user access tokens** - API access as the end-user, using OAuth2
    user access tokens.  This is the preferred way for user-interactive
    applications to authenticate to Planet APIs.  A registered client application
    and a web browser are required to initialize a session. A web browser is not
    required for continued operation.  The SDK itself is a registered
    client application that may be used for this purpose.

    Examples of applications that fall into this category include
    [ArcGIS Pro](https://www.esri.com/en-us/arcgis/products/arcgis-pro/overview),
    [QGIS](https://qgis.org/), and the SDK's own [`planet`](../../cli/cli-reference)
    CLI program.  All Planet first-party web applications also use this method.

* **OAuth2 M2M access tokens** (🚧 _Work in progress_) - API access as a service user, using OAuth2
    M2M access tokens.  This is the new preferred way for automated processes
    to authenticate to Planet APIs that must operate without a human user.
    No web browser is required, but this method carries some additional
    security considerations.

* **Planet API keys** (⚠️ _Pending future deprecation_) - API access as a Planet end-user using a simple
    fixed string bearer key.  This is the method that has historically been
    documented and recommended for developers using Planet APIs.

### OAuth2
OAuth2 authentication requires that the client possess an access token
in order to make API calls. Access tokens are obtained by the client from
the Planet authorization server, which is separate from the API servers, and are
presented by the client to API services to assert the client's right to make
API calls.

Unlike Planet API keys, access tokens do not last forever for a variety of
reasons and must be regularly refreshed by the client before their expiration.
When using the Planet SDK, many of the details of obtaining and refreshing
OAuth2 access tokens will be taken care of for you.

OAuth2 defines many different ways to obtain access tokens, and a full discussion
is beyond the scope of this SDK user guide.  Please refer to the [Resources](#resources)
below for more information.  Planet broadly divides OAuth2 use cases into
user-interactive and machine-to-machine use cases, as described in this guide.

**SDK Examples:**

* **OAuth2 user access tokens**
    * [Using the CLI (Quick start)](../auth-dev-cli-managed/#planet-auth-login-planet-user)
    * [Forcing use of SDK Built-in Application ID in code (Quick start)](../auth-dev-cli-managed/#use-cli-session-force-builtin)
    * [Using a custom registered application ID](../auth-dev-app-managed-oauth/#oauth2-session-for-users)
* **OAuth2 M2M access tokens**
    * [Using the CLI (Quick start)](../auth-dev-cli-managed/#planet-auth-login-planet-m2m)
    * [Using a M2M Access Token in code](../auth-dev-app-managed-oauth/#oauth2-session-for-service-accounts)

!!! info
    OAuth2 user access tokens currently work for all Planet APIs under both
    the `api.planet.com` and `services.sentinel-hub.com` domains.

    🚧 OAuth2 machine-to-machine (M2M) access tokens are currently available for use
    with `services.sentinel-hub.com` APIs. Work to support `api.planet.com` is
    ongoing.  It should also be noted that at this time no API clients for
    `services.sentinel-hub.com` APIs have been incorporated into this SDK.
    The SDK may still be used to obtain and manage M2M access tokens to
    support external applications.

### Planet API Keys
Planet API keys are simple fixed strings that may be presented by the client
to API services to assert the client's right to access APIs.  API keys are
obtained by the user from their [Account](https://www.planet.com/account) page
under the [_My Settings_](https://www.planet.com/account/#/user-settings) tab.

**SDK Examples:**

* **Planet API keys**
     * [Using the CLI (Quick start)](../auth-dev-cli-managed/#planet-auth-login-planet-apikey)
     * [Using a Planet API Key in code](../auth-dev-app-managed-apikey)


!!! warning
    Planet API keys are being targeted for eventual deprecation in favor
    of OAuth2 mechanisms for most use cases. No specific timeframe has been
    set for disabling API keys, but new development should use OAuth2
    mechanisms where possible.

    Planet API keys will work for Planet APIs underneath `api.planet.com`, but
    will **NOT** work for APIs underneath `services.sentinel-hub.com`.

    There is no plan for API keys to ever be supported by APIs underneath
    `services.sentinel-hub.com`.

----

## Resources
More information regarding Authentication to Planet APIs, OAuth2, and JWTs
may be found here:

* [Planet Authentication](https://docs.planet.com/develop/authentication/)
* [RFC 6749 - The OAuth 2.0 Authorization Framework](https://datatracker.ietf.org/doc/html/rfc6749)
* [RFC 8628 - OAuth 2.0 Device Authorization Grant](https://datatracker.ietf.org/doc/html/rfc8628)
* [RFC 7519 - JSON Web Token (JWT)](https://datatracker.ietf.org/doc/html/rfc7519)
* [RFC 9068 - JSON Web Token (JWT) Profile for OAuth 2.0 Access Tokens](https://datatracker.ietf.org/doc/html/rfc9068)
* [RFC 6819 - OAuth 2.0 Threat Model and Security Considerations](https://datatracker.ietf.org/doc/html/rfc6819)

----

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{ageCpGs}
\alias{ageCpGs}
\title{Placental gestational age CpGs}
\format{
A \link[tibble:tibble-package]{tibble} with coefficients for the RPC,
CPC, and refined RPC.
}
\usage{
data(ageCpGs)
}
\description{
Coefficients from the three placental gestational age clocks
from \href{https://pubmed.ncbi.nlm.nih.gov/31235674/}{Lee Y et al. 2019}.

Reference: Lee Y, Choufani S, Weksberg R, et al. Placental epigenetic
clocks: estimating gestational age using placental DNA methylation levels.
Aging (Albany NY). 2019;11(12):4238–4253. doi:10.18632/aging.102049. PMID:
31235674
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{plColors}
\alias{plColors}
\title{A color palette for placental cell types}
\format{
An object of class \code{character} of length 6.
}
\usage{
data(plColors)
}
\description{
A nice color palette for placental cell types.

Used in \url{Yuan V et al. 2020}.

Contains colors for:
\itemize{
\item Syncytiotrophoblast
\item Trophoblast
\item Stromal
\item Hofbauer
\item Endothelial
\item nRBCs
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/predict_mixOmics.R
\name{predict}
\alias{predict}
\alias{predict.mixo_pls}
\alias{predict.mixo_spls}
\title{predict mixxo from}
\usage{
\method{predict}{mixo_pls}(
  object,
  newdata,
  study.test,
  dist = c("all", "max.dist", "centroids.dist", "mahalanobis.dist"),
  multilevel = NULL,
  ...
)

\method{predict}{mixo_spls}(
  object,
  newdata,
  study.test,
  dist = c("all", "max.dist", "centroids.dist", "mahalanobis.dist"),
  multilevel = NULL,
  ...
)
}
\arguments{
\item{object}{object of class inheriting from
\code{"(mint).(block).(s)pls(da)"}.}

\item{newdata}{data matrix in which to look for for explanatory variables to
be used for prediction. Please note that this method does not perform
multilevel decomposition or log ratio transformations, which need to be
processed beforehand.}

\item{study.test}{For MINT objects, grouping factor indicating which samples
of \code{newdata} are from the same study. Overlap with \code{object$study}
are allowed.}

\item{dist}{distance to be applied for discriminant methods to predict the
class of new data, should be a subset of \code{"centroids.dist"},
\code{"mahalanobis.dist"} or \code{"max.dist"} (see Details). Defaults to
\code{"all"}.}

\item{multilevel}{Design matrix for multilevel analysis (for repeated
measurements). A numeric matrix or data frame. For a one level factor
decomposition, the input is a vector indicating the repeated measures on
each individual, i.e. the individuals ID. For a two level decomposition with
splsda models, the two factors are included in Y. Finally for a two level
decomposition with spls models, 2nd AND 3rd columns in design indicate those
factors (see example in \code{?splsda} and \code{?spls}).}

\item{...}{not used currently.}
}
\value{
\code{predict} produces a list with the following components:
\item{predict}{predicted response values. The dimensions correspond to the
observations, the response variables and the model dimension, respectively.
For a supervised model, it corresponds to the predicted dummy variables.}
\item{variates}{matrix of predicted variates.} \item{B.hat}{matrix of
regression coefficients (without the intercept).}

\item{AveragedPredict}{if more than one block, returns the average predicted
values over the blocks (using the \code{predict} output)}
\item{WeightedPredict}{if more than one block, returns the weighted average
of the predicted values over the blocks (using the \code{predict} and
\code{weights} outputs)}

\item{class}{predicted class of \code{newdata} for each
\eqn{1,...,}\code{ncomp} components.}

\item{MajorityVote}{if more than one block, returns the majority class over
the blocks. NA for a sample means that there is no consensus on the
predicted class for this particular sample over the blocks.}
\item{WeightedVote}{if more than one block, returns the weighted majority
class over the blocks. NA for a sample means that there is no consensus on
the predicted class for this particular sample over the blocks.}
\item{weights}{Returns the weights of each block used for the weighted
predictions, for each nrepeat and each fold}

\item{centroids}{matrix of coordinates for centroids.} \item{dist}{type of
distance requested.} \item{vote}{majority vote result for multi block
analysis (see details above).}
}
\description{
copied from mixOmicsTeam/mixOmics/refs/heads/master/R/predict.R
on 2025 Jan 30. Some components omitted that are not used in planet.
}
\examples{
# example code

}
\references{
Rohart F, Gautier B, Singh A, Lê Cao K-A. mixOmics: an R package for 'omics
feature selection and multiple data integration. PLoS Comput Biol 13(11):
e1005752

Tenenhaus, M. (1998). \emph{La regression PLS: theorie et pratique}. Paris:
Editions Technic.
}
\seealso{
http://www.mixOmics.org for more details.
}
\author{
Florian Rohart, Sébastien Déjean, Ignacio González, Kim-Anh Lê Cao,
Al J Abadi
}
\keyword{multivariate}
\keyword{regression}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/predictAge.R
\name{predictAge}
\alias{predictAge}
\title{Predicts gestational age using placental DNA methylation microarray
data}
\usage{
predictAge(betas, type = "RPC")
}
\arguments{
\item{betas}{An n by m dataframe of methylation values on the beta scale (0,
1), where the CpGs are arranged in rows, and samples in columns. Should
contain all CpGs used in each clock}

\item{type}{One of the following: "RPC" (Robust), "CPC", (Control) or "RRPC"
(Refined Robust).}
}
\value{
A vector of length \code{m}, containing inferred gestational age.
}
\description{
\code{predictAge} Multiplies the coefficients from one of three
epigenetic gestational age clocks, by the corresponding CpGs in a supplied
betas \code{data.frame}.
}
\details{
Predicts gestational age using one of 3 placental gestational age
clocks: RPC, CPC, or refined RPC. Requires placental DNA methylation measured
on the Infinium 27K/450k/EPIC methylation array. Ensure as many predictive
CpGs are present in your data, otherwise accuracy may be impacted.

It's recommended that you have all predictive CpGs, otherwise accuracy may
vary.
}
\examples{

# Load placenta DNAm data
library(dplyr)
data(plBetas)
data(plPhenoData)

plPhenoData \%>\%
    mutate(inferred_ga = predictAge(plBetas, type = "RPC"))
    
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/predictPreeclampsia.R
\name{predictPreeclampsia}
\alias{predictPreeclampsia}
\title{predictPreeclampsia}
\usage{
predictPreeclampsia(betas, ...)
}
\arguments{
\item{betas}{matrix or array of methylation values on the beta scale (0, 1),
where the variables are arranged in rows, and samples in columns.}

\item{...}{feeds into outersect function}
}
\value{
produces a list with components detailed in the \code{mixOmics::predict} R documentation
}
\description{
Uses 45 CpGs to predict early preeclampsia (PE delivered before or at 34 weeks of gestation)
on placental DNA methylation microarray data.
}
\details{
Assigns the class labels "early-PE" or "normotensive" to each sample
and returns a class probability.
}
\section{It is recommended that users apply beta-mixture quantile normalization (BMIQ) to their data}{
prior to prediction. This was the normalization method used on the training data.
}

\examples{

# To predict early preeclampsia on 450k/850k samples

# Load data
library(ExperimentHub)
eh <- ExperimentHub()
query(eh, "eoPredData")

# test object
x_test <- eh[['EH8403']]
x_test \%>\% predictPreeclampsia()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/predictEthnicity.R
\name{predictEthnicity}
\alias{predictEthnicity}
\title{Predicts ethnicity using placental DNA methylation microarray data}
\usage{
predictEthnicity(betas, threshold = 0.75, force = FALSE)
}
\arguments{
\item{betas}{n x m dataframe of methylation values on the beta scale (0, 1),
where the variables are arranged in rows, and samples in columns. Should
contain all 1860 predictors and be normalized with NOOB and BMIQ.}

\item{threshold}{A probability threshold ranging from (0, 1) to call samples
'ambiguous'. Defaults to 0.75.}

\item{force}{run even if missing predictors. Default is \code{FALSE}.}
}
\value{
a \link[tibble:tibble-package]{tibble}
}
\description{
Uses 1860 CpGs to predict self-reported ethnicity on placental
microarray data.
}
\details{
Predicts self-reported ethnicity from 3 classes: Africans, Asians,
and Caucasians, using placental DNA methylation data measured on the Infinium
450k/EPIC methylation array. Will return membership probabilities that often
reflect genetic ancestry composition.

The input data should contain all 1860 predictors (cpgs) of the final GLMNET
model.

It's recommended to use the same normalization methods used on the training
data: NOOB and BMIQ.
}
\examples{
## To predict ethnicity on 450k/850k samples

# Load placenta DNAm data
data(plBetas)
predictEthnicity(plBetas)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{ethnicityCpGs}
\alias{ethnicityCpGs}
\title{CpGs to predict ethnicity}
\format{
A character vector of length 1860
}
\source{
\url{https://pubmed.ncbi.nlm.nih.gov/31399127/}
}
\usage{
data(ethnicityCpGs)
}
\description{
1860 CpGs used to predict ethnicity.

See \href{https://pubmed.ncbi.nlm.nih.gov/31399127/}{Yuan et al. 2019} for
details.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{plBetas}
\alias{plBetas}
\title{Example placental DNA methylation data}
\format{
A matrix
}
\source{
\url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE75196}
}
\usage{
data(plBetas)
}
\description{
6 DNA methylation profiles from preeclampsia and healthy
control placentas. This data was downloaded from:
\itemize{
\item \href{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE75196}{GSE75196}
}

"Genome wide DNA methylation profiling of normal and
preeclampsia placental samples. Illumina Infinium HumanMethylation450
BeadChip (450K array) was used to obtain DNA methylation profiles in
placental samples. Samples included 16 samples from healthy uncomplicated
pregnancies and 8 samples from pregnancies affected by preeclampsia." -
from \href{https://pubmed.ncbi.nlm.nih.gov/26968548/}{Yeung et al.}

The DNA methylation data for 24 placental samples were downloaded from
\href{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE75196}{GSE75196}.
After normalizing using \code{minfi::preprocessNoob} and \code{wateRmelon::BMIQ},
the data were filtered to 6/24 samples and 10,000 random CpGs + those CpGs
used in the gestational age clock and ethnicity classifier.

Reference: Yeung KR, Chiu CL, Pidsley R, Makris A et al. DNA methylation
profiles in preeclampsia and healthy control placentas. Am J Physiol Heart
Circ Physiol 2016 May 15;310(10):H1295-303.
\href{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE75196}{PMID:26968548}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{plCellCpGsFirst}
\alias{plCellCpGsFirst}
\title{First trimester placental cell type coefficients}
\format{
A \link{matrix} with coefficients for Trophoblasts, Stromal,
Endothelial, Hofbauer cells, nRBCs, and Syncytiotrophoblasts.
}
\usage{
data(plCellCpGsFirst)
}
\description{
First trimester coefficients for placental cellular
deconvolution from \url{Yuan V et al. 2020}.

Reference: to be edited
PMID: to be edited
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{plPhenoData}
\alias{plPhenoData}
\title{Sample information accompanying \code{pl_betas}}
\format{
A \link[tibble:tibble-package]{tibble}
}
\source{
\url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE75196}
}
\usage{
data(plPhenoData)
}
\description{
Sex, disease, and gestational age information associated with
\code{pl_betas}.

Downloaded from the GEO accession:
\itemize{
\item \href{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE75196}{GSE75196}
}

Reference: Yeung KR, Chiu CL, Pidsley R, Makris A et al. DNA methylation
profiles in preeclampsia and healthy control placentas. Am J Physiol Heart
Circ Physiol 2016 May 15;310(10):H1295-303.
\href{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE75196}{PMID: 26968548}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/planet-package.R
\docType{package}
\name{planet-package}
\alias{planet}
\alias{planet-package}
\title{planet: Placental DNA methylation analysis tools}
\description{
\if{html}{\figure{logo.png}{options: style='float: right' alt='logo' width='120'}}

This package contains R functions to predict biological variables to from placnetal DNA methylation data generated from infinium arrays. This includes inferring ethnicity/ancestry, gestational age, and cell composition from placental DNA methylation array (450k/850k) data.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://victor.rbind.io/planet}
  \item \url{http://github.com/wvictor14/planet}
  \item Report bugs at \url{http://github.com/wvictor14/planet/issues}
}

}
\author{
\strong{Maintainer}: Victor Yuan \email{victor.2wy@gmail.com}

Authors:
\itemize{
  \item Wendy P. Robinson [contributor]
  \item Icíar Fernández-Boyano \email{iciarfernandez@outlook.com} [contributor]
}

}
\keyword{internal}
